UPGRADE FROM 2.2 to 2.3
========================

Table of Contents
-----------------

- [General](#general)
- [Action](#action)
- [ActionBundle](#actionbundle)
- [ActivityBundle](#activitybundle)
- [ActivityListBundle](#activitylistbundle)
- [ApiBundle](#apibundle)
- [AttachmentBundle](#attachmentbundle)
- [CommentBundle](#commentbundle)
- [ConfigBundle](#configbundle)
- [CronBundle](#cronbundle)
- [DashboardBundle](#dashboardbundle)
- [DataAuditBundle](#dataauditbundle)
- [DataGridBundle](#datagridbundle)
- [DistributionBundle](#distributionbundle)
- [DoctrineUtils](#doctrineutils)
- [EmailBundle](#emailbundle)
- [EntityBundle](#entitybundle)
- [EntityConfigBundle](#entityconfigbundle)
- [EntityExtendBundle](#entityextendbundle)
- [EntityPaginationBundle](#entitypaginationbundle)
- [FilterBundle](#filterbundle)
- [FormBundle](#formbundle)
- [ImapBundle](#imapbundle)****
- [ImportExportBundle](#importexportbundle)
- [InstallerBundle](#installerbundle)
- [IntegrationBundle](#integrationbundle)
- [MigrationBundle](#migrationbundle)
- [NavigationBundle](#navigationbundle)
- [NoteBundle](#notebundle)
- [NotificationBundle](#notificationbundle)
- [OrganizationBundle](#organizationbundle)
- [PhpUtils](#phputils)
- [ReportBundle](#reportbundle)
- [SearchBundle](#searchbundle)
- [SecurityBundle](#securitybundle)
- [SegmentBundle](#segmentbundle)
- [SyncBundle](#syncbundle)
- [TagBundle](#tagbundle)
- [TestGeneratorBundle](#testgeneratorbundle)
- [TranslationBundle](#translationbundle)
- [UIBundle](#uibundle)
- [UserBundle](#userbundle)
- [WorkflowBundle](#workflowbundle)

General
-------

### Important

The class `Oro\Bundle\SecurityBundle\SecurityFacade`, services `oro_security.security_facade` and `oro_security.security_facade.link`, and TWIG function `resource_granted` were marked as deprecated.
Use services `security.authorization_checker`, `security.token_storage`, `oro_security.token_accessor`, `oro_security.class_authorization_checker`, `oro_security.request_authorization_checker` and TWIG function `is_granted` instead.
In controllers use `isGranted` method from `Symfony\Bundle\FrameworkBundle\Controller\Controller`.
The usage of deprecated service `security.context` (interface `Symfony\Component\Security\Core\SecurityContextInterface`) was removed as well.
All existing classes were updated to use new services instead of the `SecurityFacade` and `SecurityContext`:

* service `security.authorization_checker`
    - implements `Symfony\Component\Security\Core\Authorization\AuthorizationCheckerInterface`
    - the property name in classes that use this service is `authorizationChecker`
* service `security.token_storage`
    - implements `Symfony\Component\Security\Core\Authentication\Token\Storage\TokenStorageInterface`
    - the property name in classes that use this service is `tokenStorage`
* service `oro_security.token_accessor`
    - implements `Oro\Bundle\SecurityBundle\Authentication\TokenAccessorInterface`
    - the property name in classes that use this service is `tokenAccessor`
* service `oro_security.class_authorization_checker`
    - implements `Oro\Bundle\SecurityBundle\Authorization\ClassAuthorizationChecker`
    - the property name in classes that use this service is `classAuthorizationChecker`
* service `oro_security.request_authorization_checker`
    - implements `Oro\Bundle\SecurityBundle\Authorization\RequestAuthorizationChecker`
    - the property name in classes that use this service is `requestAuthorizationChecker`

Action
------
* The `AbstractDateAction::createDateTime()`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Component/Action/Action/AbstractDateAction.php#L27 "Oro\Component\Action\Action\AbstractDateAction")</sup> method was changed to `AbstractDateAction::createDateTime($context)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Component/Action/Action/AbstractDateAction.php#L28 "Oro\Component\Action\Action\AbstractDateAction")</sup>
* The `CreateDateTime::createDateTime()`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Component/Action/Action/CreateDateTime.php#L12 "Oro\Component\Action\Action\CreateDateTime")</sup> method was changed to `CreateDateTime::createDateTime($context)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Component/Action/Action/CreateDateTime.php#L15 "Oro\Component\Action\Action\CreateDateTime")</sup>
* The `AssignActiveUser::__construct(ContextAccessor $contextAccessor, SecurityContextInterface $securityContext)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Component/Action/Action/AssignActiveUser.php#L28 "Oro\Component\Action\Action\AssignActiveUser")</sup> method was changed to `AssignActiveUser::__construct(ContextAccessor $contextAccessor, TokenStorageInterface $tokenStorage)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Component/Action/Action/AssignActiveUser.php#L24 "Oro\Component\Action\Action\AssignActiveUser")</sup>
* The `AssignActiveUser::$securityContext`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Component/Action/Action/AssignActiveUser.php#L17 "Oro\Component\Action\Action\AssignActiveUser::$securityContext")</sup> property was removed.

ActionBundle
------------
* The `CreateDate::createDateTime()`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/ActionBundle/Action/CreateDate.php#L32 "Oro\Bundle\ActionBundle\Action\CreateDate")</sup> method was changed to `CreateDate::createDateTime($context)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/ActionBundle/Action/CreateDate.php#L33 "Oro\Bundle\ActionBundle\Action\CreateDate")</sup>

ActivityBundle
--------------
* The `ActivityWidgetProvider::__construct(ActivityManager $activityManager, SecurityFacade $securityFacade, TranslatorInterface $translator, EntityIdAccessor $entityIdAccessor, EntityRoutingHelper $entityRoutingHelper)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/ActivityBundle/Provider/ActivityWidgetProvider.php#L40 "Oro\Bundle\ActivityBundle\Provider\ActivityWidgetProvider")</sup> method was changed to `ActivityWidgetProvider::__construct(ActivityManager $activityManager, AuthorizationCheckerInterface $authorizationChecker, TranslatorInterface $translator, EntityIdAccessor $entityIdAccessor, EntityRoutingHelper $entityRoutingHelper)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/ActivityBundle/Provider/ActivityWidgetProvider.php#L40 "Oro\Bundle\ActivityBundle\Provider\ActivityWidgetProvider")</sup>
* The `ActivityEntityApiHandler::__construct(FormInterface $form, Request $request, ObjectManager $entityManager, ActivityManager $activityManager, SecurityFacade $securityFacade)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/ActivityBundle/Form/Handler/ActivityEntityApiHandler.php#L32 "Oro\Bundle\ActivityBundle\Form\Handler\ActivityEntityApiHandler")</sup> method was changed to `ActivityEntityApiHandler::__construct(FormInterface $form, Request $request, ObjectManager $entityManager, ActivityManager $activityManager, AuthorizationCheckerInterface $authorizationChecker)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/ActivityBundle/Form/Handler/ActivityEntityApiHandler.php#L32 "Oro\Bundle\ActivityBundle\Form\Handler\ActivityEntityApiHandler")</sup>
* The `ActivityWidgetProvider::$securityFacade`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/ActivityBundle/Provider/ActivityWidgetProvider.php#L22 "Oro\Bundle\ActivityBundle\Provider\ActivityWidgetProvider::$securityFacade")</sup> property was removed.
* The `ActivityEntityApiHandler::$securityFacade`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/ActivityBundle/Form/Handler/ActivityEntityApiHandler.php#L23 "Oro\Bundle\ActivityBundle\Form\Handler\ActivityEntityApiHandler::$securityFacade")</sup> property was removed.
* The `ActivityEntityDeleteHandler::$securityFacade`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/ActivityBundle/Entity/Manager/ActivityEntityDeleteHandler.php#L19 "Oro\Bundle\ActivityBundle\Entity\Manager\ActivityEntityDeleteHandler::$securityFacade")</sup> property was removed.
* The `ActivityEntityDeleteHandler::setSecurityFacade`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/ActivityBundle/Entity/Manager/ActivityEntityDeleteHandler.php#L27 "Oro\Bundle\ActivityBundle\Entity\Manager\ActivityEntityDeleteHandler::setSecurityFacade")</sup> method was removed.

ActivityListBundle
------------------
* The `ActivityListAclCriteriaHelper::__construct(AclHelper $aclHelper, ServiceLink $securityContextLink)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/ActivityListBundle/Helper/ActivityListAclCriteriaHelper.php#L29 "Oro\Bundle\ActivityListBundle\Helper\ActivityListAclCriteriaHelper")</sup> method was changed to `ActivityListAclCriteriaHelper::__construct(AclHelper $aclHelper, AuthorizationCheckerInterface $authorizationChecker)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/ActivityListBundle/Helper/ActivityListAclCriteriaHelper.php#L26 "Oro\Bundle\ActivityListBundle\Helper\ActivityListAclCriteriaHelper")</sup>
* The `ActivityListManager::__construct(SecurityFacade $securityFacade, EntityNameResolver $entityNameResolver, ConfigManager $config, ActivityListChainProvider $provider, ActivityListFilterHelper $activityListFilterHelper, CommentApiManager $commentManager, DoctrineHelper $doctrineHelper, ActivityListAclCriteriaHelper $aclHelper, ActivityInheritanceTargetsHelper $activityInheritanceTargetsHelper, EventDispatcherInterface $eventDispatcher, WorkflowDataHelper $workflowHelper)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/ActivityListBundle/Entity/Manager/ActivityListManager.php#L83 "Oro\Bundle\ActivityListBundle\Entity\Manager\ActivityListManager")</sup> method was changed to `ActivityListManager::__construct(AuthorizationCheckerInterface $authorizationChecker, EntityNameResolver $entityNameResolver, ConfigManager $config, ActivityListChainProvider $provider, ActivityListFilterHelper $activityListFilterHelper, CommentApiManager $commentManager, DoctrineHelper $doctrineHelper, ActivityListAclCriteriaHelper $aclHelper, ActivityInheritanceTargetsHelper $activityInheritanceTargetsHelper, EventDispatcherInterface $eventDispatcher, WorkflowDataHelper $workflowHelper)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/ActivityListBundle/Entity/Manager/ActivityListManager.php#L83 "Oro\Bundle\ActivityListBundle\Entity\Manager\ActivityListManager")</sup>
* The `ActivityListAclCriteriaHelper::$securityContextLink`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/ActivityListBundle/Helper/ActivityListAclCriteriaHelper.php#L23 "Oro\Bundle\ActivityListBundle\Helper\ActivityListAclCriteriaHelper::$securityContextLink")</sup> property was removed.
* The `ActivityListManager::$securityFacade`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/ActivityListBundle/Entity/Manager/ActivityListManager.php#L40 "Oro\Bundle\ActivityListBundle\Entity\Manager\ActivityListManager::$securityFacade")</sup> property was removed.

ApiBundle
---------
* The `AccessGrantedValidator::__construct(SecurityFacade $securityFacade)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/ApiBundle/Validator/Constraints/AccessGrantedValidator.php#L19 "Oro\Bundle\ApiBundle\Validator\Constraints\AccessGrantedValidator")</sup> method was changed to `AccessGrantedValidator::__construct(AuthorizationCheckerInterface $authorizationChecker)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/ApiBundle/Validator/Constraints/AccessGrantedValidator.php#L18 "Oro\Bundle\ApiBundle\Validator\Constraints\AccessGrantedValidator")</sup>
* The `ParentEntityObjectSecurityCheck::__construct(DoctrineHelper $doctrineHelper, SecurityFacade $securityFacade, $permission)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/ApiBundle/Processor/Subresource/Shared/ParentEntityObjectSecurityCheck.php#L33 "Oro\Bundle\ApiBundle\Processor\Subresource\Shared\ParentEntityObjectSecurityCheck")</sup> method was changed to `ParentEntityObjectSecurityCheck::__construct(DoctrineHelper $doctrineHelper, AuthorizationCheckerInterface $authorizationChecker, $permission)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/ApiBundle/Processor/Subresource/Shared/ParentEntityObjectSecurityCheck.php#L33 "Oro\Bundle\ApiBundle\Processor\Subresource\Shared\ParentEntityObjectSecurityCheck")</sup>
* The `ParentEntityTypeSecurityCheck::__construct(DoctrineHelper $doctrineHelper, SecurityFacade $securityFacade, $permission)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/ApiBundle/Processor/Subresource/Shared/ParentEntityTypeSecurityCheck.php#L35 "Oro\Bundle\ApiBundle\Processor\Subresource\Shared\ParentEntityTypeSecurityCheck")</sup> method was changed to `ParentEntityTypeSecurityCheck::__construct(DoctrineHelper $doctrineHelper, AuthorizationCheckerInterface $authorizationChecker, $permission, $forcePermissionUsage = false)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/ApiBundle/Processor/Subresource/Shared/ParentEntityTypeSecurityCheck.php#L39 "Oro\Bundle\ApiBundle\Processor\Subresource\Shared\ParentEntityTypeSecurityCheck")</sup>
* The `EntityTypeSecurityCheck::__construct(DoctrineHelper $doctrineHelper, SecurityFacade $securityFacade, $permission)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/ApiBundle/Processor/Shared/EntityTypeSecurityCheck.php#L35 "Oro\Bundle\ApiBundle\Processor\Shared\EntityTypeSecurityCheck")</sup> method was changed to `EntityTypeSecurityCheck::__construct(DoctrineHelper $doctrineHelper, AuthorizationCheckerInterface $authorizationChecker, $permission, $forcePermissionUsage = false)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/ApiBundle/Processor/Shared/EntityTypeSecurityCheck.php#L39 "Oro\Bundle\ApiBundle\Processor\Shared\EntityTypeSecurityCheck")</sup>
* The `AddOwnerValidator::__construct(DoctrineHelper $doctrineHelper, OwnershipMetadataProvider $ownershipMetadataProvider, ValidationHelper $validationHelper)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/ApiBundle/Processor/Config/GetConfig/AddOwnerValidator.php#L39 "Oro\Bundle\ApiBundle\Processor\Config\GetConfig\AddOwnerValidator")</sup> method was changed to `AddOwnerValidator::__construct(DoctrineHelper $doctrineHelper, OwnershipMetadataProviderInterface $ownershipMetadataProvider, ValidationHelper $validationHelper)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/ApiBundle/Processor/Config/GetConfig/AddOwnerValidator.php#L35 "Oro\Bundle\ApiBundle\Processor\Config\GetConfig\AddOwnerValidator")</sup>
* The `AccessGrantedValidator::$securityFacade`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/ApiBundle/Validator/Constraints/AccessGrantedValidator.php#L14 "Oro\Bundle\ApiBundle\Validator\Constraints\AccessGrantedValidator::$securityFacade")</sup> property was removed.
* The `ParentEntityObjectSecurityCheck::$securityFacade`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/ApiBundle/Processor/Subresource/Shared/ParentEntityObjectSecurityCheck.php#L23 "Oro\Bundle\ApiBundle\Processor\Subresource\Shared\ParentEntityObjectSecurityCheck::$securityFacade")</sup> property was removed.
* The `ParentEntityTypeSecurityCheck::$securityFacade`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/ApiBundle/Processor/Subresource/Shared/ParentEntityTypeSecurityCheck.php#L25 "Oro\Bundle\ApiBundle\Processor\Subresource\Shared\ParentEntityTypeSecurityCheck::$securityFacade")</sup> property was removed.
* The `EntityTypeSecurityCheck::$securityFacade`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/ApiBundle/Processor/Shared/EntityTypeSecurityCheck.php#L25 "Oro\Bundle\ApiBundle\Processor\Shared\EntityTypeSecurityCheck::$securityFacade")</sup> property was removed.

AttachmentBundle
----------------
* The `FileListener::__construct(FileManager $fileManager, ServiceLink $securityFacadeLink)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/AttachmentBundle/EventListener/FileListener.php#L23 "Oro\Bundle\AttachmentBundle\EventListener\FileListener")</sup> method was changed to `FileListener::__construct(FileManager $fileManager, TokenAccessorInterface $tokenAccessor)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/AttachmentBundle/EventListener/FileListener.php#L23 "Oro\Bundle\AttachmentBundle\EventListener\FileListener")</sup>
* The `AttachmentApiEntityManager::__construct($class, ObjectManager $om, SecurityFacade $securityFacade, AttachmentManager $attachmentManager, DoctrineHelper $doctrineHelper)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/AttachmentBundle/Entity/Manager/AttachmentApiEntityManager.php#L36 "Oro\Bundle\AttachmentBundle\Entity\Manager\AttachmentApiEntityManager")</sup> method was changed to `AttachmentApiEntityManager::__construct($class, ObjectManager $om, AuthorizationCheckerInterface $authorizationChecker, AttachmentManager $attachmentManager, DoctrineHelper $doctrineHelper)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/AttachmentBundle/Entity/Manager/AttachmentApiEntityManager.php#L36 "Oro\Bundle\AttachmentBundle\Entity\Manager\AttachmentApiEntityManager")</sup>
* The `FileApiEntityManager::__construct($class, ObjectManager $om, SecurityFacade $securityFacade, FileManager $fileManager, AttachmentManager $attachmentManager)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/AttachmentBundle/Entity/Manager/FileApiEntityManager.php#L34 "Oro\Bundle\AttachmentBundle\Entity\Manager\FileApiEntityManager")</sup> method was changed to `FileApiEntityManager::__construct($class, ObjectManager $om, AuthorizationCheckerInterface $authorizationChecker, FileManager $fileManager, AttachmentManager $attachmentManager)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/AttachmentBundle/Entity/Manager/FileApiEntityManager.php#L34 "Oro\Bundle\AttachmentBundle\Entity\Manager\FileApiEntityManager")</sup>
* The `FileListener::$securityFacadeLink`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/AttachmentBundle/EventListener/FileListener.php#L17 "Oro\Bundle\AttachmentBundle\EventListener\FileListener::$securityFacadeLink")</sup> property was removed.
* The `AttachmentApiEntityManager::$securityFacade`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/AttachmentBundle/Entity/Manager/AttachmentApiEntityManager.php#L18 "Oro\Bundle\AttachmentBundle\Entity\Manager\AttachmentApiEntityManager::$securityFacade")</sup> property was removed.
* The `FileApiEntityManager::$securityFacade`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/AttachmentBundle/Entity/Manager/FileApiEntityManager.php#L19 "Oro\Bundle\AttachmentBundle\Entity\Manager\FileApiEntityManager::$securityFacade")</sup> property was removed.

CommentBundle
-------------
* The `CommentPlaceholderFilter::__construct(CommentAssociationHelper $commentAssociationHelper, DoctrineHelper $doctrineHelper, SecurityFacade $securityFacade)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/CommentBundle/Placeholder/CommentPlaceholderFilter.php#L27 "Oro\Bundle\CommentBundle\Placeholder\CommentPlaceholderFilter")</sup> method was changed to `CommentPlaceholderFilter::__construct(CommentAssociationHelper $commentAssociationHelper, DoctrineHelper $doctrineHelper, AuthorizationCheckerInterface $authorizationChecker)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/CommentBundle/Placeholder/CommentPlaceholderFilter.php#L28 "Oro\Bundle\CommentBundle\Placeholder\CommentPlaceholderFilter")</sup>
* The `CommentLifecycleListener::__construct(ServiceLink $securityFacadeLink)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/CommentBundle/EventListener/CommentLifecycleListener.php#L22 "Oro\Bundle\CommentBundle\EventListener\CommentLifecycleListener")</sup> method was changed to `CommentLifecycleListener::__construct(TokenAccessorInterface $tokenAccessor)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/CommentBundle/EventListener/CommentLifecycleListener.php#L22 "Oro\Bundle\CommentBundle\EventListener\CommentLifecycleListener")</sup>
* The `CommentApiManager::__construct(Registry $doctrine, SecurityFacade $securityFacade, EntityNameResolver $entityNameResolver, Pager $pager, EventDispatcherInterface $eventDispatcher, AttachmentProvider $attachmentProvider, AclHelper $aclHelper, ConfigManager $configManager)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/CommentBundle/Entity/Manager/CommentApiManager.php#L67 "Oro\Bundle\CommentBundle\Entity\Manager\CommentApiManager")</sup> method was changed to `CommentApiManager::__construct(Registry $doctrine, AuthorizationCheckerInterface $authorizationChecker, EntityNameResolver $entityNameResolver, Pager $pager, EventDispatcherInterface $eventDispatcher, AttachmentProvider $attachmentProvider, AclHelper $aclHelper, ConfigManager $configManager)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/CommentBundle/Entity/Manager/CommentApiManager.php#L67 "Oro\Bundle\CommentBundle\Entity\Manager\CommentApiManager")</sup>
* The `CommentPlaceholderFilter::$securityFacade`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/CommentBundle/Placeholder/CommentPlaceholderFilter.php#L20 "Oro\Bundle\CommentBundle\Placeholder\CommentPlaceholderFilter::$securityFacade")</sup> property was removed.
* The `CommentLifecycleListener::$securityFacadeLink`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/CommentBundle/EventListener/CommentLifecycleListener.php#L17 "Oro\Bundle\CommentBundle\EventListener\CommentLifecycleListener::$securityFacadeLink")</sup> property was removed.
* The `CommentApiManager::$securityFacade`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/CommentBundle/Entity/Manager/CommentApiManager.php#L40 "Oro\Bundle\CommentBundle\Entity\Manager\CommentApiManager::$securityFacade")</sup> property was removed.

ConfigBundle
------------
* Interface `Oro\Bundle\ConfigBundle\Provider\Value\ValueProviderInterface` was added. Now services can be used for fetching default value of config setting. For details, see [config_management.md](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/ConfigBundle/Resources/doc/config_management.md).
* The `SystemConfigurationFormProvider::__construct(ConfigBag $configBag, FormFactoryInterface $factory, SecurityFacade $securityFacade)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/ConfigBundle/Provider/SystemConfigurationFormProvider.php#L31 "Oro\Bundle\ConfigBundle\Provider\SystemConfigurationFormProvider")</sup> method was changed to `SystemConfigurationFormProvider::__construct(ConfigBag $configBag, FormFactoryInterface $factory, AuthorizationCheckerInterface $authorizationChecker)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/ConfigBundle/Provider/SystemConfigurationFormProvider.php#L31 "Oro\Bundle\ConfigBundle\Provider\SystemConfigurationFormProvider")</sup>
* The `LoadConfigurationSections::__construct(ConfigurationRepository $configRepository, SecurityFacade $securityFacade)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/ConfigBundle/Api/Processor/GetList/LoadConfigurationSections.php#L27 "Oro\Bundle\ConfigBundle\Api\Processor\GetList\LoadConfigurationSections")</sup> method was changed to `LoadConfigurationSections::__construct(ConfigurationRepository $configRepository, AuthorizationCheckerInterface $authorizationChecker)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/ConfigBundle/Api/Processor/GetList/LoadConfigurationSections.php#L28 "Oro\Bundle\ConfigBundle\Api\Processor\GetList\LoadConfigurationSections")</sup>
* The `SystemConfigurationFormProvider::$securityFacade`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/ConfigBundle/Provider/SystemConfigurationFormProvider.php#L24 "Oro\Bundle\ConfigBundle\Provider\SystemConfigurationFormProvider::$securityFacade")</sup> property was removed.
* The `LoadConfigurationSections::$securityFacade`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/ConfigBundle/Api/Processor/GetList/LoadConfigurationSections.php#L21 "Oro\Bundle\ConfigBundle\Api\Processor\GetList\LoadConfigurationSections::$securityFacade")</sup> property was removed.

CronBundle
----------
* The `CommandRunnerMessageProcessor::__construct(CommandRunnerInterface $commandRunner, JobRunner $jobRunner, LoggerInterface $logger)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/CronBundle/Async/CommandRunnerMessageProcessor.php#L36 "Oro\Bundle\CronBundle\Async\CommandRunnerMessageProcessor")</sup> method was changed to `CommandRunnerMessageProcessor::__construct(JobRunner $jobRunner, LoggerInterface $logger, MessageProducerInterface $producer)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/CronBundle/Async/CommandRunnerMessageProcessor.php#L36 "Oro\Bundle\CronBundle\Async\CommandRunnerMessageProcessor")</sup>

DashboardBundle
---------------
* The `Manager::__construct(Factory $factory, EntityManager $entityManager, AclHelper $aclHelper, SecurityContextInterface $securityContext)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/DashboardBundle/Model/Manager.php#L41 "Oro\Bundle\DashboardBundle\Model\Manager")</sup> method was changed to `Manager::__construct(Factory $factory, EntityManager $entityManager, AclHelper $aclHelper, TokenStorageInterface $tokenStorage)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/DashboardBundle/Model/Manager.php#L41 "Oro\Bundle\DashboardBundle\Model\Manager")</sup>
* The `StateManager::__construct(EntityManager $em, SecurityFacade $securityFacade)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/DashboardBundle/Model/StateManager.php#L32 "Oro\Bundle\DashboardBundle\Model\StateManager")</sup> method was changed to `StateManager::__construct(EntityManager $em, TokenAccessorInterface $tokenAccessor)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/DashboardBundle/Model/StateManager.php#L25 "Oro\Bundle\DashboardBundle\Model\StateManager")</sup>
* The `WidgetConfigVisibilityFilter::__construct(SecurityFacade $securityFacade, ResolverInterface $resolver, FeatureChecker $featureChecker)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/DashboardBundle/Filter/WidgetConfigVisibilityFilter.php#L25 "Oro\Bundle\DashboardBundle\Filter\WidgetConfigVisibilityFilter")</sup> method was changed to `WidgetConfigVisibilityFilter::__construct(AuthorizationCheckerInterface $authorizationChecker, ResolverInterface $resolver, FeatureChecker $featureChecker)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/DashboardBundle/Filter/WidgetConfigVisibilityFilter.php#L26 "Oro\Bundle\DashboardBundle\Filter\WidgetConfigVisibilityFilter")</sup>
* The `NavigationListener::__construct(SecurityFacade $securityFacade, Manager $manager)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/DashboardBundle/EventListener/NavigationListener.php#L22 "Oro\Bundle\DashboardBundle\EventListener\NavigationListener")</sup> method was changed to `NavigationListener::__construct(TokenAccessorInterface $tokenAccessor, Manager $manager)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/DashboardBundle/EventListener/NavigationListener.php#L22 "Oro\Bundle\DashboardBundle\EventListener\NavigationListener")</sup>
* The `Manager::$securityContext`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/DashboardBundle/Model/Manager.php#L31 "Oro\Bundle\DashboardBundle\Model\Manager::$securityContext")</sup> property was removed.
* The `StateManager::$securityContext`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/DashboardBundle/Model/StateManager.php#L26 "Oro\Bundle\DashboardBundle\Model\StateManager::$securityContext")</sup> property was removed.
* The `WidgetConfigVisibilityFilter::$securityFacade`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/DashboardBundle/Filter/WidgetConfigVisibilityFilter.php#L12 "Oro\Bundle\DashboardBundle\Filter\WidgetConfigVisibilityFilter::$securityFacade")</sup> property was removed.
* The `NavigationListener::$securityFacade`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/DashboardBundle/EventListener/NavigationListener.php#L13 "Oro\Bundle\DashboardBundle\EventListener\NavigationListener::$securityFacade")</sup> property was removed.
* The `DashboardController::getSecurityFacade`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/DashboardBundle/Controller/DashboardController.php#L446 "Oro\Bundle\DashboardBundle\Controller\DashboardController::getSecurityFacade")</sup> method was removed.

DataAuditBundle
---------------
* The `SegmentWidgetOptionsListener::__construct(HttpKernelInterface $httpKernel, SecurityFacade $securityFacade, ContextChecker $contextChecker)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/DataAuditBundle/EventListener/SegmentWidgetOptionsListener.php#L31 "Oro\Bundle\DataAuditBundle\EventListener\SegmentWidgetOptionsListener")</sup> method was changed to `SegmentWidgetOptionsListener::__construct(HttpKernelInterface $httpKernel, AuthorizationCheckerInterface $authorizationChecker, ContextChecker $contextChecker)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/DataAuditBundle/EventListener/SegmentWidgetOptionsListener.php#L31 "Oro\Bundle\DataAuditBundle\EventListener\SegmentWidgetOptionsListener")</sup>
* The `SegmentWidgetOptionsListener::$securityFacade`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/DataAuditBundle/EventListener/SegmentWidgetOptionsListener.php#L21 "Oro\Bundle\DataAuditBundle\EventListener\SegmentWidgetOptionsListener::$securityFacade")</sup> property was removed.

DataGridBundle
--------------
* The following classes were removed:
   - `ActionProvidersPass`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/DataGridBundle/DependencyInjection/CompilerPass/ActionProvidersPass.php#L9 "Oro\Bundle\DataGridBundle\DependencyInjection\CompilerPass\ActionProvidersPass")</sup>
   - `MassActionsPass`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/DataGridBundle/DependencyInjection/CompilerPass/MassActionsPass.php#L8 "Oro\Bundle\DataGridBundle\DependencyInjection\CompilerPass\MassActionsPass")</sup>
* The `DataGridExtension::getSecurityFacade`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/DataGridBundle/Twig/DataGridExtension.php#L59 "Oro\Bundle\DataGridBundle\Twig\DataGridExtension::getSecurityFacade")</sup> method was removed.
* The `InlineEditingExtension::getColummFieldName`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/DataGridBundle/Extension/InlineEditing/InlineEditingExtension.php#L162 "Oro\Bundle\DataGridBundle\Extension\InlineEditing\InlineEditingExtension::getColummFieldName")</sup> method was removed.
* The `GridViewsExtension::getCurrentUser`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/DataGridBundle/Extension/GridViews/GridViewsExtension.php#L279 "Oro\Bundle\DataGridBundle\Extension\GridViews\GridViewsExtension::getCurrentUser")</sup> method was removed.
* The following methods in class `FieldAclExtension`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/DataGridBundle/Extension/FieldAcl/FieldAclExtension.php#L189 "Oro\Bundle\DataGridBundle\Extension\FieldAcl\FieldAclExtension")</sup> were removed:
   - `collectEntityAliases::collectEntityAliases`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/DataGridBundle/Extension/FieldAcl/FieldAclExtension.php#L189 "Oro\Bundle\DataGridBundle\Extension\FieldAcl\FieldAclExtension::collectEntityAliases")</sup>
   - `addIdentitySelectsToQuery::addIdentitySelectsToQuery`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/DataGridBundle/Extension/FieldAcl/FieldAclExtension.php#L211 "Oro\Bundle\DataGridBundle\Extension\FieldAcl\FieldAclExtension::addIdentitySelectsToQuery")</sup>
   - `tryToGetAliasFromSelectPart::tryToGetAliasFromSelectPart`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/DataGridBundle/Extension/FieldAcl/FieldAclExtension.php#L249 "Oro\Bundle\DataGridBundle\Extension\FieldAcl\FieldAclExtension::tryToGetAliasFromSelectPart")</sup>
* The `ColumnsExtension::getCurrentUser`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/DataGridBundle/Extension/Columns/ColumnsExtension.php#L412 "Oro\Bundle\DataGridBundle\Extension\Columns\ColumnsExtension::getCurrentUser")</sup> method was removed.
* The following methods in class `ActionExtension`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/DataGridBundle/Extension/Action/ActionExtension.php#L87 "Oro\Bundle\DataGridBundle\Extension\Action\ActionExtension")</sup> were removed:
   - `getApplicableActionProviders::getApplicableActionProviders`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/DataGridBundle/Extension/Action/ActionExtension.php#L87 "Oro\Bundle\DataGridBundle\Extension\Action\ActionExtension::getApplicableActionProviders")</sup>
   - `getActionObject::getActionObject`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/DataGridBundle/Extension/Action/ActionExtension.php#L144 "Oro\Bundle\DataGridBundle\Extension\Action\ActionExtension::getActionObject")</sup>
   - `create::create`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/DataGridBundle/Extension/Action/ActionExtension.php#L180 "Oro\Bundle\DataGridBundle\Extension\Action\ActionExtension::create")</sup>
   - `isResourceGranted::isResourceGranted`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/DataGridBundle/Extension/Action/ActionExtension.php#L209 "Oro\Bundle\DataGridBundle\Extension\Action\ActionExtension::isResourceGranted")</sup>
* The `GridViewsLoadListener::getCurrentUser`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/DataGridBundle/EventListener/GridViewsLoadListener.php#L129 "Oro\Bundle\DataGridBundle\EventListener\GridViewsLoadListener::getCurrentUser")</sup> method was removed.
* The `GridViewController::getSecurityFacade`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/DataGridBundle/Controller/Api/Rest/GridViewController.php#L229 "Oro\Bundle\DataGridBundle\Controller\Api\Rest\GridViewController::getSecurityFacade")</sup> method was removed.
* The `MultiGridProvider::__construct(SecurityFacade $securityFacade, ConfigManager $configManager, ManagerInterface $gridManager)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/DataGridBundle/Provider/MultiGridProvider.php#L32 "Oro\Bundle\DataGridBundle\Provider\MultiGridProvider")</sup> method was changed to `MultiGridProvider::__construct(AuthorizationCheckerInterface $authorizationChecker, ConfigManager $configManager, ManagerInterface $gridManager)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/DataGridBundle/Provider/MultiGridProvider.php#L27 "Oro\Bundle\DataGridBundle\Provider\MultiGridProvider")</sup>
* The `DatagridType::__construct(NameStrategyInterface $nameStrategy, ManagerInterface $manager, SecurityFacade $securityFacade)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/DataGridBundle/Layout/Block/Type/DatagridType.php#L36 "Oro\Bundle\DataGridBundle\Layout\Block\Type\DatagridType")</sup> method was changed to `DatagridType::__construct(NameStrategyInterface $nameStrategy, ManagerInterface $manager, AuthorizationCheckerInterface $authorizationChecker)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/DataGridBundle/Layout/Block/Type/DatagridType.php#L37 "Oro\Bundle\DataGridBundle\Layout\Block\Type\DatagridType")</sup>
* The `AbstractPagerExtension::__construct(AbstractPager $pager)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/DataGridBundle/Extension/Pager/AbstractPagerExtension.php#L20 "Oro\Bundle\DataGridBundle\Extension\Pager\AbstractPagerExtension")</sup> method was changed to `AbstractPagerExtension::__construct(PagerInterface $pager)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/DataGridBundle/Extension/Pager/AbstractPagerExtension.php#L20 "Oro\Bundle\DataGridBundle\Extension\Pager\AbstractPagerExtension")</sup>
* The `DeleteMassActionHandler::__construct(RegistryInterface $registry, TranslatorInterface $translator, SecurityFacade $securityFacade, MassDeleteLimiter $limiter, RequestStack $requestStack, OptionalListenerManager $listenerManager, MessageProducerInterface $producer)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/DataGridBundle/Extension/MassAction/DeleteMassActionHandler.php#L59 "Oro\Bundle\DataGridBundle\Extension\MassAction\DeleteMassActionHandler")</sup> method was changed to `DeleteMassActionHandler::__construct(ManagerRegistry $registry, TranslatorInterface $translator, AuthorizationCheckerInterface $authorizationChecker, MassDeleteLimiter $limiter, RequestStack $requestStack, OptionalListenerManager $listenerManager, MessageProducerInterface $producer)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/DataGridBundle/Extension/MassAction/DeleteMassActionHandler.php#L59 "Oro\Bundle\DataGridBundle\Extension\MassAction\DeleteMassActionHandler")</sup>
* The `InlineEditingExtension::__construct(InlineEditColumnOptionsGuesser $inlineEditColumnOptionsGuesser, SecurityFacade $securityFacade, EntityClassNameHelper $entityClassNameHelper, AuthorizationCheckerInterface $authorizationChecker)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/DataGridBundle/Extension/InlineEditing/InlineEditingExtension.php#L37 "Oro\Bundle\DataGridBundle\Extension\InlineEditing\InlineEditingExtension")</sup> method was changed to `InlineEditingExtension::__construct(InlineEditColumnOptionsGuesser $inlineEditColumnOptionsGuesser, EntityClassNameHelper $entityClassNameHelper, AuthorizationCheckerInterface $authorizationChecker)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/DataGridBundle/Extension/InlineEditing/InlineEditingExtension.php#L32 "Oro\Bundle\DataGridBundle\Extension\InlineEditing\InlineEditingExtension")</sup>
* The `GridViewsExtension::__construct(EventDispatcherInterface $eventDispatcher, SecurityFacade $securityFacade, TranslatorInterface $translator, ManagerRegistry $registry, AclHelper $aclHelper, ServiceLink $managerLink)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/DataGridBundle/Extension/GridViews/GridViewsExtension.php#L64 "Oro\Bundle\DataGridBundle\Extension\GridViews\GridViewsExtension")</sup> method was changed to `GridViewsExtension::__construct(EventDispatcherInterface $eventDispatcher, AuthorizationCheckerInterface $authorizationChecker, TokenAccessorInterface $tokenAccessor, TranslatorInterface $translator, ManagerRegistry $registry, AclHelper $aclHelper, ServiceLink $managerLink)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/DataGridBundle/Extension/GridViews/GridViewsExtension.php#L67 "Oro\Bundle\DataGridBundle\Extension\GridViews\GridViewsExtension")</sup>
* The `FieldAclExtension::__construct(OwnershipMetadataProvider $ownershipMetadataProvider, EntityClassResolver $entityClassResolver, AuthorizationCheckerInterface $authorizationChecker, ConfigProvider $configProvider)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/DataGridBundle/Extension/FieldAcl/FieldAclExtension.php#L55 "Oro\Bundle\DataGridBundle\Extension\FieldAcl\FieldAclExtension")</sup> method was changed to `FieldAclExtension::__construct(AuthorizationCheckerInterface $authorizationChecker, ConfigManager $configManager, OwnershipQueryHelper $ownershipQueryHelper)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/DataGridBundle/Extension/FieldAcl/FieldAclExtension.php#L53 "Oro\Bundle\DataGridBundle\Extension\FieldAcl\FieldAclExtension")</sup>
* The `ExportExtension::__construct(TranslatorInterface $translator, SecurityFacade $securityFacade)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/DataGridBundle/Extension/Export/ExportExtension.php#L30 "Oro\Bundle\DataGridBundle\Extension\Export\ExportExtension")</sup> method was changed to `ExportExtension::__construct(TranslatorInterface $translator, AuthorizationCheckerInterface $authorizationChecker, TokenStorageInterface $tokenStorage)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/DataGridBundle/Extension/Export/ExportExtension.php#L33 "Oro\Bundle\DataGridBundle\Extension\Export\ExportExtension")</sup>
* The `ColumnsExtension::__construct(Registry $registry, SecurityFacade $securityFacade, AclHelper $aclHelper, ColumnsHelper $columnsHelper)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/DataGridBundle/Extension/Columns/ColumnsExtension.php#L56 "Oro\Bundle\DataGridBundle\Extension\Columns\ColumnsExtension")</sup> method was changed to `ColumnsExtension::__construct(ManagerRegistry $registry, TokenAccessorInterface $tokenAccessor, AclHelper $aclHelper, ColumnsHelper $columnsHelper)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/DataGridBundle/Extension/Columns/ColumnsExtension.php#L54 "Oro\Bundle\DataGridBundle\Extension\Columns\ColumnsExtension")</sup>
* The `BoardExtension::__construct(SecurityFacade $securityFacade, TranslatorInterface $translator, RestrictionManager $restrictionManager, Configuration $configuration, EntityClassNameHelper $entityClassNameHelper, EntityClassResolver $entityClassResolver)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/DataGridBundle/Extension/Board/BoardExtension.php#L76 "Oro\Bundle\DataGridBundle\Extension\Board\BoardExtension")</sup> method was changed to `BoardExtension::__construct(AuthorizationCheckerInterface $authorizationChecker, TranslatorInterface $translator, RestrictionManager $restrictionManager, Configuration $configuration, EntityClassNameHelper $entityClassNameHelper, EntityClassResolver $entityClassResolver)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/DataGridBundle/Extension/Board/BoardExtension.php#L70 "Oro\Bundle\DataGridBundle\Extension\Board\BoardExtension")</sup>
* The `ActionExtension::__construct(ContainerInterface $container, SecurityFacade $securityFacade, TranslatorInterface $translator)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/DataGridBundle/Extension/Action/ActionExtension.php#L49 "Oro\Bundle\DataGridBundle\Extension\Action\ActionExtension")</sup> method was changed to `ActionExtension::__construct(ActionFactory $actionFactory, ActionMetadataFactory $actionMetadataFactory, AuthorizationCheckerInterface $authorizationChecker, OwnershipQueryHelper $ownershipQueryHelper)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/DataGridBundle/Extension/Action/ActionExtension.php#L67 "Oro\Bundle\DataGridBundle\Extension\Action\ActionExtension")</sup>
* The `GridViewsLoadListener::__construct(Registry $registry, SecurityFacade $securityFacade, AclHelper $aclHelper, TranslatorInterface $translator, GridViewManager $gridViewManager, AppearanceTypeManager $appearanceTypeManager)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/DataGridBundle/EventListener/GridViewsLoadListener.php#L48 "Oro\Bundle\DataGridBundle\EventListener\GridViewsLoadListener")</sup> method was changed to `GridViewsLoadListener::__construct(ManagerRegistry $registry, AuthorizationCheckerInterface $authorizationChecker, TokenAccessorInterface $tokenAccessor, AclHelper $aclHelper, TranslatorInterface $translator, GridViewManager $gridViewManager, AppearanceTypeManager $appearanceTypeManager)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/DataGridBundle/EventListener/GridViewsLoadListener.php#L52 "Oro\Bundle\DataGridBundle\EventListener\GridViewsLoadListener")</sup>
* The `MultiGridProvider::$securityFacade`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/DataGridBundle/Provider/MultiGridProvider.php#L15 "Oro\Bundle\DataGridBundle\Provider\MultiGridProvider::$securityFacade")</sup> property was removed.
* The `DatagridType::$securityFacade`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/DataGridBundle/Layout/Block/Type/DatagridType.php#L29 "Oro\Bundle\DataGridBundle\Layout\Block\Type\DatagridType::$securityFacade")</sup> property was removed.
* The `DeleteMassActionHandler::$securityFacade`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/DataGridBundle/Extension/MassAction/DeleteMassActionHandler.php#L33 "Oro\Bundle\DataGridBundle\Extension\MassAction\DeleteMassActionHandler::$securityFacade")</sup> property was removed.
* The `MassActionExtension::$actions`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/DataGridBundle/Extension/MassAction/MassActionExtension.php#L17 "Oro\Bundle\DataGridBundle\Extension\MassAction\MassActionExtension::$actions")</sup> property was removed.
* The following properties in class `InlineEditingExtension`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/DataGridBundle/Extension/InlineEditing/InlineEditingExtension.php#L23 "Oro\Bundle\DataGridBundle\Extension\InlineEditing\InlineEditingExtension")</sup> were removed:
   - `$securityFacade::$securityFacade`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/DataGridBundle/Extension/InlineEditing/InlineEditingExtension.php#L23 "Oro\Bundle\DataGridBundle\Extension\InlineEditing\InlineEditingExtension::$securityFacade")</sup>
   - `$authChecker::$authChecker`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/DataGridBundle/Extension/InlineEditing/InlineEditingExtension.php#L29 "Oro\Bundle\DataGridBundle\Extension\InlineEditing\InlineEditingExtension::$authChecker")</sup>
* The `GridViewsExtension::$securityFacade`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/DataGridBundle/Extension/GridViews/GridViewsExtension.php#L39 "Oro\Bundle\DataGridBundle\Extension\GridViews\GridViewsExtension::$securityFacade")</sup> property was removed.
* The following properties in class `FieldAclExtension`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/DataGridBundle/Extension/FieldAcl/FieldAclExtension.php#L32 "Oro\Bundle\DataGridBundle\Extension\FieldAcl\FieldAclExtension")</sup> were removed:
   - `$ownershipMetadataProvider::$ownershipMetadataProvider`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/DataGridBundle/Extension/FieldAcl/FieldAclExtension.php#L32 "Oro\Bundle\DataGridBundle\Extension\FieldAcl\FieldAclExtension::$ownershipMetadataProvider")</sup>
   - `$entityClassResolver::$entityClassResolver`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/DataGridBundle/Extension/FieldAcl/FieldAclExtension.php#L35 "Oro\Bundle\DataGridBundle\Extension\FieldAcl\FieldAclExtension::$entityClassResolver")</sup>
   - `$configProvider::$configProvider`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/DataGridBundle/Extension/FieldAcl/FieldAclExtension.php#L41 "Oro\Bundle\DataGridBundle\Extension\FieldAcl\FieldAclExtension::$configProvider")</sup>
   - `$queryAliases::$queryAliases`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/DataGridBundle/Extension/FieldAcl/FieldAclExtension.php#L47 "Oro\Bundle\DataGridBundle\Extension\FieldAcl\FieldAclExtension::$queryAliases")</sup>
* The `ExportExtension::$securityFacade`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/DataGridBundle/Extension/Export/ExportExtension.php#L22 "Oro\Bundle\DataGridBundle\Extension\Export\ExportExtension::$securityFacade")</sup> property was removed.
* The `ColumnsExtension::$securityFacade`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/DataGridBundle/Extension/Columns/ColumnsExtension.php#L39 "Oro\Bundle\DataGridBundle\Extension\Columns\ColumnsExtension::$securityFacade")</sup> property was removed.
* The `BoardExtension::$securityFacade`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/DataGridBundle/Extension/Board/BoardExtension.php#L51 "Oro\Bundle\DataGridBundle\Extension\Board\BoardExtension::$securityFacade")</sup> property was removed.
* The following properties in class `ActionExtension`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/DataGridBundle/Extension/Action/ActionExtension.php#L27 "Oro\Bundle\DataGridBundle\Extension\Action\ActionExtension")</sup> were removed:
   - `$container::$container`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/DataGridBundle/Extension/Action/ActionExtension.php#L27 "Oro\Bundle\DataGridBundle\Extension\Action\ActionExtension::$container")</sup>
   - `$securityFacade::$securityFacade`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/DataGridBundle/Extension/Action/ActionExtension.php#L30 "Oro\Bundle\DataGridBundle\Extension\Action\ActionExtension::$securityFacade")</sup>
   - `$translator::$translator`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/DataGridBundle/Extension/Action/ActionExtension.php#L33 "Oro\Bundle\DataGridBundle\Extension\Action\ActionExtension::$translator")</sup>
   - `$actions::$actions`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/DataGridBundle/Extension/Action/ActionExtension.php#L36 "Oro\Bundle\DataGridBundle\Extension\Action\ActionExtension::$actions")</sup>
   - `$excludeParams::$excludeParams`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/DataGridBundle/Extension/Action/ActionExtension.php#L42 "Oro\Bundle\DataGridBundle\Extension\Action\ActionExtension::$excludeParams")</sup>
* The `GridViewsLoadListener::$securityFacade`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/DataGridBundle/EventListener/GridViewsLoadListener.php#L24 "Oro\Bundle\DataGridBundle\EventListener\GridViewsLoadListener::$securityFacade")</sup> property was removed.
* The `ActionExtension::registerAction`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/DataGridBundle/Extension/Action/ActionExtension.php#L164 "Oro\Bundle\DataGridBundle\Extension\Action\ActionExtension::registerAction")</sup> method was removed.

DistributionBundle
------------------
* The `AccessDeniedListener::__construct(Session $session, Router $router, SecurityContextInterface $securityContext)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/DistributionBundle/Security/AccessDeniedListener.php#L34 "Oro\Bundle\DistributionBundle\Security\AccessDeniedListener")</sup> method was changed to `AccessDeniedListener::__construct(Session $session, Router $router, TokenStorageInterface $tokenStorage)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/DistributionBundle/Security/AccessDeniedListener.php#L29 "Oro\Bundle\DistributionBundle\Security\AccessDeniedListener")</sup>
* The `NavigationListener::__construct(SecurityContextInterface $securityContext, $entryPoint = null)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/DistributionBundle/EventListener/NavigationListener.php#L33 "Oro\Bundle\DistributionBundle\EventListener\NavigationListener")</sup> method was changed to `NavigationListener::__construct(AuthorizationCheckerInterface $authorizationChecker, TokenStorageInterface $tokenStorage, $entryPoint = null)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/DistributionBundle/EventListener/NavigationListener.php#L32 "Oro\Bundle\DistributionBundle\EventListener\NavigationListener")</sup>
* The `AccessDeniedListener::$securityContext`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/DistributionBundle/Security/AccessDeniedListener.php#L27 "Oro\Bundle\DistributionBundle\Security\AccessDeniedListener::$securityContext")</sup> property was removed.
* The `NavigationListener::$securityContext`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/DistributionBundle/EventListener/NavigationListener.php#L17 "Oro\Bundle\DistributionBundle\EventListener\NavigationListener::$securityContext")</sup> property was removed.

DoctrineUtils
-------------
* The `Oro\Component\DoctrineUtils\ORM\QueryUtils` class was marked as deprecated.  Its methods were moved to 4 classes:
   - `Oro\Component\DoctrineUtils\ORM\QueryUtil`
   - `Oro\Component\DoctrineUtils\ORM\QueryBuilderUtil`
   - `Oro\Component\DoctrineUtils\ORM\ResultSetMappingUtil`
   - `Oro\Component\DoctrineUtils\ORM\DqlUtil`
* The `QueryUtils::findParentAliasWithJoin`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Component/DoctrineUtils/ORM/QueryUtils.php#L615 "Oro\Component\DoctrineUtils\ORM\QueryUtils::findParentAliasWithJoin")</sup> method was removed.

EmailBundle
-----------
* The `EmailExtension::getSecurityFacade`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/EmailBundle/Twig/EmailExtension.php#L83 "Oro\Bundle\EmailBundle\Twig\EmailExtension::getSecurityFacade")</sup> method was removed.
* The `EmailQueryFactory::getFromEmailExpression`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/EmailBundle/Datagrid/EmailQueryFactory.php#L387 "Oro\Bundle\EmailBundle\Datagrid\EmailQueryFactory::getFromEmailExpression")</sup> method was removed.
* The `EmailOriginHelper::__construct(DoctrineHelper $doctrineHelper, ServiceLink $serviceLink, EmailOwnerProvider $emailOwnerProvider, EmailAddressHelper $emailAddressHelper)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/EmailBundle/Tools/EmailOriginHelper.php#L57 "Oro\Bundle\EmailBundle\Tools\EmailOriginHelper")</sup> method was changed to `EmailOriginHelper::__construct(DoctrineHelper $doctrineHelper, TokenAccessorInterface $tokenAccessor, EmailOwnerProvider $emailOwnerProvider, EmailAddressHelper $emailAddressHelper)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/EmailBundle/Tools/EmailOriginHelper.php#L52 "Oro\Bundle\EmailBundle\Tools\EmailOriginHelper")</sup>
* The `EmailActivityListProvider::__construct(DoctrineHelper $doctrineHelper, ServiceLink $doctrineRegistryLink, EntityNameResolver $entityNameResolver, Router $router, ConfigManager $configManager, EmailThreadProvider $emailThreadProvider, HtmlTagHelper $htmlTagHelper, ServiceLink $securityFacadeLink, ServiceLink $mailboxProcessStorageLink, ActivityAssociationHelper $activityAssociationHelper, CommentAssociationHelper $commentAssociationHelper)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/EmailBundle/Provider/EmailActivityListProvider.php#L106 "Oro\Bundle\EmailBundle\Provider\EmailActivityListProvider")</sup> method was changed to `EmailActivityListProvider::__construct(DoctrineHelper $doctrineHelper, ServiceLink $doctrineRegistryLink, EntityNameResolver $entityNameResolver, Router $router, ConfigManager $configManager, EmailThreadProvider $emailThreadProvider, HtmlTagHelper $htmlTagHelper, AuthorizationCheckerInterface $authorizationChecker, TokenAccessorInterface $tokenAccessor, ServiceLink $mailboxProcessStorageLink, ActivityAssociationHelper $activityAssociationHelper, CommentAssociationHelper $commentAssociationHelper)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/EmailBundle/Provider/EmailActivityListProvider.php#L107 "Oro\Bundle\EmailBundle\Provider\EmailActivityListProvider")</sup>
* The `EmailRenderer::__construct(Twig_LoaderInterface $loader, $options, VariablesProvider $variablesProvider, Cache $cache, $cacheKey, Twig_Extension_Sandbox $sandbox, TranslatorInterface $translator)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/EmailBundle/Provider/EmailRenderer.php#L54 "Oro\Bundle\EmailBundle\Provider\EmailRenderer")</sup> method was changed to `EmailRenderer::__construct(Twig_LoaderInterface $loader, $options, VariablesProvider $variablesProvider, Cache $cache, $cacheKey, Twig_Extension_Sandbox $sandbox, TranslatorInterface $translator, VariableProcessorRegistry $variableProcessorRegistry)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/EmailBundle/Provider/EmailRenderer.php#L60 "Oro\Bundle\EmailBundle\Provider\EmailRenderer")</sup>
* The `LoggedUserVariablesProvider::__construct(TranslatorInterface $translator, SecurityFacade $securityFacade, EntityNameResolver $entityNameResolver, ConfigManager $configManager)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/EmailBundle/Provider/LoggedUserVariablesProvider.php#L39 "Oro\Bundle\EmailBundle\Provider\LoggedUserVariablesProvider")</sup> method was changed to `LoggedUserVariablesProvider::__construct(TranslatorInterface $translator, TokenAccessorInterface $tokenAccessor, EntityNameResolver $entityNameResolver, ConfigManager $configManager)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/EmailBundle/Provider/LoggedUserVariablesProvider.php#L39 "Oro\Bundle\EmailBundle\Provider\LoggedUserVariablesProvider")</sup>
* The `RecentEmailRecipientsProvider::__construct(SecurityFacade $securityFacade, RelatedEmailsProvider $relatedEmailsProvider, AclHelper $aclHelper, Registry $registry, EmailOwnerProvider $emailOwnerProvider, EmailRecipientsHelper $emailRecipientsHelper)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/EmailBundle/Provider/RecentEmailRecipientsProvider.php#L45 "Oro\Bundle\EmailBundle\Provider\RecentEmailRecipientsProvider")</sup> method was changed to `RecentEmailRecipientsProvider::__construct(TokenAccessorInterface $tokenAccessor, RelatedEmailsProvider $relatedEmailsProvider, AclHelper $aclHelper, Registry $registry, EmailOwnerProvider $emailOwnerProvider, EmailRecipientsHelper $emailRecipientsHelper)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/EmailBundle/Provider/RecentEmailRecipientsProvider.php#L44 "Oro\Bundle\EmailBundle\Provider\RecentEmailRecipientsProvider")</sup>
* The `RelatedEmailsProvider::__construct(Registry $registry, ConfigManager $configManager, SecurityFacade $securityFacade, NameFormatter $nameFormatter, EmailAddressHelper $emailAddressHelper, EmailRecipientsHelper $emailRecipientsHelper, EntityFieldProvider $entityFieldProvider)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/EmailBundle/Provider/RelatedEmailsProvider.php#L59 "Oro\Bundle\EmailBundle\Provider\RelatedEmailsProvider")</sup> method was changed to `RelatedEmailsProvider::__construct(Registry $registry, ConfigManager $configManager, AuthorizationCheckerInterface $authorizationChecker, TokenAccessorInterface $tokenAccessor, NameFormatter $nameFormatter, EmailAddressHelper $emailAddressHelper, EmailRecipientsHelper $emailRecipientsHelper, EntityFieldProvider $entityFieldProvider)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/EmailBundle/Provider/RelatedEmailsProvider.php#L63 "Oro\Bundle\EmailBundle\Provider\RelatedEmailsProvider")</sup>
* The `AutoResponseTemplateChoiceType::__construct(SecurityFacade $securityFacade, TranslatorInterface $translator)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/EmailBundle/Form/Type/AutoResponseTemplateChoiceType.php#L31 "Oro\Bundle\EmailBundle\Form\Type\AutoResponseTemplateChoiceType")</sup> method was changed to `AutoResponseTemplateChoiceType::__construct(TokenAccessorInterface $tokenAccessor, TranslatorInterface $translator)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/EmailBundle/Form/Type/AutoResponseTemplateChoiceType.php#L31 "Oro\Bundle\EmailBundle\Form\Type\AutoResponseTemplateChoiceType")</sup>
* The `EmailAddressFromType::__construct(SecurityFacade $securityFacade, RelatedEmailsProvider $relatedEmailsProvider, MailboxManager $mailboxManager)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/EmailBundle/Form/Type/EmailAddressFromType.php#L31 "Oro\Bundle\EmailBundle\Form\Type\EmailAddressFromType")</sup> method was changed to `EmailAddressFromType::__construct(TokenAccessorInterface $tokenAccessor, RelatedEmailsProvider $relatedEmailsProvider, MailboxManager $mailboxManager)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/EmailBundle/Form/Type/EmailAddressFromType.php#L31 "Oro\Bundle\EmailBundle\Form\Type\EmailAddressFromType")</sup>
* The `EmailOriginFromType::__construct(SecurityFacade $securityFacade, RelatedEmailsProvider $relatedEmailsProvider, EmailModelBuilderHelper $helper, MailboxManager $mailboxManager, Registry $registry, EmailOriginHelper $emailOriginHelper)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/EmailBundle/Form/Type/EmailOriginFromType.php#L51 "Oro\Bundle\EmailBundle\Form\Type\EmailOriginFromType")</sup> method was changed to `EmailOriginFromType::__construct(TokenAccessorInterface $tokenAccessor, RelatedEmailsProvider $relatedEmailsProvider, EmailModelBuilderHelper $helper, MailboxManager $mailboxManager, ManagerRegistry $registry, EmailOriginHelper $emailOriginHelper)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/EmailBundle/Form/Type/EmailOriginFromType.php#L51 "Oro\Bundle\EmailBundle\Form\Type\EmailOriginFromType")</sup>
* The `EmailType::__construct(SecurityContextInterface $securityContext, EmailRenderer $emailRenderer, EmailModelBuilderHelper $emailModelBuilderHelper, ConfigManager $configManager)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/EmailBundle/Form/Type/EmailType.php#L46 "Oro\Bundle\EmailBundle\Form\Type\EmailType")</sup> method was changed to `EmailType::__construct(AuthorizationCheckerInterface $authorizationChecker, TokenAccessorInterface $tokenAccessor, EmailRenderer $emailRenderer, EmailModelBuilderHelper $emailModelBuilderHelper, ConfigManager $configManager)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/EmailBundle/Form/Type/EmailType.php#L46 "Oro\Bundle\EmailBundle\Form\Type\EmailType")</sup>
* The `EmailApiHandler::__construct(FormInterface $form, Request $request, EntityManager $entityManager, EmailEntityBuilder $emailEntityBuilder, SecurityFacade $securityFacade, EventDispatcherInterface $eventDispatcher, DataTransformerInterface $emailImportanceTransformer, DataTransformerInterface $emailBodyTypeTransformer)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/EmailBundle/Form/Handler/EmailApiHandler.php#L61 "Oro\Bundle\EmailBundle\Form\Handler\EmailApiHandler")</sup> method was changed to `EmailApiHandler::__construct(FormInterface $form, Request $request, EntityManager $entityManager, EmailEntityBuilder $emailEntityBuilder, TokenAccessorInterface $tokenAccessor, EventDispatcherInterface $eventDispatcher, DataTransformerInterface $emailImportanceTransformer, DataTransformerInterface $emailBodyTypeTransformer)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/EmailBundle/Form/Handler/EmailApiHandler.php#L61 "Oro\Bundle\EmailBundle\Form\Handler\EmailApiHandler")</sup>
* The `AutoResponseRuleSubscriber::__construct(SecurityFacade $securityFacade)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/EmailBundle/Form/EventListener/AutoResponseRuleSubscriber.php#L24 "Oro\Bundle\EmailBundle\Form\EventListener\AutoResponseRuleSubscriber")</sup> method was changed to `AutoResponseRuleSubscriber::__construct(TokenAccessorInterface $tokenAccessor)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/EmailBundle/Form/EventListener/AutoResponseRuleSubscriber.php#L22 "Oro\Bundle\EmailBundle\Form\EventListener\AutoResponseRuleSubscriber")</sup>
* The `BuildTemplateFormSubscriber::__construct(SecurityContextInterface $securityContext)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/EmailBundle/Form/EventListener/BuildTemplateFormSubscriber.php#L30 "Oro\Bundle\EmailBundle\Form\EventListener\BuildTemplateFormSubscriber")</sup> method was changed to `BuildTemplateFormSubscriber::__construct(TokenStorageInterface $tokenStorage)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/EmailBundle/Form/EventListener/BuildTemplateFormSubscriber.php#L30 "Oro\Bundle\EmailBundle\Form\EventListener\BuildTemplateFormSubscriber")</sup>
* The `OriginTransformer::__construct(EntityManager $em, SecurityFacade $securityFacade, EmailOriginHelper $emailOriginHelper)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/EmailBundle/Form/DataTransformer/OriginTransformer.php#L41 "Oro\Bundle\EmailBundle\Form\DataTransformer\OriginTransformer")</sup> method was changed to `OriginTransformer::__construct(EntityManager $em, TokenAccessorInterface $tokenAccessor, EmailOriginHelper $emailOriginHelper)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/EmailBundle/Form/DataTransformer/OriginTransformer.php#L41 "Oro\Bundle\EmailBundle\Form\DataTransformer\OriginTransformer")</sup>
* The `EmailBodyAddListener::__construct(EmailAttachmentManager $attachmentManager, ConfigProvider $configProvider, EmailActivityListProvider $activityListProvider, ServiceLink $securityFacadeLink, ActivityListChainProvider $chainProvider, EntityManager $entityManager)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/EmailBundle/EventListener/EmailBodyAddListener.php#L47 "Oro\Bundle\EmailBundle\EventListener\EmailBodyAddListener")</sup> method was changed to `EmailBodyAddListener::__construct(EmailAttachmentManager $attachmentManager, ConfigProvider $configProvider, EmailActivityListProvider $activityListProvider, AuthorizationCheckerInterface $authorizationChecker, TokenStorageInterface $tokenStorage, ActivityListChainProvider $chainProvider, EntityManager $entityManager)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/EmailBundle/EventListener/EmailBodyAddListener.php#L52 "Oro\Bundle\EmailBundle\EventListener\EmailBodyAddListener")</sup>
* The `MailboxAuthorizationListener::__construct(Registry $registry, SecurityFacade $securityFacade)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/EmailBundle/EventListener/MailboxAuthorizationListener.php#L26 "Oro\Bundle\EmailBundle\EventListener\MailboxAuthorizationListener")</sup> method was changed to `MailboxAuthorizationListener::__construct(ManagerRegistry $registry, AuthorizationCheckerInterface $authorizationChecker, TokenAccessorInterface $tokenAccessor)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/EmailBundle/EventListener/MailboxAuthorizationListener.php#L32 "Oro\Bundle\EmailBundle\EventListener\MailboxAuthorizationListener")</sup>
* The `EmailGridListener::__construct(EmailQueryFactory $factory, SecurityFacade $securityFacade, GridViewManager $gridViewManager, ConfigManager $configManager)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/EmailBundle/EventListener/Datagrid/EmailGridListener.php#L51 "Oro\Bundle\EmailBundle\EventListener\Datagrid\EmailGridListener")</sup> method was changed to `EmailGridListener::__construct(EmailQueryFactory $factory, TokenAccessorInterface $tokenAccessor, GridViewManager $gridViewManager, ConfigManager $configManager, EmailGridResultHelper $resultHelper)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/EmailBundle/EventListener/Datagrid/EmailGridListener.php#L53 "Oro\Bundle\EmailBundle\EventListener\Datagrid\EmailGridListener")</sup>
* The `EmailManager::__construct(EntityManager $em, EmailThreadManager $emailThreadManager, EmailThreadProvider $emailThreadProvider, SecurityFacade $securityFacade, MailboxManager $mailboxManager)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/EmailBundle/Entity/Manager/EmailManager.php#L42 "Oro\Bundle\EmailBundle\Entity\Manager\EmailManager")</sup> method was changed to `EmailManager::__construct(EntityManager $em, EmailThreadManager $emailThreadManager, EmailThreadProvider $emailThreadProvider, TokenAccessorInterface $tokenAccessor, MailboxManager $mailboxManager)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/EmailBundle/Entity/Manager/EmailManager.php#L41 "Oro\Bundle\EmailBundle\Entity\Manager\EmailManager")</sup>
* The `EmailQueryFactory::__construct(EmailOwnerProviderStorage $emailOwnerProviderStorage, EntityNameResolver $entityNameResolver, MailboxManager $mailboxManager, SecurityFacade $securityFacade, FormFactoryInterface $formFactory, FilterUtility $filterUtil)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/EmailBundle/Datagrid/EmailQueryFactory.php#L54 "Oro\Bundle\EmailBundle\Datagrid\EmailQueryFactory")</sup> method was changed to `EmailQueryFactory::__construct(EmailOwnerProviderStorage $emailOwnerProviderStorage, EntityNameResolver $entityNameResolver, MailboxManager $mailboxManager, TokenAccessorInterface $tokenAccessor, FormFactoryInterface $formFactory, FilterUtility $filterUtil)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/EmailBundle/Datagrid/EmailQueryFactory.php#L50 "Oro\Bundle\EmailBundle\Datagrid\EmailQueryFactory")</sup>
* The `MailboxChoiceList::__construct(Registry $doctrine, SecurityFacade $securityFacade, MailboxManager $mailboxManager)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/EmailBundle/Datagrid/MailboxChoiceList.php#L29 "Oro\Bundle\EmailBundle\Datagrid\MailboxChoiceList")</sup> method was changed to `MailboxChoiceList::__construct(TokenAccessorInterface $tokenAccessor, MailboxManager $mailboxManager, MailboxNameHelper $mailboxNameHelper)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/EmailBundle/Datagrid/MailboxChoiceList.php#L26 "Oro\Bundle\EmailBundle\Datagrid\MailboxChoiceList")</sup>
* The `OriginFolderFilterProvider::__construct(Registry $doctrine, SecurityFacade $securityFacade)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/EmailBundle/Datagrid/OriginFolderFilterProvider.php#L27 "Oro\Bundle\EmailBundle\Datagrid\OriginFolderFilterProvider")</sup> method was changed to `OriginFolderFilterProvider::__construct(ManagerRegistry $doctrine, TokenAccessorInterface $tokenAccessor, MailboxNameHelper $mailboxNameHelper)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/EmailBundle/Datagrid/OriginFolderFilterProvider.php#L28 "Oro\Bundle\EmailBundle\Datagrid\OriginFolderFilterProvider")</sup>
* The `MarkMassActionHandler::__construct(EntityManager $entityManager, TranslatorInterface $translator, SecurityContext $securityContext, ServiceLink $securityFacadeLink, EmailManager $emailManager)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/EmailBundle/Datagrid/Extension/MassAction/MarkMassActionHandler.php#L69 "Oro\Bundle\EmailBundle\Datagrid\Extension\MassAction\MarkMassActionHandler")</sup> method was changed to `MarkMassActionHandler::__construct(EntityManager $entityManager, TranslatorInterface $translator, AuthorizationCheckerInterface $authorizationChecker, TokenAccessorInterface $tokenAccessor, EmailManager $emailManager)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/EmailBundle/Datagrid/Extension/MassAction/MarkMassActionHandler.php#L52 "Oro\Bundle\EmailBundle\Datagrid\Extension\MassAction\MarkMassActionHandler")</sup>
* The `EmailModelBuilderHelper::__construct(EntityRoutingHelper $entityRoutingHelper, EmailAddressHelper $emailAddressHelper, EntityNameResolver $entityNameResolver, SecurityFacade $securityFacade, EmailAddressManager $emailAddressManager, EntityManager $entityManager, EmailCacheManager $emailCacheManager, EngineInterface $engineInterface, MailboxManager $mailboxManager)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/EmailBundle/Builder/Helper/EmailModelBuilderHelper.php#L87 "Oro\Bundle\EmailBundle\Builder\Helper\EmailModelBuilderHelper")</sup> method was changed to `EmailModelBuilderHelper::__construct(EntityRoutingHelper $entityRoutingHelper, EmailAddressHelper $emailAddressHelper, EntityNameResolver $entityNameResolver, TokenAccessorInterface $tokenAccessor, EmailAddressManager $emailAddressManager, EntityManager $entityManager, EmailCacheManager $emailCacheManager, EngineInterface $engineInterface, MailboxManager $mailboxManager)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/EmailBundle/Builder/Helper/EmailModelBuilderHelper.php#L69 "Oro\Bundle\EmailBundle\Builder\Helper\EmailModelBuilderHelper")</sup>
* The `EmailOriginHelper::$securityFacade`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/EmailBundle/Tools/EmailOriginHelper.php#L40 "Oro\Bundle\EmailBundle\Tools\EmailOriginHelper::$securityFacade")</sup> property was removed.
* The following properties in class `EmailActivityListProvider`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/EmailBundle/Provider/EmailActivityListProvider.php#L77 "Oro\Bundle\EmailBundle\Provider\EmailActivityListProvider")</sup> were removed:
   - `$securityContextLink::$securityContextLink`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/EmailBundle/Provider/EmailActivityListProvider.php#L77 "Oro\Bundle\EmailBundle\Provider\EmailActivityListProvider::$securityContextLink")</sup>
   - `$securityFacadeLink::$securityFacadeLink`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/EmailBundle/Provider/EmailActivityListProvider.php#L80 "Oro\Bundle\EmailBundle\Provider\EmailActivityListProvider::$securityFacadeLink")</sup>
* The `LoggedUserVariablesProvider::$securityFacade`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/EmailBundle/Provider/LoggedUserVariablesProvider.php#L25 "Oro\Bundle\EmailBundle\Provider\LoggedUserVariablesProvider::$securityFacade")</sup> property was removed.
* The `RecentEmailRecipientsProvider::$securityFacade`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/EmailBundle/Provider/RecentEmailRecipientsProvider.php#L20 "Oro\Bundle\EmailBundle\Provider\RecentEmailRecipientsProvider::$securityFacade")</sup> property was removed.
* The `RelatedEmailsProvider::$securityFacade`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/EmailBundle/Provider/RelatedEmailsProvider.php#L33 "Oro\Bundle\EmailBundle\Provider\RelatedEmailsProvider::$securityFacade")</sup> property was removed.
* The `AutoResponseTemplateChoiceType::$securityFacade`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/EmailBundle/Form/Type/AutoResponseTemplateChoiceType.php#L22 "Oro\Bundle\EmailBundle\Form\Type\AutoResponseTemplateChoiceType::$securityFacade")</sup> property was removed.
* The `EmailAddressFromType::$securityFacade`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/EmailBundle/Form/Type/EmailAddressFromType.php#L18 "Oro\Bundle\EmailBundle\Form\Type\EmailAddressFromType::$securityFacade")</sup> property was removed.
* The `EmailOriginFromType::$securityFacade`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/EmailBundle/Form/Type/EmailOriginFromType.php#L26 "Oro\Bundle\EmailBundle\Form\Type\EmailOriginFromType::$securityFacade")</sup> property was removed.
* The `EmailType::$securityContext`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/EmailBundle/Form/Type/EmailType.php#L27 "Oro\Bundle\EmailBundle\Form\Type\EmailType::$securityContext")</sup> property was removed.
* The `EmailApiHandler::$securityFacade`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/EmailBundle/Form/Handler/EmailApiHandler.php#L37 "Oro\Bundle\EmailBundle\Form\Handler\EmailApiHandler::$securityFacade")</sup> property was removed.
* The `AutoResponseRuleSubscriber::$securityFacade`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/EmailBundle/Form/EventListener/AutoResponseRuleSubscriber.php#L19 "Oro\Bundle\EmailBundle\Form\EventListener\AutoResponseRuleSubscriber::$securityFacade")</sup> property was removed.
* The `BuildTemplateFormSubscriber::$securityContext`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/EmailBundle/Form/EventListener/BuildTemplateFormSubscriber.php#L25 "Oro\Bundle\EmailBundle\Form\EventListener\BuildTemplateFormSubscriber::$securityContext")</sup> property was removed.
* The `OriginTransformer::$securityFacade`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/EmailBundle/Form/DataTransformer/OriginTransformer.php#L27 "Oro\Bundle\EmailBundle\Form\DataTransformer\OriginTransformer::$securityFacade")</sup> property was removed.
* The `EmailBodyAddListener::$securityFacade`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/EmailBundle/EventListener/EmailBodyAddListener.php#L31 "Oro\Bundle\EmailBundle\EventListener\EmailBodyAddListener::$securityFacade")</sup> property was removed.
* The `MailboxAuthorizationListener::$securityFacade`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/EmailBundle/EventListener/MailboxAuthorizationListener.php#L20 "Oro\Bundle\EmailBundle\EventListener\MailboxAuthorizationListener::$securityFacade")</sup> property was removed.
* The `EmailGridListener::$securityFacade`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/EmailBundle/EventListener/Datagrid/EmailGridListener.php#L30 "Oro\Bundle\EmailBundle\EventListener\Datagrid\EmailGridListener::$securityFacade")</sup> property was removed.
* The `EmailManager::$securityFacade`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/EmailBundle/Entity/Manager/EmailManager.php#L28 "Oro\Bundle\EmailBundle\Entity\Manager\EmailManager::$securityFacade")</sup> property was removed.
* The following properties in class `EmailQueryFactory`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/EmailBundle/Datagrid/EmailQueryFactory.php#L32 "Oro\Bundle\EmailBundle\Datagrid\EmailQueryFactory")</sup> were removed:
   - `$fromEmailExpression::$fromEmailExpression`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/EmailBundle/Datagrid/EmailQueryFactory.php#L32 "Oro\Bundle\EmailBundle\Datagrid\EmailQueryFactory::$fromEmailExpression")</sup>
   - `$securityFacade::$securityFacade`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/EmailBundle/Datagrid/EmailQueryFactory.php#L38 "Oro\Bundle\EmailBundle\Datagrid\EmailQueryFactory::$securityFacade")</sup>
* The `OriginFolderFilterProvider::$securityFacade`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/EmailBundle/Datagrid/OriginFolderFilterProvider.php#L18 "Oro\Bundle\EmailBundle\Datagrid\OriginFolderFilterProvider::$securityFacade")</sup> property was removed.
* The following properties in class `MarkMassActionHandler`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/EmailBundle/Datagrid/Extension/MassAction/MarkMassActionHandler.php#L39 "Oro\Bundle\EmailBundle\Datagrid\Extension\MassAction\MarkMassActionHandler")</sup> were removed:
   - `$securityContext::$securityContext`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/EmailBundle/Datagrid/Extension/MassAction/MarkMassActionHandler.php#L39 "Oro\Bundle\EmailBundle\Datagrid\Extension\MassAction\MarkMassActionHandler::$securityContext")</sup>
   - `$user::$user`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/EmailBundle/Datagrid/Extension/MassAction/MarkMassActionHandler.php#L44 "Oro\Bundle\EmailBundle\Datagrid\Extension\MassAction\MarkMassActionHandler::$user")</sup>
   - `$securityFacade::$securityFacade`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/EmailBundle/Datagrid/Extension/MassAction/MarkMassActionHandler.php#L57 "Oro\Bundle\EmailBundle\Datagrid\Extension\MassAction\MarkMassActionHandler::$securityFacade")</sup>
* The `EmailModelBuilderHelper::$securityFacade`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/EmailBundle/Builder/Helper/EmailModelBuilderHelper.php#L49 "Oro\Bundle\EmailBundle\Builder\Helper\EmailModelBuilderHelper::$securityFacade")</sup> property was removed.
* The `EmailActivityListProvider::setSecurityContextLink`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/EmailBundle/Provider/EmailActivityListProvider.php#L135 "Oro\Bundle\EmailBundle\Provider\EmailActivityListProvider::setSecurityContextLink")</sup> method was removed.
* The `EmailQueryFactory::prepareQuery`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/EmailBundle/Datagrid/EmailQueryFactory.php#L74 "Oro\Bundle\EmailBundle\Datagrid\EmailQueryFactory::prepareQuery")</sup> method was removed.

EntityBundle
------------
* The `EntityDataApiManager::__construct(EntityFieldManager $entityDataManager, AuthorizationChecker $securityService, EntityRoutingHelper $entityRoutingHelper)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/EntityBundle/Manager/Api/EntityDataApiManager.php#L28 "Oro\Bundle\EntityBundle\Manager\Api\EntityDataApiManager")</sup> method was changed to `EntityDataApiManager::__construct(EntityFieldManager $entityDataManager, AuthorizationCheckerInterface $authorizationChecker, EntityRoutingHelper $entityRoutingHelper)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/EntityBundle/Manager/Api/EntityDataApiManager.php#L28 "Oro\Bundle\EntityBundle\Manager\Api\EntityDataApiManager")</sup>
* The `NavigationListener::__construct(SecurityFacade $securityFacade, ConfigManager $configManager, TranslatorInterface $translator)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/EntityBundle/EventListener/NavigationListener.php#L31 "Oro\Bundle\EntityBundle\EventListener\NavigationListener")</sup> method was changed to `NavigationListener::__construct(AuthorizationCheckerInterface $authorizationChecker, TokenAccessorInterface $tokenAccessor, ConfigManager $configManager, TranslatorInterface $translator)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/EntityBundle/EventListener/NavigationListener.php#L36 "Oro\Bundle\EntityBundle\EventListener\NavigationListener")</sup>
* The `EntityFieldManager::__construct(Registry $registry, FormBuilder $formBuilder, EntityApiBaseHandler $handler, EntityRoutingHelper $entityRoutingHelper, OwnershipMetadataProvider $ownershipMetadataProvider, EntityFieldValidator $entityFieldValidator)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/EntityBundle/Entity/Manager/Field/EntityFieldManager.php#L56 "Oro\Bundle\EntityBundle\Entity\Manager\Field\EntityFieldManager")</sup> method was changed to `EntityFieldManager::__construct(Registry $registry, FormBuilder $formBuilder, EntityApiBaseHandler $handler, EntityRoutingHelper $entityRoutingHelper, OwnershipMetadataProviderInterface $ownershipMetadataProvider, EntityFieldValidator $entityFieldValidator)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/EntityBundle/Entity/Manager/Field/EntityFieldManager.php#L56 "Oro\Bundle\EntityBundle\Entity\Manager\Field\EntityFieldManager")</sup>
* The `EntityDataApiManager::$securityService`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/EntityBundle/Manager/Api/EntityDataApiManager.php#L18 "Oro\Bundle\EntityBundle\Manager\Api\EntityDataApiManager::$securityService")</sup> property was removed.
* The `NavigationListener::$securityFacade`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/EntityBundle/EventListener/NavigationListener.php#L18 "Oro\Bundle\EntityBundle\EventListener\NavigationListener::$securityFacade")</sup> property was removed.

EntityConfigBundle
------------------
* The following methods in class `AttributeFormViewListener`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/EntityConfigBundle/EventListener/AttributeFormViewListener.php#L155 "Oro\Bundle\EntityConfigBundle\EventListener\AttributeFormViewListener")</sup> were removed:
   - `onFormRender::onFormRender`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/EntityConfigBundle/EventListener/AttributeFormViewListener.php#L155 "Oro\Bundle\EntityConfigBundle\EventListener\AttributeFormViewListener::onFormRender")</sup>
   - `onViewRender::onViewRender`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/EntityConfigBundle/EventListener/AttributeFormViewListener.php#L163 "Oro\Bundle\EntityConfigBundle\EventListener\AttributeFormViewListener::onViewRender")</sup>
* The `AttributeFamilyActionsConfiguration::__construct(SecurityFacade $securityFacade, EntityManager $entityManager)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/EntityConfigBundle/Datagrid/AttributeFamilyActionsConfiguration.php#L22 "Oro\Bundle\EntityConfigBundle\Datagrid\AttributeFamilyActionsConfiguration")</sup> method was changed to `AttributeFamilyActionsConfiguration::__construct(AuthorizationCheckerInterface $authorizationChecker, EntityManager $entityManager)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/EntityConfigBundle/Datagrid/AttributeFamilyActionsConfiguration.php#L24 "Oro\Bundle\EntityConfigBundle\Datagrid\AttributeFamilyActionsConfiguration")</sup>

EntityExtendBundle
------------------
* The `ExtendClassLoader`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/EntityExtendBundle/Tools/ExtendClassLoader.php#L12 "Oro\Bundle\EntityExtendBundle\Tools\ExtendClassLoader")</sup> class was removed.
* The `ExtendFieldValueRenderListener::__construct(ConfigManager $configManager, UrlGeneratorInterface $router, ManagerRegistry $registry, SecurityFacade $securityFacade, EntityClassNameHelper $entityClassNameHelper)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/EntityExtendBundle/EventListener/ExtendFieldValueRenderListener.php#L70 "Oro\Bundle\EntityExtendBundle\EventListener\ExtendFieldValueRenderListener")</sup> method was changed to `ExtendFieldValueRenderListener::__construct(ConfigManager $configManager, UrlGeneratorInterface $router, ManagerRegistry $registry, AuthorizationCheckerInterface $authorizationChecker, EntityClassNameHelper $entityClassNameHelper)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/EntityExtendBundle/EventListener/ExtendFieldValueRenderListener.php#L56 "Oro\Bundle\EntityExtendBundle\EventListener\ExtendFieldValueRenderListener")</sup>
* The `ExtendFieldValueRenderListener::$securityFacade`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/EntityExtendBundle/EventListener/ExtendFieldValueRenderListener.php#L56 "Oro\Bundle\EntityExtendBundle\EventListener\ExtendFieldValueRenderListener::$securityFacade")</sup> property was removed.

EntityPaginationBundle
----------------------
* The `StorageDataCollector::__construct(ServiceLink $dataGridManagerLink, DoctrineHelper $doctrineHelper, AclHelper $aclHelper, EntityPaginationStorage $storage, EntityPaginationManager $paginationManager)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/EntityPaginationBundle/Storage/StorageDataCollector.php#L54 "Oro\Bundle\EntityPaginationBundle\Storage\StorageDataCollector")</sup> method was changed to `StorageDataCollector::__construct(ServiceLink $dataGridManagerLink, DoctrineHelper $doctrineHelper, EntityPaginationStorage $storage, EntityPaginationManager $paginationManager)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/EntityPaginationBundle/Storage/StorageDataCollector.php#L46 "Oro\Bundle\EntityPaginationBundle\Storage\StorageDataCollector")</sup>
* The `EntityPaginationNavigation::__construct(DoctrineHelper $doctrineHelper, SecurityFacade $securityFacade, EntityPaginationStorage $storage)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/EntityPaginationBundle/Navigation/EntityPaginationNavigation.php#L36 "Oro\Bundle\EntityPaginationBundle\Navigation\EntityPaginationNavigation")</sup> method was changed to `EntityPaginationNavigation::__construct(DoctrineHelper $doctrineHelper, AuthorizationCheckerInterface $authorizationChecker, EntityPaginationStorage $storage)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/EntityPaginationBundle/Navigation/EntityPaginationNavigation.php#L37 "Oro\Bundle\EntityPaginationBundle\Navigation\EntityPaginationNavigation")</sup>
* The `StorageDataCollector::$aclHelper`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/EntityPaginationBundle/Storage/StorageDataCollector.php#L35 "Oro\Bundle\EntityPaginationBundle\Storage\StorageDataCollector::$aclHelper")</sup> property was removed.
* The `EntityPaginationNavigation::$securityFacade`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/EntityPaginationBundle/Navigation/EntityPaginationNavigation.php#L23 "Oro\Bundle\EntityPaginationBundle\Navigation\EntityPaginationNavigation::$securityFacade")</sup> property was removed.

FilterBundle
------------
* The `NumberFilterType::setDefaultOptions`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/FilterBundle/Form/Type/Filter/NumberFilterType.php#L57 "Oro\Bundle\FilterBundle\Form\Type\Filter\NumberFilterType::setDefaultOptions")</sup> method was removed.

FormBundle
----------
* The `MultipleEntityType::__construct(DoctrineHelper $doctrineHelper, SecurityFacade $securityFacade)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/FormBundle/Form/Type/MultipleEntityType.php#L27 "Oro\Bundle\FormBundle\Form\Type\MultipleEntityType")</sup> method was changed to `MultipleEntityType::__construct(DoctrineHelper $doctrineHelper, AuthorizationCheckerInterface $authorizationChecker)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/FormBundle/Form/Type/MultipleEntityType.php#L27 "Oro\Bundle\FormBundle\Form\Type\MultipleEntityType")</sup>
* The `OroEntitySelectOrCreateInlineType::__construct(SecurityFacade $securityFacade, ConfigManager $configManager, EntityManager $entityManager, SearchRegistry $searchRegistry)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/FormBundle/Form/Type/OroEntitySelectOrCreateInlineType.php#L46 "Oro\Bundle\FormBundle\Form\Type\OroEntitySelectOrCreateInlineType")</sup> method was changed to `OroEntitySelectOrCreateInlineType::__construct(AuthorizationCheckerInterface $authorizationChecker, ConfigManager $configManager, EntityManager $entityManager, SearchRegistry $searchRegistry)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/FormBundle/Form/Type/OroEntitySelectOrCreateInlineType.php#L45 "Oro\Bundle\FormBundle\Form\Type\OroEntitySelectOrCreateInlineType")</sup>
* The `RelatedEntityTransformer::__construct(DoctrineHelper $doctrineHelper, EntityClassNameHelper $entityClassNameHelper, SecurityFacade $securityFacade)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/FormBundle/Form/DataTransformer/RelatedEntityTransformer.php#L31 "Oro\Bundle\FormBundle\Form\DataTransformer\RelatedEntityTransformer")</sup> method was changed to `RelatedEntityTransformer::__construct(DoctrineHelper $doctrineHelper, EntityClassNameHelper $entityClassNameHelper, AuthorizationCheckerInterface $authorizationChecker)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/FormBundle/Form/DataTransformer/RelatedEntityTransformer.php#L31 "Oro\Bundle\FormBundle\Form\DataTransformer\RelatedEntityTransformer")</sup>
* The `Security::__construct(SecurityFacade $securityFacade)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/FormBundle/Autocomplete/Security.php#L19 "Oro\Bundle\FormBundle\Autocomplete\Security")</sup> method was changed to `Security::__construct(AuthorizationCheckerInterface $authorizationChecker)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/FormBundle/Autocomplete/Security.php#L18 "Oro\Bundle\FormBundle\Autocomplete\Security")</sup>
* The `MultipleEntityType::$securityFacade`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/FormBundle/Form/Type/MultipleEntityType.php#L21 "Oro\Bundle\FormBundle\Form\Type\MultipleEntityType::$securityFacade")</sup> property was removed.
* The `OroEntitySelectOrCreateInlineType::$securityFacade`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/FormBundle/Form/Type/OroEntitySelectOrCreateInlineType.php#L29 "Oro\Bundle\FormBundle\Form\Type\OroEntitySelectOrCreateInlineType::$securityFacade")</sup> property was removed.
* The `RelatedEntityTransformer::$securityFacade`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/FormBundle/Form/DataTransformer/RelatedEntityTransformer.php#L24 "Oro\Bundle\FormBundle\Form\DataTransformer\RelatedEntityTransformer::$securityFacade")</sup> property was removed.
* The `Security::$securityFacade`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/FormBundle/Autocomplete/Security.php#L12 "Oro\Bundle\FormBundle\Autocomplete\Security::$securityFacade")</sup> property was removed.

ImapBundle
----------
* The `ConfigurationGmailType::__construct(TranslatorInterface $translator, ConfigManager $userConfigManager, SecurityFacade $securityFacade)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/ImapBundle/Form/Type/ConfigurationGmailType.php#L43 "Oro\Bundle\ImapBundle\Form\Type\ConfigurationGmailType")</sup> method was changed to `ConfigurationGmailType::__construct(TranslatorInterface $translator, ConfigManager $userConfigManager, TokenAccessorInterface $tokenAccessor)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/ImapBundle/Form/Type/ConfigurationGmailType.php#L43 "Oro\Bundle\ImapBundle\Form\Type\ConfigurationGmailType")</sup>
* The `ConfigurationType::__construct(Mcrypt $encryptor, SecurityFacade $securityFacade, TranslatorInterface $translator)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/ImapBundle/Form/Type/ConfigurationType.php#L43 "Oro\Bundle\ImapBundle\Form\Type\ConfigurationType")</sup> method was changed to `ConfigurationType::__construct(Mcrypt $encryptor, TokenAccessorInterface $tokenAccessor, TranslatorInterface $translator)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/ImapBundle/Form/Type/ConfigurationType.php#L43 "Oro\Bundle\ImapBundle\Form\Type\ConfigurationType")</sup>
* The `ConfigurationGmailType::$securityFacade`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/ImapBundle/Form/Type/ConfigurationGmailType.php#L36 "Oro\Bundle\ImapBundle\Form\Type\ConfigurationGmailType::$securityFacade")</sup> property was removed.
* The `ConfigurationType::$securityFacade`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/ImapBundle/Form/Type/ConfigurationType.php#L33 "Oro\Bundle\ImapBundle\Form\Type\ConfigurationType::$securityFacade")</sup> property was removed.

ImportExportBundle
------------------
* The `ImportStrategyHelper::__construct(ManagerRegistry $managerRegistry, ValidatorInterface $validator, TranslatorInterface $translator, FieldHelper $fieldHelper, ConfigurableTableDataConverter $configurableDataConverter, SecurityFacade $securityFacade)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/ImportExportBundle/Strategy/Import/ImportStrategyHelper.php#L67 "Oro\Bundle\ImportExportBundle\Strategy\Import\ImportStrategyHelper")</sup> method was changed to `ImportStrategyHelper::__construct(ManagerRegistry $managerRegistry, ValidatorInterface $validator, TranslatorInterface $translator, FieldHelper $fieldHelper, ConfigurableTableDataConverter $configurableDataConverter, AuthorizationCheckerInterface $authorizationChecker, TokenAccessorInterface $tokenAccessor)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/ImportExportBundle/Strategy/Import/ImportStrategyHelper.php#L60 "Oro\Bundle\ImportExportBundle\Strategy\Import\ImportStrategyHelper")</sup>
* The `EntityReader::__construct(ContextRegistry $contextRegistry, ManagerRegistry $registry, OwnershipMetadataProvider $ownershipMetadata)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/ImportExportBundle/Reader/EntityReader.php#L42 "Oro\Bundle\ImportExportBundle\Reader\EntityReader")</sup> method was changed to `EntityReader::__construct(ContextRegistry $contextRegistry, ManagerRegistry $registry, OwnershipMetadataProviderInterface $ownershipMetadata)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/ImportExportBundle/Reader/EntityReader.php#L43 "Oro\Bundle\ImportExportBundle\Reader\EntityReader")</sup>
* The `JobExecutor::__construct(ConnectorRegistry $jobRegistry, DoctrineJobRepository $batchJobRepository, ContextRegistry $contextRegistry, ManagerRegistry $managerRegistry)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/ImportExportBundle/Job/JobExecutor.php#L84 "Oro\Bundle\ImportExportBundle\Job\JobExecutor")</sup> method was changed to `JobExecutor::__construct(ConnectorRegistry $jobRegistry, DoctrineJobRepository $batchJobRepository, ContextRegistry $contextRegistry, ManagerRegistry $managerRegistry, ContextAggregatorRegistry $contextAggregatorRegistry)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/ImportExportBundle/Job/JobExecutor.php#L78 "Oro\Bundle\ImportExportBundle\Job\JobExecutor")</sup>
* The `DatabaseHelper::__construct(ManagerRegistry $registry, DoctrineHelper $doctrineHelper, ServiceLink $fieldHelperLink, ServiceLink $securityFacadeLink, ServiceLink $ownershipMetadataProviderLink)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/ImportExportBundle/Field/DatabaseHelper.php#L60 "Oro\Bundle\ImportExportBundle\Field\DatabaseHelper")</sup> method was changed to `DatabaseHelper::__construct(ManagerRegistry $registry, DoctrineHelper $doctrineHelper, ServiceLink $fieldHelperLink, TokenAccessorInterface $tokenAccessor, ServiceLink $ownershipMetadataProviderLink)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/ImportExportBundle/Field/DatabaseHelper.php#L61 "Oro\Bundle\ImportExportBundle\Field\DatabaseHelper")</sup>
* The `ImportStrategyHelper::$securityFacade`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/ImportExportBundle/Strategy/Import/ImportStrategyHelper.php#L57 "Oro\Bundle\ImportExportBundle\Strategy\Import\ImportStrategyHelper::$securityFacade")</sup> property was removed.
* The `DatabaseHelper::$securityFacadeLink`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/ImportExportBundle/Field/DatabaseHelper.php#L41 "Oro\Bundle\ImportExportBundle\Field\DatabaseHelper::$securityFacadeLink")</sup> property was removed.

InstallerBundle
---------------
* The `ScriptHandler::checkComposerPlugin`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/InstallerBundle/Composer/ScriptHandler.php#L140 "Oro\Bundle\InstallerBundle\Composer\ScriptHandler::checkComposerPlugin")</sup> method was removed.

IntegrationBundle
-----------------
* The `ReverseSyncProcessor::processExport($jobName, array $configuration)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/IntegrationBundle/Provider/ReverseSyncProcessor.php#L62 "Oro\Bundle\IntegrationBundle\Provider\ReverseSyncProcessor")</sup> method was changed to `ReverseSyncProcessor::processExport(Channel $integration, ConnectorInterface $connector, array $configuration)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/IntegrationBundle/Provider/ReverseSyncProcessor.php#L89 "Oro\Bundle\IntegrationBundle\Provider\ReverseSyncProcessor")</sup>
* The `SyncProcessor::processImport(ConnectorInterface $connector, $jobName, $configuration, Channel $integration)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/IntegrationBundle/Provider/SyncProcessor.php#L258 "Oro\Bundle\IntegrationBundle\Provider\SyncProcessor")</sup> method was changed to `SyncProcessor::processImport(Channel $integration, ConnectorInterface $connector, array $configuration)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/IntegrationBundle/Provider/SyncProcessor.php#L265 "Oro\Bundle\IntegrationBundle\Provider\SyncProcessor")</sup>
* The `GuzzleRestClient::getXML`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/IntegrationBundle/Provider/Rest/Client/Guzzle/GuzzleRestClient.php#L95 "Oro\Bundle\IntegrationBundle\Provider\Rest\Client\Guzzle\GuzzleRestClient::getXML")</sup> method was removed.
* The following methods in class `GuzzleRestResponse`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/IntegrationBundle/Provider/Rest/Client/Guzzle/GuzzleRestResponse.php#L88 "Oro\Bundle\IntegrationBundle\Provider\Rest\Client\Guzzle\GuzzleRestResponse")</sup> were removed:
   - `getRawHeaders::getRawHeaders`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/IntegrationBundle/Provider/Rest/Client/Guzzle/GuzzleRestResponse.php#L88 "Oro\Bundle\IntegrationBundle\Provider\Rest\Client\Guzzle\GuzzleRestResponse::getRawHeaders")</sup>
   - `getContentEncoding::getContentEncoding`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/IntegrationBundle/Provider/Rest/Client/Guzzle/GuzzleRestResponse.php#L128 "Oro\Bundle\IntegrationBundle\Provider\Rest\Client\Guzzle\GuzzleRestResponse::getContentEncoding")</sup>
   - `getContentLanguage::getContentLanguage`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/IntegrationBundle/Provider/Rest/Client/Guzzle/GuzzleRestResponse.php#L136 "Oro\Bundle\IntegrationBundle\Provider\Rest\Client\Guzzle\GuzzleRestResponse::getContentLanguage")</sup>
   - `getContentLength::getContentLength`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/IntegrationBundle/Provider/Rest/Client/Guzzle/GuzzleRestResponse.php#L144 "Oro\Bundle\IntegrationBundle\Provider\Rest\Client\Guzzle\GuzzleRestResponse::getContentLength")</sup>
   - `getContentLocation::getContentLocation`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/IntegrationBundle/Provider/Rest/Client/Guzzle/GuzzleRestResponse.php#L152 "Oro\Bundle\IntegrationBundle\Provider\Rest\Client\Guzzle\GuzzleRestResponse::getContentLocation")</sup>
   - `getContentDisposition::getContentDisposition`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/IntegrationBundle/Provider/Rest/Client/Guzzle/GuzzleRestResponse.php#L160 "Oro\Bundle\IntegrationBundle\Provider\Rest\Client\Guzzle\GuzzleRestResponse::getContentDisposition")</sup>
   - `getContentMd5::getContentMd5`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/IntegrationBundle/Provider/Rest/Client/Guzzle/GuzzleRestResponse.php#L168 "Oro\Bundle\IntegrationBundle\Provider\Rest\Client\Guzzle\GuzzleRestResponse::getContentMd5")</sup>
   - `getContentRange::getContentRange`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/IntegrationBundle/Provider/Rest/Client/Guzzle/GuzzleRestResponse.php#L176 "Oro\Bundle\IntegrationBundle\Provider\Rest\Client\Guzzle\GuzzleRestResponse::getContentRange")</sup>
   - `getContentType::getContentType`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/IntegrationBundle/Provider/Rest/Client/Guzzle/GuzzleRestResponse.php#L184 "Oro\Bundle\IntegrationBundle\Provider\Rest\Client\Guzzle\GuzzleRestResponse::getContentType")</sup>
   - `isContentType::isContentType`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/IntegrationBundle/Provider/Rest/Client/Guzzle/GuzzleRestResponse.php#L192 "Oro\Bundle\IntegrationBundle\Provider\Rest\Client\Guzzle\GuzzleRestResponse::isContentType")</sup>
   - `xml::xml`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/IntegrationBundle/Provider/Rest/Client/Guzzle/GuzzleRestResponse.php#L261 "Oro\Bundle\IntegrationBundle\Provider\Rest\Client\Guzzle\GuzzleRestResponse::xml")</sup>
   - `getRedirectCount::getRedirectCount`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/IntegrationBundle/Provider/Rest/Client/Guzzle/GuzzleRestResponse.php#L274 "Oro\Bundle\IntegrationBundle\Provider\Rest\Client\Guzzle\GuzzleRestResponse::getRedirectCount")</sup>
   - `getEffectiveUrl::getEffectiveUrl`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/IntegrationBundle/Provider/Rest/Client/Guzzle/GuzzleRestResponse.php#L282 "Oro\Bundle\IntegrationBundle\Provider\Rest\Client\Guzzle\GuzzleRestResponse::getEffectiveUrl")</sup>
* The `DefaultOwnerHelper::__construct(RegistryInterface $registry, OwnershipMetadataProvider $ownershipMetadataProvider)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/IntegrationBundle/ImportExport/Helper/DefaultOwnerHelper.php#L27 "Oro\Bundle\IntegrationBundle\ImportExport\Helper\DefaultOwnerHelper")</sup> method was changed to `DefaultOwnerHelper::__construct(RegistryInterface $registry, OwnershipMetadataProviderInterface $ownershipMetadataProvider)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/IntegrationBundle/ImportExport/Helper/DefaultOwnerHelper.php#L27 "Oro\Bundle\IntegrationBundle\ImportExport\Helper\DefaultOwnerHelper")</sup>
* The `DefaultOwnerSubscriber::__construct(SecurityFacade $securityFacade, TypesRegistry $typesRegistry)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/IntegrationBundle/Form/EventListener/DefaultOwnerSubscriber.php#L26 "Oro\Bundle\IntegrationBundle\Form\EventListener\DefaultOwnerSubscriber")</sup> method was changed to `DefaultOwnerSubscriber::__construct(TokenAccessorInterface $tokenAccessor, TypesRegistry $typesRegistry)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/IntegrationBundle/Form/EventListener/DefaultOwnerSubscriber.php#L27 "Oro\Bundle\IntegrationBundle\Form\EventListener\DefaultOwnerSubscriber")</sup>
* The `DefaultOwnerSubscriber::$securityFacade`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/IntegrationBundle/Form/EventListener/DefaultOwnerSubscriber.php#L18 "Oro\Bundle\IntegrationBundle\Form\EventListener\DefaultOwnerSubscriber::$securityFacade")</sup> property was removed.
* The following methods in class `IntegrationController`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/IntegrationBundle/Controller/IntegrationController.php#L188 "Oro\Bundle\IntegrationBundle\Controller\IntegrationController")</sup> were removed:
   - `getSyncScheduler::getSyncScheduler`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/IntegrationBundle/Controller/IntegrationController.php#L188 "Oro\Bundle\IntegrationBundle\Controller\IntegrationController::getSyncScheduler")</sup>
   - `getTypeRegistry::getTypeRegistry`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/IntegrationBundle/Controller/IntegrationController.php#L196 "Oro\Bundle\IntegrationBundle\Controller\IntegrationController::getTypeRegistry")</sup>
   - `getLogger::getLogger`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/IntegrationBundle/Controller/IntegrationController.php#L204 "Oro\Bundle\IntegrationBundle\Controller\IntegrationController::getLogger")</sup>

MigrationBundle
---------------
* The following methods in class `LoadDataFixturesCommand`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/MigrationBundle/Command/LoadDataFixturesCommand.php#L204 "Oro\Bundle\MigrationBundle\Command\LoadDataFixturesCommand")</sup> were removed:
   - `disableDefaultListeners::disableDefaultListeners`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/MigrationBundle/Command/LoadDataFixturesCommand.php#L204 "Oro\Bundle\MigrationBundle\Command\LoadDataFixturesCommand::disableDefaultListeners")</sup>
   - `enableDefaultListeners::enableDefaultListeners`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/MigrationBundle/Command/LoadDataFixturesCommand.php#L209 "Oro\Bundle\MigrationBundle\Command\LoadDataFixturesCommand::enableDefaultListeners")</sup>
   - `scheduleSearchReindexAndUpdateEmailAssociation::scheduleSearchReindexAndUpdateEmailAssociation`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/MigrationBundle/Command/LoadDataFixturesCommand.php#L214 "Oro\Bundle\MigrationBundle\Command\LoadDataFixturesCommand::scheduleSearchReindexAndUpdateEmailAssociation")</sup>
   - `checkDisableListeners::checkDisableListeners`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/MigrationBundle/Command/LoadDataFixturesCommand.php#L228 "Oro\Bundle\MigrationBundle\Command\LoadDataFixturesCommand::checkDisableListeners")</sup>
   - `getListenersToDisable::getListenersToDisable`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/MigrationBundle/Command/LoadDataFixturesCommand.php#L239 "Oro\Bundle\MigrationBundle\Command\LoadDataFixturesCommand::getListenersToDisable")</sup>
   - `getOptionalListenerManager::getOptionalListenerManager`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/MigrationBundle/Command/LoadDataFixturesCommand.php#L252 "Oro\Bundle\MigrationBundle\Command\LoadDataFixturesCommand::getOptionalListenerManager")</sup>
   - `getSearchIndexer::getSearchIndexer`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/MigrationBundle/Command/LoadDataFixturesCommand.php#L260 "Oro\Bundle\MigrationBundle\Command\LoadDataFixturesCommand::getSearchIndexer")</sup>
   - `getProducer::getProducer`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/MigrationBundle/Command/LoadDataFixturesCommand.php#L268 "Oro\Bundle\MigrationBundle\Command\LoadDataFixturesCommand::getProducer")</sup>

NavigationBundle
----------------
* The `AclAwareMenuFactoryExtension::__construct(RouterInterface $router, ServiceLink $securityFacadeLink)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/NavigationBundle/Menu/AclAwareMenuFactoryExtension.php#L63 "Oro\Bundle\NavigationBundle\Menu\AclAwareMenuFactoryExtension")</sup> method was changed to `AclAwareMenuFactoryExtension::__construct(RouterInterface $router, AuthorizationCheckerInterface $authorizationChecker, ClassAuthorizationChecker $classAuthorizationChecker, TokenAccessorInterface $tokenAccessor)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/NavigationBundle/Menu/AclAwareMenuFactoryExtension.php#L64 "Oro\Bundle\NavigationBundle\Menu\AclAwareMenuFactoryExtension")</sup>
* The `NavigationItemBuilder::__construct(SecurityContextInterface $securityContext, EntityManager $em, ItemFactory $factory, Router $router)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/NavigationBundle/Menu/NavigationItemBuilder.php#L49 "Oro\Bundle\NavigationBundle\Menu\NavigationItemBuilder")</sup> method was changed to `NavigationItemBuilder::__construct(TokenAccessorInterface $tokenAccessor, EntityManager $em, ItemFactory $factory, RouterInterface $router)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/NavigationBundle/Menu/NavigationItemBuilder.php#L41 "Oro\Bundle\NavigationBundle\Menu\NavigationItemBuilder")</sup>
* The `PageStateHandler::__construct(FormInterface $form, Request $request, ObjectManager $manager, SecurityContextInterface $security)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/NavigationBundle/Form/Handler/PageStateHandler.php#L42 "Oro\Bundle\NavigationBundle\Form\Handler\PageStateHandler")</sup> method was changed to `PageStateHandler::__construct(FormInterface $form, Request $request, ObjectManager $manager, TokenStorageInterface $tokenStorage)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/NavigationBundle/Form/Handler/PageStateHandler.php#L42 "Oro\Bundle\NavigationBundle\Form\Handler\PageStateHandler")</sup>
* The `NavigationListener::__construct(SecurityFacade $securityFacade)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/NavigationBundle/EventListener/NavigationListener.php#L17 "Oro\Bundle\NavigationBundle\EventListener\NavigationListener")</sup> method was changed to `NavigationListener::__construct(AuthorizationCheckerInterface $authorizationChecker, TokenAccessorInterface $tokenAccessor)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/NavigationBundle/EventListener/NavigationListener.php#L23 "Oro\Bundle\NavigationBundle\EventListener\NavigationListener")</sup>
* The `ResponseHashnavListener::__construct(SecurityContextInterface $security, EngineInterface $templating, $isDebug = false)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/NavigationBundle/Event/ResponseHashnavListener.php#L32 "Oro\Bundle\NavigationBundle\Event\ResponseHashnavListener")</sup> method was changed to `ResponseHashnavListener::__construct(TokenStorageInterface $tokenStorage, EngineInterface $templating, $isDebug = false)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/NavigationBundle/Event/ResponseHashnavListener.php#L32 "Oro\Bundle\NavigationBundle\Event\ResponseHashnavListener")</sup>
* The `ResponseHistoryListener::__construct(ItemFactory $navigationItemFactory, SecurityContextInterface $securityContext, ManagerRegistry $registry, TitleServiceInterface $titleService)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/NavigationBundle/Event/ResponseHistoryListener.php#L56 "Oro\Bundle\NavigationBundle\Event\ResponseHistoryListener")</sup> method was changed to `ResponseHistoryListener::__construct(ItemFactory $navigationItemFactory, TokenStorageInterface $tokenStorage, ManagerRegistry $registry, TitleServiceInterface $titleService)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/NavigationBundle/Event/ResponseHistoryListener.php#L56 "Oro\Bundle\NavigationBundle\Event\ResponseHistoryListener")</sup>
* The `PinbarPostPersist::postPersist(LifecycleEventArgs $args)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/NavigationBundle/Entity/Listener/PinbarPostPersist.php#L27 "Oro\Bundle\NavigationBundle\Entity\Listener\PinbarPostPersist")</sup> method was changed to `PinbarPostPersist::postPersist(AbstractPinbarTab $pinbarTab, LifecycleEventArgs $args)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/NavigationBundle/Entity/Listener/PinbarPostPersist.php#L15 "Oro\Bundle\NavigationBundle\Entity\Listener\PinbarPostPersist")</sup>
* The `NavigationHistoryBuilder::setOptions`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/NavigationBundle/Menu/NavigationHistoryBuilder.php#L42 "Oro\Bundle\NavigationBundle\Menu\NavigationHistoryBuilder::setOptions")</sup> method was removed.
* The `NavigationMostviewedBuilder::setOptions`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/NavigationBundle/Menu/NavigationMostviewedBuilder.php#L19 "Oro\Bundle\NavigationBundle\Menu\NavigationMostviewedBuilder::setOptions")</sup> method was removed.
* The `PinbarPostPersist::setClassName`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/NavigationBundle/Entity/Listener/PinbarPostPersist.php#L20 "Oro\Bundle\NavigationBundle\Entity\Listener\PinbarPostPersist::setClassName")</sup> method was removed.
* The `PageStateHandler::$security`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/NavigationBundle/Form/Handler/PageStateHandler.php#L33 "Oro\Bundle\NavigationBundle\Form\Handler\PageStateHandler::$security")</sup> property was removed.
* The `NavigationListener::$securityFacade`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/NavigationBundle/EventListener/NavigationListener.php#L12 "Oro\Bundle\NavigationBundle\EventListener\NavigationListener::$securityFacade")</sup> property was removed.
* The `ResponseHashnavListener::$security`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/NavigationBundle/Event/ResponseHashnavListener.php#L15 "Oro\Bundle\NavigationBundle\Event\ResponseHashnavListener::$security")</sup> property was removed.
* The `ResponseHistoryListener::$securityContext`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/NavigationBundle/Event/ResponseHistoryListener.php#L42 "Oro\Bundle\NavigationBundle\Event\ResponseHistoryListener::$securityContext")</sup> property was removed.
* The `PinbarPostPersist::$className`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/NavigationBundle/Entity/Listener/PinbarPostPersist.php#L13 "Oro\Bundle\NavigationBundle\Entity\Listener\PinbarPostPersist::$className")</sup> property was removed.

NoteBundle
----------
* The `NoteManager::__construct(EntityManager $em, SecurityFacade $securityFacade, AclHelper $aclHelper, EntityNameResolver $entityNameResolver, AttachmentProvider $attachmentProvider, AttachmentManager $attachmentManager)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/NoteBundle/Entity/Manager/NoteManager.php#L41 "Oro\Bundle\NoteBundle\Entity\Manager\NoteManager")</sup> method was changed to `NoteManager::__construct(EntityManager $em, AuthorizationCheckerInterface $authorizationChecker, AclHelper $aclHelper, EntityNameResolver $entityNameResolver, AttachmentProvider $attachmentProvider, AttachmentManager $attachmentManager)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/NoteBundle/Entity/Manager/NoteManager.php#L42 "Oro\Bundle\NoteBundle\Entity\Manager\NoteManager")</sup>
* The `NoteManager::$securityFacade`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/NoteBundle/Entity/Manager/NoteManager.php#L22 "Oro\Bundle\NoteBundle\Entity\Manager\NoteManager::$securityFacade")</sup> property was removed.

NotificationBundle
------------------
* The `EmailNotificationApiType`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/NotificationBundle/Form/Type/EmailNotificationApiType.php#L10 "Oro\Bundle\NotificationBundle\Form\Type\EmailNotificationApiType")</sup> class was removed.
* The `EmailNotificationType::setDefaultOptions`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/NotificationBundle/Form/Type/EmailNotificationType.php#L124 "Oro\Bundle\NotificationBundle\Form\Type\EmailNotificationType::setDefaultOptions")</sup> method was removed.
* The following methods in class `RecipientListType`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/NotificationBundle/Form/Type/RecipientListType.php#L18 "Oro\Bundle\NotificationBundle\Form\Type\RecipientListType")</sup> were removed:
   - `__construct::__construct`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/NotificationBundle/Form/Type/RecipientListType.php#L18 "Oro\Bundle\NotificationBundle\Form\Type\RecipientListType::__construct")</sup>
   - `setDefaultOptions::setDefaultOptions`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/NotificationBundle/Form/Type/RecipientListType.php#L71 "Oro\Bundle\NotificationBundle\Form\Type\RecipientListType::setDefaultOptions")</sup>
* The `EmailNotificationType::__construct(BuildTemplateFormSubscriber $subscriber, ConfigProvider $ownershipConfigProvider, RouterInterface $router)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/NotificationBundle/Form/Type/EmailNotificationType.php#L36 "Oro\Bundle\NotificationBundle\Form\Type\EmailNotificationType")</sup> method was changed to `EmailNotificationType::__construct(BuildTemplateFormSubscriber $buildTemplateSubscriber, AdditionalEmailsSubscriber $additionalEmailsSubscriber, ConfigProvider $ownershipConfigProvider, RouterInterface $router)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/NotificationBundle/Form/Type/EmailNotificationType.php#L45 "Oro\Bundle\NotificationBundle\Form\Type\EmailNotificationType")</sup>
* The following methods in class `EmailNotificationHandler`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/NotificationBundle/Form/Handler/EmailNotificationHandler.php#L23 "Oro\Bundle\NotificationBundle\Form\Handler\EmailNotificationHandler")</sup> were changed:
  > - `__construct(FormInterface $form, Request $request, ObjectManager $manager)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/NotificationBundle/Form/Handler/EmailNotificationHandler.php#L34 "Oro\Bundle\NotificationBundle\Form\Handler\EmailNotificationHandler")</sup>
  > - `__construct(ManagerRegistry $registry)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/NotificationBundle/Form/Handler/EmailNotificationHandler.php#L23 "Oro\Bundle\NotificationBundle\Form\Handler\EmailNotificationHandler")</sup>

  > - `process(EmailNotification $entity)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/NotificationBundle/Form/Handler/EmailNotificationHandler.php#L47 "Oro\Bundle\NotificationBundle\Form\Handler\EmailNotificationHandler")</sup>
  > - `process($data, FormInterface $form, Request $request)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/NotificationBundle/Form/Handler/EmailNotificationHandler.php#L31 "Oro\Bundle\NotificationBundle\Form\Handler\EmailNotificationHandler")</sup>

  > - `__construct(EmailNotificationManager $manager, EntityManager $em, ConfigProvider $configProvider)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/NotificationBundle/Event/Handler/EmailNotificationHandler.php#L34 "Oro\Bundle\NotificationBundle\Event\Handler\EmailNotificationHandler")</sup>
  > - `__construct(EmailNotificationManager $manager, EntityManager $em, ConfigProvider $configProvider, PropertyAccessor $propertyAccessor)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/NotificationBundle/Event/Handler/EmailNotificationHandler.php#L34 "Oro\Bundle\NotificationBundle\Event\Handler\EmailNotificationHandler")</sup>

* The `EmailNotificationAdapter::__construct($entity, EmailNotification $notification, EntityManager $em, ConfigProvider $configProvider)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/NotificationBundle/Event/Handler/EmailNotificationAdapter.php#L43 "Oro\Bundle\NotificationBundle\Event\Handler\EmailNotificationAdapter")</sup> method was changed to `EmailNotificationAdapter::__construct($entity, EmailNotification $notification, EntityManager $em, ConfigProvider $configProvider, PropertyAccessor $propertyAccessor)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/NotificationBundle/Event/Handler/EmailNotificationAdapter.php#L43 "Oro\Bundle\NotificationBundle\Event\Handler\EmailNotificationAdapter")</sup>
* The following methods in class `EmailNotificationController`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/NotificationBundle/Controller/EmailNotificationController.php#L56 "Oro\Bundle\NotificationBundle\Controller\EmailNotificationController")</sup> were changed:
  > - `updateAction(EmailNotification $entity)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/NotificationBundle/Controller/EmailNotificationController.php#L48 "Oro\Bundle\NotificationBundle\Controller\EmailNotificationController")</sup>
  > - `updateAction(EmailNotification $entity, Request $request)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/NotificationBundle/Controller/EmailNotificationController.php#L56 "Oro\Bundle\NotificationBundle\Controller\EmailNotificationController")</sup>

  > - `createAction()`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/NotificationBundle/Controller/EmailNotificationController.php#L63 "Oro\Bundle\NotificationBundle\Controller\EmailNotificationController")</sup>
  > - `createAction(Request $request)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/NotificationBundle/Controller/EmailNotificationController.php#L75 "Oro\Bundle\NotificationBundle\Controller\EmailNotificationController")</sup>

* The following properties in class `EmailNotificationType`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/NotificationBundle/Form/Type/EmailNotificationType.php#L21 "Oro\Bundle\NotificationBundle\Form\Type\EmailNotificationType")</sup> were removed:
   - `$ownershipEntities::$ownershipEntities`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/NotificationBundle/Form/Type/EmailNotificationType.php#L21 "Oro\Bundle\NotificationBundle\Form\Type\EmailNotificationType::$ownershipEntities")</sup>
   - `$subscriber::$subscriber`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/NotificationBundle/Form/Type/EmailNotificationType.php#L26 "Oro\Bundle\NotificationBundle\Form\Type\EmailNotificationType::$subscriber")</sup>
* The `RecipientListType::$entityManager`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/NotificationBundle/Form/Type/RecipientListType.php#L16 "Oro\Bundle\NotificationBundle\Form\Type\RecipientListType::$entityManager")</sup> property was removed.
* The following properties in class `EmailNotificationHandler`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/NotificationBundle/Form/Handler/EmailNotificationHandler.php#L17 "Oro\Bundle\NotificationBundle\Form\Handler\EmailNotificationHandler")</sup> were removed:
   - `$form::$form`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/NotificationBundle/Form/Handler/EmailNotificationHandler.php#L17 "Oro\Bundle\NotificationBundle\Form\Handler\EmailNotificationHandler::$form")</sup>
   - `$request::$request`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/NotificationBundle/Form/Handler/EmailNotificationHandler.php#L22 "Oro\Bundle\NotificationBundle\Form\Handler\EmailNotificationHandler::$request")</sup>
   - `$manager::$manager`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/NotificationBundle/Form/Handler/EmailNotificationHandler.php#L27 "Oro\Bundle\NotificationBundle\Form\Handler\EmailNotificationHandler::$manager")</sup>
* The `EmailNotificationController::update(EmailNotification $entity)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/NotificationBundle/Controller/EmailNotificationController.php#L72 "Oro\Bundle\NotificationBundle\Controller\EmailNotificationController")</sup> method was changed to `EmailNotificationController::update(EmailNotification $entity, Request $request)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/NotificationBundle/Controller/EmailNotificationController.php#L86 "Oro\Bundle\NotificationBundle\Controller\EmailNotificationController")</sup>

OrganizationBundle
------------------
* The `OrganizationUniqueEntityValidator::__construct(ManagerRegistry $registry, OwnershipMetadataProvider $metadataProvider, DoctrineHelper $doctrineHelper)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/OrganizationBundle/Validator/Constraints/OrganizationUniqueEntityValidator.php#L26 "Oro\Bundle\OrganizationBundle\Validator\Constraints\OrganizationUniqueEntityValidator")</sup> method was changed to `OrganizationUniqueEntityValidator::__construct(ManagerRegistry $registry, OwnershipMetadataProviderInterface $metadataProvider, DoctrineHelper $doctrineHelper)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/OrganizationBundle/Validator/Constraints/OrganizationUniqueEntityValidator.php#L26 "Oro\Bundle\OrganizationBundle\Validator\Constraints\OrganizationUniqueEntityValidator")</sup>
* The `OwnerValidator::__construct(ManagerRegistry $doctrine, BusinessUnitManager $businessUnitManager, OwnershipMetadataProvider $ownershipMetadataProvider, EntityOwnerAccessor $ownerAccessor, SecurityFacade $securityFacade, OwnerTreeProvider $treeProvider, AclVoter $aclVoter)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/OrganizationBundle/Validator/Constraints/OwnerValidator.php#L57 "Oro\Bundle\OrganizationBundle\Validator\Constraints\OwnerValidator")</sup> method was changed to `OwnerValidator::__construct(ManagerRegistry $doctrine, BusinessUnitManager $businessUnitManager, OwnershipMetadataProviderInterface $ownershipMetadataProvider, EntityOwnerAccessor $ownerAccessor, AuthorizationCheckerInterface $authorizationChecker, TokenAccessorInterface $tokenAccessor, OwnerTreeProvider $treeProvider, AclVoter $aclVoter)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/OrganizationBundle/Validator/Constraints/OwnerValidator.php#L62 "Oro\Bundle\OrganizationBundle\Validator\Constraints\OwnerValidator")</sup>
* The `OwnershipEntityConfigDumperExtension::__construct(ConfigManager $configManager, RelationBuilder $relationBuilder, OwnershipMetadataProvider $ownershipMetadataProvider)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/OrganizationBundle/Tools/OwnershipEntityConfigDumperExtension.php#L32 "Oro\Bundle\OrganizationBundle\Tools\OwnershipEntityConfigDumperExtension")</sup> method was changed to `OwnershipEntityConfigDumperExtension::__construct(ConfigManager $configManager, RelationBuilder $relationBuilder, OwnershipMetadataProviderInterface $ownershipMetadataProvider)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/OrganizationBundle/Tools/OwnershipEntityConfigDumperExtension.php#L32 "Oro\Bundle\OrganizationBundle\Tools\OwnershipEntityConfigDumperExtension")</sup>
* The `BusinessUnitAclProvider::__construct(SecurityFacade $securityFacade, AclVoter $aclVoter, OwnerTreeProvider $treeProvider)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/OrganizationBundle/Provider/BusinessUnitAclProvider.php#L33 "Oro\Bundle\OrganizationBundle\Provider\BusinessUnitAclProvider")</sup> method was changed to `BusinessUnitAclProvider::__construct(AuthorizationCheckerInterface $authorizationChecker, TokenAccessorInterface $tokenAccessor, AclVoter $aclVoter, OwnerTreeProvider $treeProvider)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/OrganizationBundle/Provider/BusinessUnitAclProvider.php#L39 "Oro\Bundle\OrganizationBundle\Provider\BusinessUnitAclProvider")</sup>
* The `ChoiceTreeBusinessUnitProvider::__construct(Registry $registry, SecurityFacade $securityFacade, AclHelper $aclHelper, ChainOwnerTreeProvider $treeProvider)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/OrganizationBundle/Provider/Filter/ChoiceTreeBusinessUnitProvider.php#L37 "Oro\Bundle\OrganizationBundle\Provider\Filter\ChoiceTreeBusinessUnitProvider")</sup> method was changed to `ChoiceTreeBusinessUnitProvider::__construct(Registry $registry, TokenAccessorInterface $tokenAccessor, AclHelper $aclHelper, ChainOwnerTreeProvider $treeProvider)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/OrganizationBundle/Provider/Filter/ChoiceTreeBusinessUnitProvider.php#L35 "Oro\Bundle\OrganizationBundle\Provider\Filter\ChoiceTreeBusinessUnitProvider")</sup>
* The `OwnerDeletionManager::__construct(OwnerAssignmentCheckerInterface $defaultChecker, ConfigProvider $ownershipProvider, OwnershipMetadataProvider $ownershipMetadata, EntityManager $em, ObjectIdAccessor $objectIdAccessor)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/OrganizationBundle/Ownership/OwnerDeletionManager.php#L53 "Oro\Bundle\OrganizationBundle\Ownership\OwnerDeletionManager")</sup> method was changed to `OwnerDeletionManager::__construct(OwnerAssignmentCheckerInterface $defaultChecker, ConfigProvider $ownershipProvider, OwnershipMetadataProviderInterface $ownershipMetadata, EntityManager $em, ObjectIdAccessor $objectIdAccessor)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/OrganizationBundle/Ownership/OwnerDeletionManager.php#L53 "Oro\Bundle\OrganizationBundle\Ownership\OwnerDeletionManager")</sup>
* The `OrganizationFixture::__construct(SecurityFacade $securityFacade)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/OrganizationBundle/ImportExport/TemplateFixture/OrganizationFixture.php#L24 "Oro\Bundle\OrganizationBundle\ImportExport\TemplateFixture\OrganizationFixture")</sup> method was changed to `OrganizationFixture::__construct(TokenAccessorInterface $tokenAccessor)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/OrganizationBundle/ImportExport/TemplateFixture/OrganizationFixture.php#L20 "Oro\Bundle\OrganizationBundle\ImportExport\TemplateFixture\OrganizationFixture")</sup>
* The `BusinessUnitSelectType::__construct(Registry $doctrine, SecurityFacade $securityFacade)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/OrganizationBundle/Form/Type/BusinessUnitSelectType.php#L26 "Oro\Bundle\OrganizationBundle\Form\Type\BusinessUnitSelectType")</sup> method was changed to `BusinessUnitSelectType::__construct(Registry $doctrine, TokenAccessorInterface $tokenAccessor)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/OrganizationBundle/Form/Type/BusinessUnitSelectType.php#L24 "Oro\Bundle\OrganizationBundle\Form\Type\BusinessUnitSelectType")</sup>
* The `BusinessUnitType::__construct(BusinessUnitManager $businessUnitManager, SecurityFacade $securityFacade)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/OrganizationBundle/Form/Type/BusinessUnitType.php#L29 "Oro\Bundle\OrganizationBundle\Form\Type\BusinessUnitType")</sup> method was changed to `BusinessUnitType::__construct(BusinessUnitManager $businessUnitManager, TokenAccessorInterface $tokenAccessor)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/OrganizationBundle/Form/Type/BusinessUnitType.php#L26 "Oro\Bundle\OrganizationBundle\Form\Type\BusinessUnitType")</sup>
* The `OrganizationType::__construct(SecurityContext $securityContext)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/OrganizationBundle/Form/Type/OrganizationType.php#L22 "Oro\Bundle\OrganizationBundle\Form\Type\OrganizationType")</sup> method was changed to `OrganizationType::__construct(TokenAccessorInterface $tokenAccessor)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/OrganizationBundle/Form/Type/OrganizationType.php#L21 "Oro\Bundle\OrganizationBundle\Form\Type\OrganizationType")</sup>
* The `OrganizationsSelectType::__construct(EntityManager $em, BusinessUnitManager $buManager, SecurityFacade $securityFacade)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/OrganizationBundle/Form/Type/OrganizationsSelectType.php#L36 "Oro\Bundle\OrganizationBundle\Form\Type\OrganizationsSelectType")</sup> method was changed to `OrganizationsSelectType::__construct(EntityManager $em, BusinessUnitManager $buManager, TokenAccessorInterface $tokenAccessor)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/OrganizationBundle/Form/Type/OrganizationsSelectType.php#L36 "Oro\Bundle\OrganizationBundle\Form\Type\OrganizationsSelectType")</sup>
* The `OrganizationFormExtension::__construct(ManagerRegistry $registry, ServiceLink $securityFacadeLink, ServiceLink $metadataProviderLink)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/OrganizationBundle/Form/Extension/OrganizationFormExtension.php#L49 "Oro\Bundle\OrganizationBundle\Form\Extension\OrganizationFormExtension")</sup> method was changed to `OrganizationFormExtension::__construct(ManagerRegistry $registry, TokenAccessorInterface $tokenAccessor, ServiceLink $metadataProviderLink)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/OrganizationBundle/Form/Extension/OrganizationFormExtension.php#L41 "Oro\Bundle\OrganizationBundle\Form\Extension\OrganizationFormExtension")</sup>
* The `OwnerFormExtension::__construct(DoctrineHelper $doctrineHelper, OwnershipMetadataProvider $ownershipMetadataProvider, BusinessUnitManager $businessUnitManager, SecurityFacade $securityFacade, AclVoter $aclVoter, OwnerTreeProvider $treeProvider, EntityOwnerAccessor $entityOwnerAccessor)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/OrganizationBundle/Form/Extension/OwnerFormExtension.php#L96 "Oro\Bundle\OrganizationBundle\Form\Extension\OwnerFormExtension")</sup> method was changed to `OwnerFormExtension::__construct(DoctrineHelper $doctrineHelper, OwnershipMetadataProviderInterface $ownershipMetadataProvider, BusinessUnitManager $businessUnitManager, AuthorizationCheckerInterface $authorizationChecker, TokenAccessorInterface $tokenAccessor, AclVoter $aclVoter, OwnerTreeProvider $treeProvider, EntityOwnerAccessor $entityOwnerAccessor)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/OrganizationBundle/Form/Extension/OwnerFormExtension.php#L101 "Oro\Bundle\OrganizationBundle\Form\Extension\OwnerFormExtension")</sup>
* The `RecordOwnerDataListener::__construct(ServiceLink $securityContextLink, ConfigProvider $configProvider)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/OrganizationBundle/EventListener/RecordOwnerDataListener.php#L29 "Oro\Bundle\OrganizationBundle\EventListener\RecordOwnerDataListener")</sup> method was changed to `RecordOwnerDataListener::__construct(TokenAccessor $tokenAccessor, ConfigProvider $configProvider)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/OrganizationBundle/EventListener/RecordOwnerDataListener.php#L30 "Oro\Bundle\OrganizationBundle\EventListener\RecordOwnerDataListener")</sup>
* The `BusinessUnitGridListener::__construct(ServiceLink $securityContextLink, OwnerTreeProvider $treeProvider, AclVoter $aclVoter = null)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/OrganizationBundle/Event/BusinessUnitGridListener.php#L25 "Oro\Bundle\OrganizationBundle\Event\BusinessUnitGridListener")</sup> method was changed to `BusinessUnitGridListener::__construct(AuthorizationCheckerInterface $authorizationChecker, TokenAccessorInterface $tokenAccessor, OwnerTreeProvider $treeProvider, AclVoter $aclVoter = null)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/OrganizationBundle/Event/BusinessUnitGridListener.php#L34 "Oro\Bundle\OrganizationBundle\Event\BusinessUnitGridListener")</sup>
* The `ImportStrategyListener::__construct(ManagerRegistry $registry, ServiceLink $securityFacadeLink, ServiceLink $metadataProviderLink)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/OrganizationBundle/Event/ImportStrategyListener.php#L55 "Oro\Bundle\OrganizationBundle\Event\ImportStrategyListener")</sup> method was changed to `ImportStrategyListener::__construct(ManagerRegistry $registry, TokenAccessorInterface $tokenAccessor, ServiceLink $metadataProviderLink)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/OrganizationBundle/Event/ImportStrategyListener.php#L43 "Oro\Bundle\OrganizationBundle\Event\ImportStrategyListener")</sup>
* The `BusinessUnitManager::__construct(EntityManager $em, SecurityFacade $securityFacade, AclHelper $aclHelper)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/OrganizationBundle/Entity/Manager/BusinessUnitManager.php#L31 "Oro\Bundle\OrganizationBundle\Entity\Manager\BusinessUnitManager")</sup> method was changed to `BusinessUnitManager::__construct(EntityManager $em, TokenAccessorInterface $tokenAccessor, AclHelper $aclHelper)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/OrganizationBundle/Entity/Manager/BusinessUnitManager.php#L33 "Oro\Bundle\OrganizationBundle\Entity\Manager\BusinessUnitManager")</sup>
* The `OrganizationSearchHandler::__construct($className, $fields, $displayFields, ManagerRegistry $managerRegistry, ServiceLink $securityContextLink)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/OrganizationBundle/Autocomplete/OrganizationSearchHandler.php#L41 "Oro\Bundle\OrganizationBundle\Autocomplete\OrganizationSearchHandler")</sup> method was changed to `OrganizationSearchHandler::__construct($className, $fields, $displayFields, ManagerRegistry $managerRegistry, TokenAccessorInterface $tokenAccessor)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/OrganizationBundle/Autocomplete/OrganizationSearchHandler.php#L41 "Oro\Bundle\OrganizationBundle\Autocomplete\OrganizationSearchHandler")</sup>
* The `OwnerValidator::$securityFacade`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/OrganizationBundle/Validator/Constraints/OwnerValidator.php#L37 "Oro\Bundle\OrganizationBundle\Validator\Constraints\OwnerValidator::$securityFacade")</sup> property was removed.
* The `BusinessUnitAclProvider::$securityFacade`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/OrganizationBundle/Provider/BusinessUnitAclProvider.php#L14 "Oro\Bundle\OrganizationBundle\Provider\BusinessUnitAclProvider::$securityFacade")</sup> property was removed.
* The `ChoiceTreeBusinessUnitProvider::$securityFacade`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/OrganizationBundle/Provider/Filter/ChoiceTreeBusinessUnitProvider.php#L26 "Oro\Bundle\OrganizationBundle\Provider\Filter\ChoiceTreeBusinessUnitProvider::$securityFacade")</sup> property was removed.
* The `OrganizationFixture::$securityFacade`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/OrganizationBundle/ImportExport/TemplateFixture/OrganizationFixture.php#L14 "Oro\Bundle\OrganizationBundle\ImportExport\TemplateFixture\OrganizationFixture::$securityFacade")</sup> property was removed.
* The `BusinessUnitType::$securityFacade`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/OrganizationBundle/Form/Type/BusinessUnitType.php#L23 "Oro\Bundle\OrganizationBundle\Form\Type\BusinessUnitType::$securityFacade")</sup> property was removed.
* The `OrganizationType::$securityContext`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/OrganizationBundle/Form/Type/OrganizationType.php#L20 "Oro\Bundle\OrganizationBundle\Form\Type\OrganizationType::$securityContext")</sup> property was removed.
* The `OrganizationsSelectType::$securityFacade`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/OrganizationBundle/Form/Type/OrganizationsSelectType.php#L29 "Oro\Bundle\OrganizationBundle\Form\Type\OrganizationsSelectType::$securityFacade")</sup> property was removed.
* The `OrganizationFormExtension::$securityFacadeLink`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/OrganizationBundle/Form/Extension/OrganizationFormExtension.php#L32 "Oro\Bundle\OrganizationBundle\Form\Extension\OrganizationFormExtension::$securityFacadeLink")</sup> property was removed.
* The `OwnerFormExtension::$securityFacade`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/OrganizationBundle/Form/Extension/OwnerFormExtension.php#L58 "Oro\Bundle\OrganizationBundle\Form\Extension\OwnerFormExtension::$securityFacade")</sup> property was removed.
* The `RecordOwnerDataListener::$securityContextLink`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/OrganizationBundle/EventListener/RecordOwnerDataListener.php#L20 "Oro\Bundle\OrganizationBundle\EventListener\RecordOwnerDataListener::$securityContextLink")</sup> property was removed.
* The `BusinessUnitGridListener::$securityContextLink`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/OrganizationBundle/Event/BusinessUnitGridListener.php#L17 "Oro\Bundle\OrganizationBundle\Event\BusinessUnitGridListener::$securityContextLink")</sup> property was removed.
* The `ImportStrategyListener::$securityFacadeLink`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/OrganizationBundle/Event/ImportStrategyListener.php#L28 "Oro\Bundle\OrganizationBundle\Event\ImportStrategyListener::$securityFacadeLink")</sup> property was removed.
* The `BusinessUnitManager::$securityFacade`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/OrganizationBundle/Entity/Manager/BusinessUnitManager.php#L23 "Oro\Bundle\OrganizationBundle\Entity\Manager\BusinessUnitManager::$securityFacade")</sup> property was removed.
* The `BusinessUnitTreeSearchHandler::$securityFacade`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/OrganizationBundle/Autocomplete/BusinessUnitTreeSearchHandler.php#L10 "Oro\Bundle\OrganizationBundle\Autocomplete\BusinessUnitTreeSearchHandler::$securityFacade")</sup> property was removed.
* The `OrganizationSearchHandler::$securityContextLink`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/OrganizationBundle/Autocomplete/OrganizationSearchHandler.php#L29 "Oro\Bundle\OrganizationBundle\Autocomplete\OrganizationSearchHandler::$securityContextLink")</sup> property was removed.
* The `ChoiceTreeBusinessUnitProvider::getUser`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/OrganizationBundle/Provider/Filter/ChoiceTreeBusinessUnitProvider.php#L105 "Oro\Bundle\OrganizationBundle\Provider\Filter\ChoiceTreeBusinessUnitProvider::getUser")</sup> method was removed.
* The `RecordOwnerDataListener::getSecurityContext`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/OrganizationBundle/EventListener/RecordOwnerDataListener.php#L94 "Oro\Bundle\OrganizationBundle\EventListener\RecordOwnerDataListener::getSecurityContext")</sup> method was removed.
* The `BusinessUnitGridListener::getSecurityContext`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/OrganizationBundle/Event/BusinessUnitGridListener.php#L81 "Oro\Bundle\OrganizationBundle\Event\BusinessUnitGridListener::getSecurityContext")</sup> method was removed.
* The `BusinessUnitManager::getOrganizationContextId`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/OrganizationBundle/Entity/Manager/BusinessUnitManager.php#L316 "Oro\Bundle\OrganizationBundle\Entity\Manager\BusinessUnitManager::getOrganizationContextId")</sup> method was removed.
* The `BusinessUnitTreeSearchHandler::setSecurityFacade`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/OrganizationBundle/Autocomplete/BusinessUnitTreeSearchHandler.php#L15 "Oro\Bundle\OrganizationBundle\Autocomplete\BusinessUnitTreeSearchHandler::setSecurityFacade")</sup> method was removed.

PhpUtils
--------
* Added class `Oro\Component\PhpUtils\ClassLoader`, it is a simple and fast implementation of the class loader that can be used to map one namespace to one path.
* The deprecated `QueryUtil`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Component/PhpUtils/QueryUtil.php#L10 "Oro\Component\PhpUtils\QueryUtil")</sup> class was removed. Use `Oro\Component\DoctrineUtils\ORM\QueryBuilderUtil` instead.

ReportBundle
------------
* The `ReportDatagridConfigurationProvider::__construct(ReportDatagridConfigurationBuilder $builder, ManagerRegistry $doctrine)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/ReportBundle/Grid/ReportDatagridConfigurationProvider.php#L34 "Oro\Bundle\ReportBundle\Grid\ReportDatagridConfigurationProvider")</sup> method was changed to `ReportDatagridConfigurationProvider::__construct(ReportDatagridConfigurationBuilder $builder, ManagerRegistry $doctrine, Cache $reportCacheManager, $prefixCacheKey)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/ReportBundle/Grid/ReportDatagridConfigurationProvider.php#L43 "Oro\Bundle\ReportBundle\Grid\ReportDatagridConfigurationProvider")</sup>
* The `StoreSqlExtension::__construct(SecurityFacade $securityFacade)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/ReportBundle/Grid/StoreSqlExtension.php#L26 "Oro\Bundle\ReportBundle\Grid\StoreSqlExtension")</sup> method was changed to `StoreSqlExtension::__construct(AuthorizationCheckerInterface $authorizationChecker, TokenAccessorInterface $tokenAccessor)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/ReportBundle/Grid/StoreSqlExtension.php#L30 "Oro\Bundle\ReportBundle\Grid\StoreSqlExtension")</sup>
* The `NavigationListener::__construct(EntityManager $entityManager, ConfigProvider $entityConfigProvider, SecurityFacade $securityFacade, AclHelper $aclHelper, FeatureChecker $featureChecker)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/ReportBundle/EventListener/NavigationListener.php#L39 "Oro\Bundle\ReportBundle\EventListener\NavigationListener")</sup> method was changed to `NavigationListener::__construct(EntityManager $entityManager, ConfigProvider $entityConfigProvider, TokenAccessorInterface $tokenAccessor, AclHelper $aclHelper, FeatureChecker $featureChecker)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/ReportBundle/EventListener/NavigationListener.php#L41 "Oro\Bundle\ReportBundle\EventListener\NavigationListener")</sup>
* The `StoreSqlExtension::$securityFacade`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/ReportBundle/Grid/StoreSqlExtension.php#L19 "Oro\Bundle\ReportBundle\Grid\StoreSqlExtension::$securityFacade")</sup> property was removed.
* The `NavigationListener::$securityFacade`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/ReportBundle/EventListener/NavigationListener.php#L24 "Oro\Bundle\ReportBundle\EventListener\NavigationListener::$securityFacade")</sup> property was removed.

SearchBundle
------------
* The `ReindexDemoDataListener`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/SearchBundle/EventListener/ReindexDemoDataListener.php#L10 "Oro\Bundle\SearchBundle\EventListener\ReindexDemoDataListener")</sup> class was removed.
* The `SecurityProvider::__construct(SecurityFacade $securityFacade, EntitySecurityMetadataProvider $entitySecurityMetadataProvider)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/SearchBundle/Security/SecurityProvider.php#L20 "Oro\Bundle\SearchBundle\Security\SecurityProvider")</sup> method was changed to `SecurityProvider::__construct(AuthorizationCheckerInterface $authorizationChecker, EntitySecurityMetadataProvider $entitySecurityMetadataProvider)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/SearchBundle/Security/SecurityProvider.php#L21 "Oro\Bundle\SearchBundle\Security\SecurityProvider")</sup>
* The `SecurityProvider::$securityFacade`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/SearchBundle/Security/SecurityProvider.php#L13 "Oro\Bundle\SearchBundle\Security\SecurityProvider::$securityFacade")</sup> property was removed.

SecurityBundle
--------------
* The following classes were removed:
   - `AbstractMetadataProvider`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/SecurityBundle/Owner/Metadata/AbstractMetadataProvider.php#L16 "Oro\Bundle\SecurityBundle\Owner\Metadata\AbstractMetadataProvider")</sup>
   - `ChainMetadataProvider`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/SecurityBundle/Owner/Metadata/ChainMetadataProvider.php#L9 "Oro\Bundle\SecurityBundle\Owner\Metadata\ChainMetadataProvider")</sup>
* The `SecurityFacade::__construct(SecurityContextInterface $securityContext, AclAnnotationProvider $annotationProvider, ObjectIdentityFactory $objectIdentityFactory, EntityClassResolver $classResolver, LoggerInterface $logger)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/SecurityBundle/SecurityFacade.php#L44 "Oro\Bundle\SecurityBundle\SecurityFacade")</sup> method was changed to `SecurityFacade::__construct(AuthorizationCheckerInterface $authorizationChecker, RequestAuthorizationChecker $requestAuthorizationChecker, ClassAuthorizationChecker $classAuthorizationChecker, TokenStorageInterface $tokenStorage)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/SecurityBundle/SecurityFacade.php#L39 "Oro\Bundle\SecurityBundle\SecurityFacade")</sup>
* The `AclHelper::__construct(SearchMappingProvider $mappingProvider, SecurityFacade $securityFacade, OwnershipConditionDataBuilder $ownershipDataBuilder)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/SecurityBundle/Search/AclHelper.php#L29 "Oro\Bundle\SecurityBundle\Search\AclHelper")</sup> method was changed to `AclHelper::__construct(SearchMappingProvider $mappingProvider, TokenAccessorInterface $tokenAccessor, OwnershipConditionDataBuilder $ownershipDataBuilder, OwnershipMetadataProviderInterface $metadataProvider)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/SecurityBundle/Search/AclHelper.php#L34 "Oro\Bundle\SecurityBundle\Search\AclHelper")</sup>
* The `DoctrineParamConverter::__construct(ManagerRegistry $registry = null, SecurityFacade $securityFacade = null)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/SecurityBundle/Request/ParamConverter/DoctrineParamConverter.php#L24 "Oro\Bundle\SecurityBundle\Request\ParamConverter\DoctrineParamConverter")</sup> method was changed to `DoctrineParamConverter::__construct(ManagerRegistry $registry = null, RequestAuthorizationChecker $requestAuthorizationChecker = null)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/SecurityBundle/Request/ParamConverter/DoctrineParamConverter.php#L24 "Oro\Bundle\SecurityBundle\Request\ParamConverter\DoctrineParamConverter")</sup>
* The `EntityOwnerAccessor::__construct(MetadataProviderInterface $metadataProvider)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/SecurityBundle/Owner/EntityOwnerAccessor.php#L35 "Oro\Bundle\SecurityBundle\Owner\EntityOwnerAccessor")</sup> method was changed to `EntityOwnerAccessor::__construct(OwnershipMetadataProviderInterface $metadataProvider)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/SecurityBundle/Owner/EntityOwnerAccessor.php#L35 "Oro\Bundle\SecurityBundle\Owner\EntityOwnerAccessor")</sup>
* The `EntityOwnershipDecisionMaker::__construct(OwnerTreeProvider $treeProvider, ObjectIdAccessor $objectIdAccessor, EntityOwnerAccessor $entityOwnerAccessor, OwnershipMetadataProvider $metadataProvider)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/SecurityBundle/Owner/EntityOwnershipDecisionMaker.php#L50 "Oro\Bundle\SecurityBundle\Owner\EntityOwnershipDecisionMaker")</sup> method was changed to `EntityOwnershipDecisionMaker::__construct(OwnerTreeProviderInterface $treeProvider, ObjectIdAccessor $objectIdAccessor, EntityOwnerAccessor $entityOwnerAccessor, OwnershipMetadataProviderInterface $ownershipMetadataProvider, TokenAccessorInterface $tokenAccessor)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/SecurityBundle/Owner/EntityOwnershipDecisionMaker.php#L22 "Oro\Bundle\SecurityBundle\Owner\EntityOwnershipDecisionMaker")</sup>
* The `OwnerTreeProvider::__construct(ManagerRegistry $doctrine, DatabaseChecker $databaseChecker, CacheProvider $cache, MetadataProviderInterface $ownershipMetadataProvider, TokenStorageInterface $tokenStorage)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/SecurityBundle/Owner/OwnerTreeProvider.php#L38 "Oro\Bundle\SecurityBundle\Owner\OwnerTreeProvider")</sup> method was changed to `OwnerTreeProvider::__construct(ManagerRegistry $doctrine, DatabaseChecker $databaseChecker, CacheProvider $cache, OwnershipMetadataProviderInterface $ownershipMetadataProvider, TokenStorageInterface $tokenStorage)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/SecurityBundle/Owner/OwnerTreeProvider.php#L37 "Oro\Bundle\SecurityBundle\Owner\OwnerTreeProvider")</sup>
* The `OwnershipMetadataProvider::__construct(array $owningEntityNames, ConfigProvider $configProvider = null, EntityClassResolver $entityClassResolver = null, CacheProvider $cache = null)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/SecurityBundle/Owner/Metadata/OwnershipMetadataProvider.php#L55 "Oro\Bundle\SecurityBundle\Owner\Metadata\OwnershipMetadataProvider")</sup> method was changed to `OwnershipMetadataProvider::__construct(array $owningEntityNames, ConfigManager $configManager, EntityClassResolver $entityClassResolver, TokenAccessorInterface $tokenAccessor, CacheProvider $cache)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/SecurityBundle/Owner/Metadata/OwnershipMetadataProvider.php#L48 "Oro\Bundle\SecurityBundle\Owner\Metadata\OwnershipMetadataProvider")</sup>
* The `OwnershipConditionDataBuilder::__construct(ServiceLink $securityContextLink, ObjectIdAccessor $objectIdAccessor, EntitySecurityMetadataProvider $entityMetadataProvider, MetadataProviderInterface $metadataProvider, OwnerTreeProviderInterface $treeProvider, AclVoter $aclVoter = null)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/SecurityBundle/ORM/Walker/OwnershipConditionDataBuilder.php#L60 "Oro\Bundle\SecurityBundle\ORM\Walker\OwnershipConditionDataBuilder")</sup> method was changed to `OwnershipConditionDataBuilder::__construct(AuthorizationCheckerInterface $authorizationChecker, TokenStorageInterface $tokenStorage, ObjectIdAccessor $objectIdAccessor, EntitySecurityMetadataProvider $entityMetadataProvider, OwnershipMetadataProviderInterface $metadataProvider, OwnerTreeProviderInterface $treeProvider, AclVoter $aclVoter = null)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/SecurityBundle/ORM/Walker/OwnershipConditionDataBuilder.php#L64 "Oro\Bundle\SecurityBundle\ORM\Walker\OwnershipConditionDataBuilder")</sup>
* The `IsLoggedInContextConfigurator::__construct(SecurityFacade $securityFacade)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/SecurityBundle/Layout/Extension/IsLoggedInContextConfigurator.php#L21 "Oro\Bundle\SecurityBundle\Layout\Extension\IsLoggedInContextConfigurator")</sup> method was changed to `IsLoggedInContextConfigurator::__construct(TokenAccessorInterface $tokenAccessor)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/SecurityBundle/Layout/Extension/IsLoggedInContextConfigurator.php#L19 "Oro\Bundle\SecurityBundle\Layout\Extension\IsLoggedInContextConfigurator")</sup>
* The `AclProvider::__construct(SecurityFacade $securityFacade, ManagerRegistry $doctrine)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/SecurityBundle/Layout/DataProvider/AclProvider.php#L24 "Oro\Bundle\SecurityBundle\Layout\DataProvider\AclProvider")</sup> method was changed to `AclProvider::__construct(AuthorizationCheckerInterface $authorizationChecker, TokenAccessorInterface $tokenAccessor, ManagerRegistry $doctrine)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/SecurityBundle/Layout/DataProvider/AclProvider.php#L29 "Oro\Bundle\SecurityBundle\Layout\DataProvider\AclProvider")</sup>
* The `CurrentUserProvider::__construct(SecurityFacade $securityFacade)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/SecurityBundle/Layout/DataProvider/CurrentUserProvider.php#L15 "Oro\Bundle\SecurityBundle\Layout\DataProvider\CurrentUserProvider")</sup> method was changed to `CurrentUserProvider::__construct(TokenAccessorInterface $tokenAccessor)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/SecurityBundle/Layout/DataProvider/CurrentUserProvider.php#L15 "Oro\Bundle\SecurityBundle\Layout\DataProvider\CurrentUserProvider")</sup>
* The `OrganizationBasicAuthenticationListener::__construct(SecurityContextInterface $securityContext, AuthenticationManagerInterface $authenticationManager, $providerKey, AuthenticationEntryPointInterface $authenticationEntryPoint, OrganizationManager $manager, LoggerInterface $logger = null)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/SecurityBundle/Http/Firewall/OrganizationBasicAuthenticationListener.php#L54 "Oro\Bundle\SecurityBundle\Http\Firewall\OrganizationBasicAuthenticationListener")</sup> method was changed to `OrganizationBasicAuthenticationListener::__construct(TokenStorageInterface $tokenStorage, AuthenticationManagerInterface $authenticationManager, $providerKey, AuthenticationEntryPointInterface $authenticationEntryPoint, OrganizationManager $manager, LoggerInterface $logger = null)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/SecurityBundle/Http/Firewall/OrganizationBasicAuthenticationListener.php#L54 "Oro\Bundle\SecurityBundle\Http\Firewall\OrganizationBasicAuthenticationListener")</sup>
* The `FieldAclHelper::__construct(SecurityFacade $securityFacade, ConfigManager $configManager, DoctrineHelper $doctrineHelper)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/SecurityBundle/Form/FieldAclHelper.php#L33 "Oro\Bundle\SecurityBundle\Form\FieldAclHelper")</sup> method was changed to `FieldAclHelper::__construct(AuthorizationCheckerInterface $authorizationChecker, ConfigManager $configManager, DoctrineHelper $doctrineHelper)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/SecurityBundle/Form/FieldAclHelper.php#L33 "Oro\Bundle\SecurityBundle\Form\FieldAclHelper")</sup>
* The `ApiEventListener::__construct(SecurityFacade $securityFacade, AclHelper $aclHelper)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/SecurityBundle/EventListener/ApiEventListener.php#L35 "Oro\Bundle\SecurityBundle\EventListener\ApiEventListener")</sup> method was changed to `ApiEventListener::__construct(RequestAuthorizationChecker $requestAuthorizationChecker, AclHelper $aclHelper)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/SecurityBundle/EventListener/ApiEventListener.php#L27 "Oro\Bundle\SecurityBundle\EventListener\ApiEventListener")</sup>
* The `ControllerListener::__construct(SecurityFacade $securityFacade, LoggerInterface $logger)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/SecurityBundle/EventListener/ControllerListener.php#L32 "Oro\Bundle\SecurityBundle\EventListener\ControllerListener")</sup> method was changed to `ControllerListener::__construct(ClassAuthorizationChecker $classAuthorizationChecker, LoggerInterface $logger)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/SecurityBundle/EventListener/ControllerListener.php#L26 "Oro\Bundle\SecurityBundle\EventListener\ControllerListener")</sup>
* The `OwnerTreeListener::__construct(ServiceLink $treeProviderLink = null)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/SecurityBundle/EventListener/OwnerTreeListener.php#L43 "Oro\Bundle\SecurityBundle\EventListener\OwnerTreeListener")</sup> method was changed to `OwnerTreeListener::__construct(OwnerTreeProviderInterface $treeProvider)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/SecurityBundle/EventListener/OwnerTreeListener.php#L27 "Oro\Bundle\SecurityBundle\EventListener\OwnerTreeListener")</sup>
* The `OwnershipConfigListener::__construct(MetadataProviderInterface $provider)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/SecurityBundle/EventListener/OwnershipConfigListener.php#L17 "Oro\Bundle\SecurityBundle\EventListener\OwnershipConfigListener")</sup> method was changed to `OwnershipConfigListener::__construct(OwnershipMetadataProviderInterface $provider)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/SecurityBundle/EventListener/OwnershipConfigListener.php#L17 "Oro\Bundle\SecurityBundle\EventListener\OwnershipConfigListener")</sup>
* The `SearchListener::__construct(OwnershipMetadataProvider $metadataProvider, SecurityFacade $securityFacade)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/SecurityBundle/EventListener/SearchListener.php#L33 "Oro\Bundle\SecurityBundle\EventListener\SearchListener")</sup> method was changed to `SearchListener::__construct(OwnershipMetadataProviderInterface $metadataProvider)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/SecurityBundle/EventListener/SearchListener.php#L28 "Oro\Bundle\SecurityBundle\EventListener\SearchListener")</sup>
* The `AclGranted::__construct(SecurityFacade $securityFacade, ManagerRegistry $doctrine)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/SecurityBundle/ConfigExpression/AclGranted.php#L39 "Oro\Bundle\SecurityBundle\ConfigExpression\AclGranted")</sup> method was changed to `AclGranted::__construct(AuthorizationCheckerInterface $authorizationChecker, TokenAccessorInterface $tokenAccessor, ManagerRegistry $doctrine)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/SecurityBundle/ConfigExpression/AclGranted.php#L44 "Oro\Bundle\SecurityBundle\ConfigExpression\AclGranted")</sup>
* The `OwnershipMetadataCacheClearer::__construct(MetadataProviderInterface $provider)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/SecurityBundle/Cache/OwnershipMetadataCacheClearer.php#L19 "Oro\Bundle\SecurityBundle\Cache\OwnershipMetadataCacheClearer")</sup> method was changed to `OwnershipMetadataCacheClearer::__construct(OwnershipMetadataProviderInterface $provider)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/SecurityBundle/Cache/OwnershipMetadataCacheClearer.php#L19 "Oro\Bundle\SecurityBundle\Cache\OwnershipMetadataCacheClearer")</sup>
* The `OwnershipMetadataCacheWarmer::__construct(MetadataProviderInterface $provider)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/SecurityBundle/Cache/OwnershipMetadataCacheWarmer.php#L19 "Oro\Bundle\SecurityBundle\Cache\OwnershipMetadataCacheWarmer")</sup> method was changed to `OwnershipMetadataCacheWarmer::__construct(OwnershipMetadataProviderInterface $provider)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/SecurityBundle/Cache/OwnershipMetadataCacheWarmer.php#L19 "Oro\Bundle\SecurityBundle\Cache\OwnershipMetadataCacheWarmer")</sup>
* The `AbstractAccessLevelAclExtension::__construct(ObjectIdAccessor $objectIdAccessor, MetadataProviderInterface $metadataProvider, EntityOwnerAccessor $entityOwnerAccessor, AccessLevelOwnershipDecisionMakerInterface $decisionMaker)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/SecurityBundle/Acl/Extension/AbstractAccessLevelAclExtension.php#L50 "Oro\Bundle\SecurityBundle\Acl\Extension\AbstractAccessLevelAclExtension")</sup> method was changed to `AbstractAccessLevelAclExtension::__construct(ObjectIdAccessor $objectIdAccessor, OwnershipMetadataProviderInterface $metadataProvider, EntityOwnerAccessor $entityOwnerAccessor, AccessLevelOwnershipDecisionMakerInterface $decisionMaker)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/SecurityBundle/Acl/Extension/AbstractAccessLevelAclExtension.php#L50 "Oro\Bundle\SecurityBundle\Acl\Extension\AbstractAccessLevelAclExtension")</sup>
* The `EntityAclExtension::__construct(ObjectIdAccessor $objectIdAccessor, EntityClassResolver $entityClassResolver, EntitySecurityMetadataProvider $entityMetadataProvider, MetadataProviderInterface $metadataProvider, EntityOwnerAccessor $entityOwnerAccessor, AccessLevelOwnershipDecisionMakerInterface $decisionMaker, PermissionManager $permissionManager, AclGroupProviderInterface $groupProvider, FieldAclExtension $fieldAclExtension)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/SecurityBundle/Acl/Extension/EntityAclExtension.php#L64 "Oro\Bundle\SecurityBundle\Acl\Extension\EntityAclExtension")</sup> method was changed to `EntityAclExtension::__construct(ObjectIdAccessor $objectIdAccessor, EntityClassResolver $entityClassResolver, EntitySecurityMetadataProvider $entityMetadataProvider, OwnershipMetadataProviderInterface $metadataProvider, EntityOwnerAccessor $entityOwnerAccessor, AccessLevelOwnershipDecisionMakerInterface $decisionMaker, PermissionManager $permissionManager, AclGroupProviderInterface $groupProvider, FieldAclExtension $fieldAclExtension)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/SecurityBundle/Acl/Extension/EntityAclExtension.php#L64 "Oro\Bundle\SecurityBundle\Acl\Extension\EntityAclExtension")</sup>
* The `FieldAclExtension::__construct(ObjectIdAccessor $objectIdAccessor, MetadataProviderInterface $metadataProvider, AccessLevelOwnershipDecisionMakerInterface $decisionMaker, EntityOwnerAccessor $entityOwnerAccessor, ConfigManager $configManager, EntitySecurityMetadataProvider $entityMetadataProvider)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/SecurityBundle/Acl/Extension/FieldAclExtension.php#L40 "Oro\Bundle\SecurityBundle\Acl\Extension\FieldAclExtension")</sup> method was changed to `FieldAclExtension::__construct(ObjectIdAccessor $objectIdAccessor, OwnershipMetadataProviderInterface $metadataProvider, AccessLevelOwnershipDecisionMakerInterface $decisionMaker, EntityOwnerAccessor $entityOwnerAccessor, ConfigManager $configManager, EntitySecurityMetadataProvider $entityMetadataProvider)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/SecurityBundle/Acl/Extension/FieldAclExtension.php#L40 "Oro\Bundle\SecurityBundle\Acl\Extension\FieldAclExtension")</sup>
* The following properties in class `SecurityFacade`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/SecurityBundle/SecurityFacade.php#L24 "Oro\Bundle\SecurityBundle\SecurityFacade")</sup> were removed:
   - `$annotationProvider::$annotationProvider`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/SecurityBundle/SecurityFacade.php#L24 "Oro\Bundle\SecurityBundle\SecurityFacade::$annotationProvider")</sup>
   - `$objectIdentityFactory::$objectIdentityFactory`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/SecurityBundle/SecurityFacade.php#L27 "Oro\Bundle\SecurityBundle\SecurityFacade::$objectIdentityFactory")</sup>
   - `$entityClassResolver::$entityClassResolver`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/SecurityBundle/SecurityFacade.php#L30 "Oro\Bundle\SecurityBundle\SecurityFacade::$entityClassResolver")</sup>
* The `AclHelper::$securityFacade`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/SecurityBundle/Search/AclHelper.php#L19 "Oro\Bundle\SecurityBundle\Search\AclHelper::$securityFacade")</sup> property was removed.
* The `DoctrineParamConverter::$securityFacade`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/SecurityBundle/Request/ParamConverter/DoctrineParamConverter.php#L18 "Oro\Bundle\SecurityBundle\Request\ParamConverter\DoctrineParamConverter::$securityFacade")</sup> property was removed.
* The following properties in class `EntityOwnershipDecisionMaker`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/SecurityBundle/Owner/EntityOwnershipDecisionMaker.php#L16 "Oro\Bundle\SecurityBundle\Owner\EntityOwnershipDecisionMaker")</sup> were removed:
   - `$treeProvider::$treeProvider`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/SecurityBundle/Owner/EntityOwnershipDecisionMaker.php#L16 "Oro\Bundle\SecurityBundle\Owner\EntityOwnershipDecisionMaker::$treeProvider")</sup>
   - `$objectIdAccessor::$objectIdAccessor`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/SecurityBundle/Owner/EntityOwnershipDecisionMaker.php#L23 "Oro\Bundle\SecurityBundle\Owner\EntityOwnershipDecisionMaker::$objectIdAccessor")</sup>
   - `$entityOwnerAccessor::$entityOwnerAccessor`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/SecurityBundle/Owner/EntityOwnershipDecisionMaker.php#L30 "Oro\Bundle\SecurityBundle\Owner\EntityOwnershipDecisionMaker::$entityOwnerAccessor")</sup>
   - `$metadataProvider::$metadataProvider`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/SecurityBundle/Owner/EntityOwnershipDecisionMaker.php#L37 "Oro\Bundle\SecurityBundle\Owner\EntityOwnershipDecisionMaker::$metadataProvider")</sup>
* The `OwnershipMetadataProvider::$configProvider`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/SecurityBundle/Owner/Metadata/OwnershipMetadataProvider.php#L24 "Oro\Bundle\SecurityBundle\Owner\Metadata\OwnershipMetadataProvider::$configProvider")</sup> property was removed.
* The `OwnershipConditionDataBuilder::$securityContextLink`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/SecurityBundle/ORM/Walker/OwnershipConditionDataBuilder.php#L29 "Oro\Bundle\SecurityBundle\ORM\Walker\OwnershipConditionDataBuilder::$securityContextLink")</sup> property was removed.
* The `IsLoggedInContextConfigurator::$securityFacade`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/SecurityBundle/Layout/Extension/IsLoggedInContextConfigurator.php#L16 "Oro\Bundle\SecurityBundle\Layout\Extension\IsLoggedInContextConfigurator::$securityFacade")</sup> property was removed.
* The `AclProvider::$securityFacade`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/SecurityBundle/Layout/DataProvider/AclProvider.php#L15 "Oro\Bundle\SecurityBundle\Layout\DataProvider\AclProvider::$securityFacade")</sup> property was removed.
* The `CurrentUserProvider::$securityFacade`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/SecurityBundle/Layout/DataProvider/CurrentUserProvider.php#L10 "Oro\Bundle\SecurityBundle\Layout\DataProvider\CurrentUserProvider::$securityFacade")</sup> property was removed.
* The `OrganizationBasicAuthenticationListener::$securityContext`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/SecurityBundle/Http/Firewall/OrganizationBasicAuthenticationListener.php#L21 "Oro\Bundle\SecurityBundle\Http\Firewall\OrganizationBasicAuthenticationListener::$securityContext")</sup> property was removed.
* The `ApiEventListener::$securityFacade`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/SecurityBundle/EventListener/ApiEventListener.php#L24 "Oro\Bundle\SecurityBundle\EventListener\ApiEventListener::$securityFacade")</sup> property was removed.
* The `OwnerTreeListener::$container`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/SecurityBundle/EventListener/OwnerTreeListener.php#L25 "Oro\Bundle\SecurityBundle\EventListener\OwnerTreeListener::$container")</sup> property was removed.
* The `SearchListener::$securityFacade`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/SecurityBundle/EventListener/SearchListener.php#L24 "Oro\Bundle\SecurityBundle\EventListener\SearchListener::$securityFacade")</sup> property was removed.
* The `AclGranted::$securityFacade`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/SecurityBundle/ConfigExpression/AclGranted.php#L24 "Oro\Bundle\SecurityBundle\ConfigExpression\AclGranted::$securityFacade")</sup> property was removed.
* The `OroSecurityExtension::getSecurityFacade`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/SecurityBundle/Twig/OroSecurityExtension.php#L32 "Oro\Bundle\SecurityBundle\Twig\OroSecurityExtension::getSecurityFacade")</sup> method was removed.
* The `AbstractEntityOwnershipDecisionMaker::getContainer`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/SecurityBundle/Owner/AbstractEntityOwnershipDecisionMaker.php#L111 "Oro\Bundle\SecurityBundle\Owner\AbstractEntityOwnershipDecisionMaker::getContainer")</sup> method was removed.
* The `AbstractOwnerTreeProvider::createTreeObject`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/SecurityBundle/Owner/AbstractOwnerTreeProvider.php#L42 "Oro\Bundle\SecurityBundle\Owner\AbstractOwnerTreeProvider::createTreeObject")</sup> method was removed.
* The `OwnershipMetadataProvider::setAccessLevelClasses`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/SecurityBundle/Owner/Metadata/OwnershipMetadataProvider.php#L70 "Oro\Bundle\SecurityBundle\Owner\Metadata\OwnershipMetadataProvider::setAccessLevelClasses")</sup> method was removed.
* The following methods in class `OwnershipConditionDataBuilder`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/SecurityBundle/ORM/Walker/OwnershipConditionDataBuilder.php#L317 "Oro\Bundle\SecurityBundle\ORM\Walker\OwnershipConditionDataBuilder")</sup> were removed:
   - `fillOrganizationBusinessUnitIds::fillOrganizationBusinessUnitIds`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/SecurityBundle/ORM/Walker/OwnershipConditionDataBuilder.php#L317 "Oro\Bundle\SecurityBundle\ORM\Walker\OwnershipConditionDataBuilder::fillOrganizationBusinessUnitIds")</sup>
   - `fillOrganizationUserIds::fillOrganizationUserIds`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/SecurityBundle/ORM/Walker/OwnershipConditionDataBuilder.php#L335 "Oro\Bundle\SecurityBundle\ORM\Walker\OwnershipConditionDataBuilder::fillOrganizationUserIds")</sup>
   - `getSecurityContext::getSecurityContext`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/SecurityBundle/ORM/Walker/OwnershipConditionDataBuilder.php#L430 "Oro\Bundle\SecurityBundle\ORM\Walker\OwnershipConditionDataBuilder::getSecurityContext")</sup>
* The `OwnerTreeListener::getTreeProvider`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/SecurityBundle/EventListener/OwnerTreeListener.php#L150 "Oro\Bundle\SecurityBundle\EventListener\OwnerTreeListener::getTreeProvider")</sup> method was removed.
* The following methods in class `AbstractEntityOwnershipDecisionMaker`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/SecurityBundle/Owner/AbstractEntityOwnershipDecisionMaker.php#L55 "Oro\Bundle\SecurityBundle\Owner\AbstractEntityOwnershipDecisionMaker")</sup> were removed:
   - `getMetadataProvider::getMetadataProvider`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/SecurityBundle/Owner/AbstractEntityOwnershipDecisionMaker.php#L55 "Oro\Bundle\SecurityBundle\Owner\AbstractEntityOwnershipDecisionMaker::getMetadataProvider")</sup>
   - `getTreeProvider::getTreeProvider`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/SecurityBundle/Owner/AbstractEntityOwnershipDecisionMaker.php#L67 "Oro\Bundle\SecurityBundle\Owner\AbstractEntityOwnershipDecisionMaker::getTreeProvider")</sup>
   - `getObjectIdAccessor::getObjectIdAccessor`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/SecurityBundle/Owner/AbstractEntityOwnershipDecisionMaker.php#L79 "Oro\Bundle\SecurityBundle\Owner\AbstractEntityOwnershipDecisionMaker::getObjectIdAccessor")</sup>
   - `getEntityOwnerAccessor::getEntityOwnerAccessor`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/SecurityBundle/Owner/AbstractEntityOwnershipDecisionMaker.php#L91 "Oro\Bundle\SecurityBundle\Owner\AbstractEntityOwnershipDecisionMaker::getEntityOwnerAccessor")</sup>
   - `setContainer::setContainer`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/SecurityBundle/Owner/AbstractEntityOwnershipDecisionMaker.php#L103 "Oro\Bundle\SecurityBundle\Owner\AbstractEntityOwnershipDecisionMaker::setContainer")</sup>
* The `ChainOwnerTreeProvider::__construct`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/SecurityBundle/Owner/ChainOwnerTreeProvider.php#L21 "Oro\Bundle\SecurityBundle\Owner\ChainOwnerTreeProvider::__construct")</sup> method was removed.
* The following methods in class `EntityOwnershipDecisionMaker`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/SecurityBundle/Owner/EntityOwnershipDecisionMaker.php#L66 "Oro\Bundle\SecurityBundle\Owner\EntityOwnershipDecisionMaker")</sup> were removed:
   - `isOrganization::isOrganization`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/SecurityBundle/Owner/EntityOwnershipDecisionMaker.php#L66 "Oro\Bundle\SecurityBundle\Owner\EntityOwnershipDecisionMaker::isOrganization")</sup>
   - `isBusinessUnit::isBusinessUnit`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/SecurityBundle/Owner/EntityOwnershipDecisionMaker.php#L75 "Oro\Bundle\SecurityBundle\Owner\EntityOwnershipDecisionMaker::isBusinessUnit")</sup>
   - `isUser::isUser`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/SecurityBundle/Owner/EntityOwnershipDecisionMaker.php#L84 "Oro\Bundle\SecurityBundle\Owner\EntityOwnershipDecisionMaker::isUser")</sup>
   - `isAssociatedWithOrganization::isAssociatedWithOrganization`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/SecurityBundle/Owner/EntityOwnershipDecisionMaker.php#L95 "Oro\Bundle\SecurityBundle\Owner\EntityOwnershipDecisionMaker::isAssociatedWithOrganization")</sup>
   - `isAssociatedWithBusinessUnit::isAssociatedWithBusinessUnit`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/SecurityBundle/Owner/EntityOwnershipDecisionMaker.php#L104 "Oro\Bundle\SecurityBundle\Owner\EntityOwnershipDecisionMaker::isAssociatedWithBusinessUnit")</sup>
   - `isAssociatedWithUser::isAssociatedWithUser`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/SecurityBundle/Owner/EntityOwnershipDecisionMaker.php#L113 "Oro\Bundle\SecurityBundle\Owner\EntityOwnershipDecisionMaker::isAssociatedWithUser")</sup>
* The following methods in class `OwnerTree`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/SecurityBundle/Owner/OwnerTree.php#L196 "Oro\Bundle\SecurityBundle\Owner\OwnerTree")</sup> were removed:
   - `getBusinessUnitUserIds::getBusinessUnitUserIds`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/SecurityBundle/Owner/OwnerTree.php#L196 "Oro\Bundle\SecurityBundle\Owner\OwnerTree::getBusinessUnitUserIds")</sup>
   - `getOrganizationUserIds::getOrganizationUserIds`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/SecurityBundle/Owner/OwnerTree.php#L245 "Oro\Bundle\SecurityBundle\Owner\OwnerTree::getOrganizationUserIds")</sup>
   - `getUsersAssignedToBU::getUsersAssignedToBU`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/SecurityBundle/Owner/OwnerTree.php#L492 "Oro\Bundle\SecurityBundle\Owner\OwnerTree::getUsersAssignedToBU")</sup>
* The `OwnerTreeListener::setContainer`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/SecurityBundle/EventListener/OwnerTreeListener.php#L33 "Oro\Bundle\SecurityBundle\EventListener\OwnerTreeListener::setContainer")</sup> method was removed.
* The `AbstractOwnerTreeProvider::fillTree(OwnerTreeInterface $tree)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/SecurityBundle/Owner/AbstractOwnerTreeProvider.php#L35 "Oro\Bundle\SecurityBundle\Owner\AbstractOwnerTreeProvider")</sup> method was changed to `AbstractOwnerTreeProvider::fillTree(OwnerTreeBuilderInterface $tree)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/SecurityBundle/Owner/AbstractOwnerTreeProvider.php#L35 "Oro\Bundle\SecurityBundle\Owner\AbstractOwnerTreeProvider")</sup>
* The `OwnerTreeProvider::fillTree(OwnerTreeInterface $tree)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/SecurityBundle/Owner/OwnerTreeProvider.php#L67 "Oro\Bundle\SecurityBundle\Owner\OwnerTreeProvider")</sup> method was changed to `OwnerTreeProvider::fillTree(OwnerTreeBuilderInterface $tree)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/SecurityBundle/Owner/OwnerTreeProvider.php#L66 "Oro\Bundle\SecurityBundle\Owner\OwnerTreeProvider")</sup>
* The following methods in class `SearchListener`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/SecurityBundle/EventListener/SearchListener.php#L92 "Oro\Bundle\SecurityBundle\EventListener\SearchListener")</sup> were changed:
  > - `getOwnerId(OwnershipMetadata $metadata, $entity)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/SecurityBundle/EventListener/SearchListener.php#L97 "Oro\Bundle\SecurityBundle\EventListener\SearchListener")</sup>
  > - `getOwnerId(OwnershipMetadataInterface $metadata, $entity)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/SecurityBundle/EventListener/SearchListener.php#L92 "Oro\Bundle\SecurityBundle\EventListener\SearchListener")</sup>

  > - `getOrganizationId(OwnershipMetadata $metadata, $entity)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/SecurityBundle/EventListener/SearchListener.php#L122 "Oro\Bundle\SecurityBundle\EventListener\SearchListener")</sup>
  > - `getOrganizationId(OwnershipMetadataInterface $metadata, $entity)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/SecurityBundle/EventListener/SearchListener.php#L114 "Oro\Bundle\SecurityBundle\EventListener\SearchListener")</sup>


SegmentBundle
-------------
* The `SegmentManager::__construct(EntityManager $em, SegmentQueryBuilderRegistry $builderRegistry)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/SegmentBundle/Entity/Manager/SegmentManager.php#L33 "Oro\Bundle\SegmentBundle\Entity\Manager\SegmentManager")</sup> method was changed to `SegmentManager::__construct(EntityManager $em, SegmentQueryBuilderRegistry $builderRegistry, SubQueryLimitHelper $subQueryLimitHelper)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/SegmentBundle/Entity/Manager/SegmentManager.php#L40 "Oro\Bundle\SegmentBundle\Entity\Manager\SegmentManager")</sup>
* The `StaticSegmentManager::__construct(EntityManager $em, DynamicSegmentQueryBuilder $dynamicSegmentQB, OwnershipMetadataProvider $ownershipMetadataProvider)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/SegmentBundle/Entity/Manager/StaticSegmentManager.php#L36 "Oro\Bundle\SegmentBundle\Entity\Manager\StaticSegmentManager")</sup> method was changed to `StaticSegmentManager::__construct(EntityManager $em, DynamicSegmentQueryBuilder $dynamicSegmentQB, OwnershipMetadataProviderInterface $ownershipMetadataProvider)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/SegmentBundle/Entity/Manager/StaticSegmentManager.php#L36 "Oro\Bundle\SegmentBundle\Entity\Manager\StaticSegmentManager")</sup>

SyncBundle
----------
* The `MaintenanceListener::__construct(TopicPublisher $publisher, SecurityFacade $securityFacade, LoggerInterface $logger)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/SyncBundle/EventListener/MaintenanceListener.php#L32 "Oro\Bundle\SyncBundle\EventListener\MaintenanceListener")</sup> method was changed to `MaintenanceListener::__construct(TopicPublisher $publisher, TokenAccessorInterface $tokenAccessor, LoggerInterface $logger)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/SyncBundle/EventListener/MaintenanceListener.php#L26 "Oro\Bundle\SyncBundle\EventListener\MaintenanceListener")</sup>
* The `TopicSender::__construct(TopicPublisher $publisher, ServiceLink $generatorLink, ServiceLink $securityContextLink, LoggerInterface $logger)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/SyncBundle/Content/TopicSender.php#L34 "Oro\Bundle\SyncBundle\Content\TopicSender")</sup> method was changed to `TopicSender::__construct(TopicPublisher $publisher, ServiceLink $generatorLink, TokenStorageInterface $tokenStorage, LoggerInterface $logger)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/SyncBundle/Content/TopicSender.php#L34 "Oro\Bundle\SyncBundle\Content\TopicSender")</sup>
* The `MaintenanceListener::$securityFacade`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/SyncBundle/EventListener/MaintenanceListener.php#L20 "Oro\Bundle\SyncBundle\EventListener\MaintenanceListener::$securityFacade")</sup> property was removed.
* The `TopicSender::$securityContextLink`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/SyncBundle/Content/TopicSender.php#L23 "Oro\Bundle\SyncBundle\Content\TopicSender::$securityContextLink")</sup> property was removed.

TagBundle
---------
* The `TagsExtension::isAccessGranted`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/TagBundle/Grid/TagsExtension.php#L100 "Oro\Bundle\TagBundle\Grid\TagsExtension::isAccessGranted")</sup> method was removed.
* The `TagsExtension::__construct(TagManager $tagManager, EntityClassResolver $entityClassResolver, TaggableHelper $helper, EntityRoutingHelper $entityRoutingHelper, SecurityFacade $securityFacade)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/TagBundle/Grid/TagsExtension.php#L37 "Oro\Bundle\TagBundle\Grid\TagsExtension")</sup> method was changed to `TagsExtension::__construct(TagManager $tagManager, EntityClassResolver $entityClassResolver, TaggableHelper $helper, EntityRoutingHelper $entityRoutingHelper, AuthorizationCheckerInterface $authorizationChecker, TokenStorageInterface $tokenStorage)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/TagBundle/Grid/TagsExtension.php#L43 "Oro\Bundle\TagBundle\Grid\TagsExtension")</sup>
* The `TagSelectType::__construct(SecurityFacade $securityFacade, TagTransformer $tagTransformer, TagSubscriber $subscriber)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/TagBundle/Form/Type/TagSelectType.php#L31 "Oro\Bundle\TagBundle\Form\Type\TagSelectType")</sup> method was changed to `TagSelectType::__construct(AuthorizationCheckerInterface $authorizationChecker, TagTransformer $tagTransformer, TagSubscriber $subscriber)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/TagBundle/Form/Type/TagSelectType.php#L30 "Oro\Bundle\TagBundle\Form\Type\TagSelectType")</sup>
* The `TagManager::__construct(EntityManager $em, $tagClass, $taggingClass, SecurityFacade $securityFacade, Router $router)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/TagBundle/Entity/TagManager.php#L54 "Oro\Bundle\TagBundle\Entity\TagManager")</sup> method was changed to `TagManager::__construct(EntityManager $em, $tagClass, $taggingClass, AuthorizationCheckerInterface $authorizationChecker, TokenAccessorInterface $tokenAccessor, Router $router)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/TagBundle/Entity/TagManager.php#L59 "Oro\Bundle\TagBundle\Entity\TagManager")</sup>
* The `SearchHandler::__construct($entityName, array $properties, SecurityFacade $securityFacade)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/TagBundle/Autocomplete/SearchHandler.php#L22 "Oro\Bundle\TagBundle\Autocomplete\SearchHandler")</sup> method was changed to `SearchHandler::__construct($entityName, array $properties, TokenAccessorInterface $tokenAccessor)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/TagBundle/Autocomplete/SearchHandler.php#L18 "Oro\Bundle\TagBundle\Autocomplete\SearchHandler")</sup>
* The `TagsExtension::$securityFacade`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/TagBundle/Grid/TagsExtension.php#L28 "Oro\Bundle\TagBundle\Grid\TagsExtension::$securityFacade")</sup> property was removed.
* The `TagSelectType::$securityFacade`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/TagBundle/Form/Type/TagSelectType.php#L21 "Oro\Bundle\TagBundle\Form\Type\TagSelectType::$securityFacade")</sup> property was removed.
* The `TagManager::$securityFacade`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/TagBundle/Entity/TagManager.php#L39 "Oro\Bundle\TagBundle\Entity\TagManager::$securityFacade")</sup> property was removed.
* The following properties in class `SearchHandler`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/TagBundle/Autocomplete/SearchHandler.php#L12 "Oro\Bundle\TagBundle\Autocomplete\SearchHandler")</sup> were removed:
   - `$securityFacade::$securityFacade`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/TagBundle/Autocomplete/SearchHandler.php#L12 "Oro\Bundle\TagBundle\Autocomplete\SearchHandler::$securityFacade")</sup>
   - `$propertyAccessor::$propertyAccessor`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/TagBundle/Autocomplete/SearchHandler.php#L15 "Oro\Bundle\TagBundle\Autocomplete\SearchHandler::$propertyAccessor")</sup>

TestGeneratorBundle
-------------------
* The `AbstractTestGenerator::getTestPath($namespace)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/TestGeneratorBundle/Generator/AbstractTestGenerator.php#L194 "Oro\Bundle\TestGeneratorBundle\Generator\AbstractTestGenerator")</sup> method was changed to `AbstractTestGenerator::getTestPath($namespace, $classFileName)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/TestGeneratorBundle/Generator/AbstractTestGenerator.php#L201 "Oro\Bundle\TestGeneratorBundle\Generator\AbstractTestGenerator")</sup>

TranslationBundle
-----------------
* The `PackagesProvider::__construct(ServiceLink $pmLink, array $bundles, $kernelRootDir, $composerCacheHome, array $packageProviders = [])`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/TranslationBundle/Provider/PackagesProvider.php#L38 "Oro\Bundle\TranslationBundle\Provider\PackagesProvider")</sup> method was changed to `PackagesProvider::__construct(PackageManager $pm, array $bundles, $kernelRootDir, $composerCacheHome, array $packageProviders = [])`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/TranslationBundle/Provider/PackagesProvider.php#L37 "Oro\Bundle\TranslationBundle\Provider\PackagesProvider")</sup>
* The `PackagesProvider::$pmLink`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/TranslationBundle/Provider/PackagesProvider.php#L14 "Oro\Bundle\TranslationBundle\Provider\PackagesProvider::$pmLink")</sup> property was removed.

UIBundle
--------
* The `TabExtension::getSecurityFacade`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/UIBundle/Twig/TabExtension.php#L50 "Oro\Bundle\UIBundle\Twig\TabExtension::getSecurityFacade")</sup> method was removed.
* The `Router::__construct(RequestStack $requestStack, Router $router, SecurityFacade $securityFacade)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/UIBundle/Route/Router.php#L44 "Oro\Bundle\UIBundle\Route\Router")</sup> method was changed to `Router::__construct(RequestStack $requestStack, Router $router, AuthorizationCheckerInterface $authorizationChecker)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/UIBundle/Route/Router.php#L36 "Oro\Bundle\UIBundle\Route\Router")</sup>
* The `PlaceholderProvider::__construct(array $placeholders, ResolverInterface $resolver, SecurityFacade $securityFacade, FeatureChecker $featureChecker)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/UIBundle/Placeholder/PlaceholderProvider.php#L31 "Oro\Bundle\UIBundle\Placeholder\PlaceholderProvider")</sup> method was changed to `PlaceholderProvider::__construct(array $placeholders, ResolverInterface $resolver, AuthorizationCheckerInterface $authorizationChecker, FeatureChecker $featureChecker)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/UIBundle/Placeholder/PlaceholderProvider.php#L32 "Oro\Bundle\UIBundle\Placeholder\PlaceholderProvider")</sup>
* The `Router::$securityFacade`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/UIBundle/Route/Router.php#L32 "Oro\Bundle\UIBundle\Route\Router::$securityFacade")</sup> property was removed.
* The `PlaceholderProvider::$securityFacade`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/UIBundle/Placeholder/PlaceholderProvider.php#L20 "Oro\Bundle\UIBundle\Placeholder\PlaceholderProvider::$securityFacade")</sup> property was removed.

UserBundle
----------
* The `UserGridFieldValidator::__construct(SecurityFacade $securityFacade)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/UserBundle/Validator/UserGridFieldValidator.php#L29 "Oro\Bundle\UserBundle\Validator\UserGridFieldValidator")</sup> method was changed to `UserGridFieldValidator::__construct(TokenAccessorInterface $tokenAccessor)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/UserBundle/Validator/UserGridFieldValidator.php#L27 "Oro\Bundle\UserBundle\Validator\UserGridFieldValidator")</sup>
* The `UserChecker::__construct(ServiceLink $securityContextLink, FlashBagInterface $flashBag, TranslatorInterface $translator)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/UserBundle/Security/UserChecker.php#L34 "Oro\Bundle\UserBundle\Security\UserChecker")</sup> method was changed to `UserChecker::__construct(TokenStorageInterface $tokenStorage, FlashBagInterface $flashBag, TranslatorInterface $translator)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/UserBundle/Security/UserChecker.php#L33 "Oro\Bundle\UserBundle\Security\UserChecker")</sup>
* The `PlaceholderFilter::__construct(SecurityFacade $securityFacade)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/UserBundle/Placeholder/PlaceholderFilter.php#L19 "Oro\Bundle\UserBundle\Placeholder\PlaceholderFilter")</sup> method was changed to `PlaceholderFilter::__construct(TokenAccessorInterface $tokenAccessor)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/UserBundle/Placeholder/PlaceholderFilter.php#L17 "Oro\Bundle\UserBundle\Placeholder\PlaceholderFilter")</sup>
* The `UserType::__construct(SecurityContextInterface $security, SecurityFacade $securityFacade, Request $request, PasswordFieldOptionsProvider $optionsProvider)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/UserBundle/Form/Type/UserType.php#L41 "Oro\Bundle\UserBundle\Form\Type\UserType")</sup> method was changed to `UserType::__construct(AuthorizationCheckerInterface $authorizationChecker, TokenAccessorInterface $tokenAccessor, Request $request, PasswordFieldOptionsProvider $optionsProvider)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/UserBundle/Form/Type/UserType.php#L41 "Oro\Bundle\UserBundle\Form\Type\UserType")</sup>
* The `UserImapConfigSubscriber::__construct(ObjectManager $manager, RequestStack $requestStack, SecurityContextInterface $security)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/UserBundle/Form/EventListener/UserImapConfigSubscriber.php#L36 "Oro\Bundle\UserBundle\Form\EventListener\UserImapConfigSubscriber")</sup> method was changed to `UserImapConfigSubscriber::__construct(EntityManager $entityManager, RequestStack $requestStack, TokenAccessorInterface $tokenAccessor)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/UserBundle/Form/EventListener/UserImapConfigSubscriber.php#L31 "Oro\Bundle\UserBundle\Form\EventListener\UserImapConfigSubscriber")</sup>
* The `UserSubscriber::__construct(FormFactoryInterface $factory, SecurityContextInterface $security)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/UserBundle/Form/EventListener/UserSubscriber.php#L29 "Oro\Bundle\UserBundle\Form\EventListener\UserSubscriber")</sup> method was changed to `UserSubscriber::__construct(FormFactoryInterface $factory, TokenAccessorInterface $tokenAccessor)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/UserBundle/Form/EventListener/UserSubscriber.php#L25 "Oro\Bundle\UserBundle\Form\EventListener\UserSubscriber")</sup>
* The `OwnerUserGridListener::__construct(EntityManager $em, ServiceLink $securityContextLink, OwnerTreeProvider $treeProvider, AclVoter $aclVoter = null)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/UserBundle/EventListener/OwnerUserGridListener.php#L45 "Oro\Bundle\UserBundle\EventListener\OwnerUserGridListener")</sup> method was changed to `OwnerUserGridListener::__construct(EntityManager $em, AuthorizationCheckerInterface $authorizationChecker, TokenAccessorInterface $tokenAccessor, OwnerTreeProvider $treeProvider, AclVoter $aclVoter = null)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/UserBundle/EventListener/OwnerUserGridListener.php#L46 "Oro\Bundle\UserBundle\EventListener\OwnerUserGridListener")</sup>
* The `UserPermissionApiEntityManager::__construct($class, ObjectManager $om, SecurityContext $securityContext, AclExtensionSelector $aclSelector)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/UserBundle/Entity/Manager/UserPermissionApiEntityManager.php#L35 "Oro\Bundle\UserBundle\Entity\Manager\UserPermissionApiEntityManager")</sup> method was changed to `UserPermissionApiEntityManager::__construct($class, ObjectManager $om, AuthorizationCheckerInterface $authorizationChecker, TokenStorageInterface $tokenStorage, AclExtensionSelector $aclSelector)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/UserBundle/Entity/Manager/UserPermissionApiEntityManager.php#L40 "Oro\Bundle\UserBundle\Entity\Manager\UserPermissionApiEntityManager")</sup>
* The `ActionChecker::__construct(SecurityFacade $securityFacade)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/UserBundle/Datagrid/ActionChecker.php#L16 "Oro\Bundle\UserBundle\Datagrid\ActionChecker")</sup> method was changed to `ActionChecker::__construct(TokenAccessorInterface $tokenAccessor)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/UserBundle/Datagrid/ActionChecker.php#L16 "Oro\Bundle\UserBundle\Datagrid\ActionChecker")</sup>
* The `ResetPasswordActionHandler::__construct(ResetPasswordHandler $resetPasswordHandler, TranslatorInterface $translator, SecurityFacade $securityFacade)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/UserBundle/Datagrid/Extension/MassAction/ResetPasswordActionHandler.php#L34 "Oro\Bundle\UserBundle\Datagrid\Extension\MassAction\ResetPasswordActionHandler")</sup> method was changed to `ResetPasswordActionHandler::__construct(ResetPasswordHandler $resetPasswordHandler, TranslatorInterface $translator, TokenAccessorInterface $tokenAccessor)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/UserBundle/Datagrid/Extension/MassAction/ResetPasswordActionHandler.php#L34 "Oro\Bundle\UserBundle\Datagrid\Extension\MassAction\ResetPasswordActionHandler")</sup>
* The `UserAclHandler::__construct(EntityManager $em, AttachmentManager $attachmentManager, $className, ServiceLink $securityContextLink, OwnerTreeProvider $treeProvider, AclVoter $aclVoter = null)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/UserBundle/Autocomplete/UserAclHandler.php#L69 "Oro\Bundle\UserBundle\Autocomplete\UserAclHandler")</sup> method was changed to `UserAclHandler::__construct(EntityManager $em, AttachmentManager $attachmentManager, $className, AuthorizationCheckerInterface $authorizationChecker, TokenAccessorInterface $tokenAccessor, OwnerTreeProvider $treeProvider, AclVoter $aclVoter = null)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/UserBundle/Autocomplete/UserAclHandler.php#L69 "Oro\Bundle\UserBundle\Autocomplete\UserAclHandler")</sup>
* The `UserWithoutCurrentHandler::__construct(SecurityFacade $securityFacade, AttachmentManager $attachmentManager, $userEntityName, array $properties)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/UserBundle/Autocomplete/UserWithoutCurrentHandler.php#L21 "Oro\Bundle\UserBundle\Autocomplete\UserWithoutCurrentHandler")</sup> method was changed to `UserWithoutCurrentHandler::__construct(TokenAccessorInterface $tokenAccessor, AttachmentManager $attachmentManager, $userEntityName, array $properties)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/UserBundle/Autocomplete/UserWithoutCurrentHandler.php#L19 "Oro\Bundle\UserBundle\Autocomplete\UserWithoutCurrentHandler")</sup>
* The `UserGridFieldValidator::$securityFacade`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/UserBundle/Validator/UserGridFieldValidator.php#L22 "Oro\Bundle\UserBundle\Validator\UserGridFieldValidator::$securityFacade")</sup> property was removed.
* The `UserChecker::$securityContextLink`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/UserBundle/Security/UserChecker.php#L21 "Oro\Bundle\UserBundle\Security\UserChecker::$securityContextLink")</sup> property was removed.
* The `PlaceholderFilter::$securityFacade`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/UserBundle/Placeholder/PlaceholderFilter.php#L14 "Oro\Bundle\UserBundle\Placeholder\PlaceholderFilter::$securityFacade")</sup> property was removed.
* The `UserDeleteHandler::$securityFacade`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/UserBundle/Handler/UserDeleteHandler.php#L14 "Oro\Bundle\UserBundle\Handler\UserDeleteHandler::$securityFacade")</sup> property was removed.
* The following properties in class `UserType`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/UserBundle/Form/Type/UserType.php#L24 "Oro\Bundle\UserBundle\Form\Type\UserType")</sup> were removed:
   - `$security::$security`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/UserBundle/Form/Type/UserType.php#L24 "Oro\Bundle\UserBundle\Form\Type\UserType::$security")</sup>
   - `$securityFacade::$securityFacade`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/UserBundle/Form/Type/UserType.php#L27 "Oro\Bundle\UserBundle\Form\Type\UserType::$securityFacade")</sup>
* The following properties in class `UserImapConfigSubscriber`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/UserBundle/Form/EventListener/UserImapConfigSubscriber.php#L21 "Oro\Bundle\UserBundle\Form\EventListener\UserImapConfigSubscriber")</sup> were removed:
   - `$manager::$manager`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/UserBundle/Form/EventListener/UserImapConfigSubscriber.php#L21 "Oro\Bundle\UserBundle\Form\EventListener\UserImapConfigSubscriber::$manager")</sup>
   - `$security::$security`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/UserBundle/Form/EventListener/UserImapConfigSubscriber.php#L26 "Oro\Bundle\UserBundle\Form\EventListener\UserImapConfigSubscriber::$security")</sup>
* The `UserSubscriber::$security`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/UserBundle/Form/EventListener/UserSubscriber.php#L23 "Oro\Bundle\UserBundle\Form\EventListener\UserSubscriber::$security")</sup> property was removed.
* The `OwnerUserGridListener::$securityContextLink`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/UserBundle/EventListener/OwnerUserGridListener.php#L31 "Oro\Bundle\UserBundle\EventListener\OwnerUserGridListener::$securityContextLink")</sup> property was removed.
* The `UserPermissionApiEntityManager::$securityContext`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/UserBundle/Entity/Manager/UserPermissionApiEntityManager.php#L24 "Oro\Bundle\UserBundle\Entity\Manager\UserPermissionApiEntityManager::$securityContext")</sup> property was removed.
* The `ActionChecker::$securityFacade`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/UserBundle/Datagrid/ActionChecker.php#L11 "Oro\Bundle\UserBundle\Datagrid\ActionChecker::$securityFacade")</sup> property was removed.
* The `ResetPasswordActionHandler::$securityFacade`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/UserBundle/Datagrid/Extension/MassAction/ResetPasswordActionHandler.php#L27 "Oro\Bundle\UserBundle\Datagrid\Extension\MassAction\ResetPasswordActionHandler::$securityFacade")</sup> property was removed.
* The `WidgetUserSelectConverter::$securityFacade`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/UserBundle/Dashboard/Converters/WidgetUserSelectConverter.php#L23 "Oro\Bundle\UserBundle\Dashboard\Converters\WidgetUserSelectConverter::$securityFacade")</sup> property was removed.
* The `OrganizationUsersHandler::$securityFacade`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/UserBundle/Autocomplete/OrganizationUsersHandler.php#L21 "Oro\Bundle\UserBundle\Autocomplete\OrganizationUsersHandler::$securityFacade")</sup> property was removed.
* The `UserAclHandler::$securityContextLink`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/UserBundle/Autocomplete/UserAclHandler.php#L56 "Oro\Bundle\UserBundle\Autocomplete\UserAclHandler::$securityContextLink")</sup> property was removed.
* The `UserWithoutCurrentHandler::$securityFacade`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/UserBundle/Autocomplete/UserWithoutCurrentHandler.php#L13 "Oro\Bundle\UserBundle\Autocomplete\UserWithoutCurrentHandler::$securityFacade")</sup> property was removed.
* The `WidgetUserSearchHandler::$securityFacade`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/UserBundle/Autocomplete/WidgetUserSearchHandler.php#L21 "Oro\Bundle\UserBundle\Autocomplete\WidgetUserSearchHandler::$securityFacade")</sup> property was removed.
* The `UserMenuBuilder::__construct`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/UserBundle/Menu/UserMenuBuilder.php#L21 "Oro\Bundle\UserBundle\Menu\UserMenuBuilder::__construct")</sup> method was removed.
* The `UserDeleteHandler::setSecurityFacade`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/UserBundle/Handler/UserDeleteHandler.php#L19 "Oro\Bundle\UserBundle\Handler\UserDeleteHandler::setSecurityFacade")</sup> method was removed.
* The `User::getId`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/UserBundle/Entity/User.php#L841 "Oro\Bundle\UserBundle\Entity\User::getId")</sup> method was removed.
* The `WidgetUserSelectConverter::setSecurityFacade`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/UserBundle/Dashboard/Converters/WidgetUserSelectConverter.php#L74 "Oro\Bundle\UserBundle\Dashboard\Converters\WidgetUserSelectConverter::setSecurityFacade")</sup> method was removed.
* The `OrganizationUsersHandler::setSecurityFacade`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/UserBundle/Autocomplete/OrganizationUsersHandler.php#L29 "Oro\Bundle\UserBundle\Autocomplete\OrganizationUsersHandler::setSecurityFacade")</sup> method was removed.
* The `WidgetUserSearchHandler::setSecurityFacade`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/UserBundle/Autocomplete/WidgetUserSearchHandler.php#L46 "Oro\Bundle\UserBundle\Autocomplete\WidgetUserSearchHandler::setSecurityFacade")</sup> method was removed.
* The `OwnerUserGridListener::getSecurityContext`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/UserBundle/EventListener/OwnerUserGridListener.php#L137 "Oro\Bundle\UserBundle\EventListener\OwnerUserGridListener::getSecurityContext")</sup> method was removed.
* The `OrganizationUsersHandler::addSearchCriteria`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/UserBundle/Autocomplete/OrganizationUsersHandler.php#L63 "Oro\Bundle\UserBundle\Autocomplete\OrganizationUsersHandler::addSearchCriteria")</sup> method was removed.
* The `UserAclHandler::getSecurityContext`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/UserBundle/Autocomplete/UserAclHandler.php#L358 "Oro\Bundle\UserBundle\Autocomplete\UserAclHandler::getSecurityContext")</sup> method was removed.
* The `UsersEnableSwitchActionHandler::finishBatch(EntityManager $em)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/UserBundle/Datagrid/Extension/MassAction/UsersEnableSwitchActionHandler.php#L130 "Oro\Bundle\UserBundle\Datagrid\Extension\MassAction\UsersEnableSwitchActionHandler")</sup> method was changed to `UsersEnableSwitchActionHandler::finishBatch(EntityManager $em, $processedEntities)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/UserBundle/Datagrid/Extension/MassAction/UsersEnableSwitchActionHandler.php#L132 "Oro\Bundle\UserBundle\Datagrid\Extension\MassAction\UsersEnableSwitchActionHandler")</sup>

WorkflowBundle
--------------
* The `WorkflowFilter`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/WorkflowBundle/Filter/WorkflowFilter.php#L17 "Oro\Bundle\WorkflowBundle\Filter\WorkflowFilter")</sup> class was removed.
* The following methods in class `TransitionAssembler`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/WorkflowBundle/Model/TransitionAssembler.php#L128 "Oro\Bundle\WorkflowBundle\Model\TransitionAssembler")</sup> were removed:
   - `parseVariableDefinitions::parseVariableDefinitions`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/WorkflowBundle/Model/TransitionAssembler.php#L128 "Oro\Bundle\WorkflowBundle\Model\TransitionAssembler::parseVariableDefinitions")</sup>
   - `assignVariableValues::assignVariableValues`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/WorkflowBundle/Model/TransitionAssembler.php#L347 "Oro\Bundle\WorkflowBundle\Model\TransitionAssembler::assignVariableValues")</sup>
* The following methods in class `WorkflowRegistry`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/WorkflowBundle/Model/WorkflowRegistry.php#L222 "Oro\Bundle\WorkflowBundle\Model\WorkflowRegistry")</sup> were removed:
   - `getEntityManager::getEntityManager`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/WorkflowBundle/Model/WorkflowRegistry.php#L222 "Oro\Bundle\WorkflowBundle\Model\WorkflowRegistry::getEntityManager")</sup>
   - `getEntityRepository::getEntityRepository`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/WorkflowBundle/Model/WorkflowRegistry.php#L230 "Oro\Bundle\WorkflowBundle\Model\WorkflowRegistry::getEntityRepository")</sup>
   - `refreshWorkflowDefinition::refreshWorkflowDefinition`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/WorkflowBundle/Model/WorkflowRegistry.php#L255 "Oro\Bundle\WorkflowBundle\Model\WorkflowRegistry::refreshWorkflowDefinition")</sup>
* The following methods in class `WorkflowConfigurationProvider`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/WorkflowBundle/Configuration/WorkflowConfigurationProvider.php#L94 "Oro\Bundle\WorkflowBundle\Configuration\WorkflowConfigurationProvider")</sup> were removed:
   - `loadConfigFile::loadConfigFile`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/WorkflowBundle/Configuration/WorkflowConfigurationProvider.php#L94 "Oro\Bundle\WorkflowBundle\Configuration\WorkflowConfigurationProvider::loadConfigFile")</sup>
   - `processImports::processImports`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/WorkflowBundle/Configuration/WorkflowConfigurationProvider.php#L119 "Oro\Bundle\WorkflowBundle\Configuration\WorkflowConfigurationProvider::processImports")</sup>
   - `applyWorkflowImports::applyWorkflowImports`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/WorkflowBundle/Configuration/WorkflowConfigurationProvider.php#L181 "Oro\Bundle\WorkflowBundle\Configuration\WorkflowConfigurationProvider::applyWorkflowImports")</sup>
   - `getConfigFilePattern::getConfigFilePattern`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/WorkflowBundle/Configuration/WorkflowConfigurationProvider.php#L278 "Oro\Bundle\WorkflowBundle\Configuration\WorkflowConfigurationProvider::getConfigFilePattern")</sup>
* The `VariableGuesser::setVariableFormOptions(Variable $variable, $formOptions)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/WorkflowBundle/Model/VariableGuesser.php#L46 "Oro\Bundle\WorkflowBundle\Model\VariableGuesser")</sup> method was changed to `VariableGuesser::setVariableFormOptions(Variable $variable, array $formOptions)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/WorkflowBundle/Model/VariableGuesser.php#L73 "Oro\Bundle\WorkflowBundle\Model\VariableGuesser")</sup>
* The `ProcessTriggerExtension::createJobs()`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/WorkflowBundle/EventListener/Extension/ProcessTriggerExtension.php#L237 "Oro\Bundle\WorkflowBundle\EventListener\Extension\ProcessTriggerExtension")</sup> method was changed to `ProcessTriggerExtension::createJobs(array $queuedJobs)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/WorkflowBundle/EventListener/Extension/ProcessTriggerExtension.php#L240 "Oro\Bundle\WorkflowBundle\EventListener\Extension\ProcessTriggerExtension")</sup>
* The `WorkflowRegistry::__construct(ManagerRegistry $managerRegistry, WorkflowAssembler $workflowAssembler, WorkflowDefinitionFilters $definitionFilters)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/WorkflowBundle/Model/WorkflowRegistry.php#L35 "Oro\Bundle\WorkflowBundle\Model\WorkflowRegistry")</sup> method was changed to `WorkflowRegistry::__construct(WorkflowDefinitionProvider $definitionProvider, WorkflowAssembler $workflowAssembler, WorkflowDefinitionFilters $definitionFilters)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/WorkflowBundle/Model/WorkflowRegistry.php#L29 "Oro\Bundle\WorkflowBundle\Model\WorkflowRegistry")</sup>
* The `IsGrantedWorkflowTransition::__construct(SecurityFacade $securityFacade)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/WorkflowBundle/Model/Condition/IsGrantedWorkflowTransition.php#L40 "Oro\Bundle\WorkflowBundle\Model\Condition\IsGrantedWorkflowTransition")</sup> method was changed to `IsGrantedWorkflowTransition::__construct(AuthorizationCheckerInterface $authorizationChecker, TokenAccessorInterface $tokenAccessor)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/WorkflowBundle/Model/Condition/IsGrantedWorkflowTransition.php#L45 "Oro\Bundle\WorkflowBundle\Model\Condition\IsGrantedWorkflowTransition")</sup>
* The `WorkflowDataHelper::__construct(WorkflowManager $workflowManager, SecurityFacade $securityFacade, TranslatorInterface $translator, UrlGeneratorInterface $router)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/WorkflowBundle/Helper/WorkflowDataHelper.php#L41 "Oro\Bundle\WorkflowBundle\Helper\WorkflowDataHelper")</sup> method was changed to `WorkflowDataHelper::__construct(WorkflowManager $workflowManager, AuthorizationCheckerInterface $authorizationChecker, TranslatorInterface $translator, UrlGeneratorInterface $router)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/WorkflowBundle/Helper/WorkflowDataHelper.php#L41 "Oro\Bundle\WorkflowBundle\Helper\WorkflowDataHelper")</sup>
* The `ActionPermissionProvider::__construct(FeatureChecker $featureChecker)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/WorkflowBundle/Datagrid/ActionPermissionProvider.php#L19 "Oro\Bundle\WorkflowBundle\Datagrid\ActionPermissionProvider")</sup> method was changed to `ActionPermissionProvider::__construct(FeatureChecker $featureChecker, ConfigurationChecker $configurationChecker)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/WorkflowBundle/Datagrid/ActionPermissionProvider.php#L22 "Oro\Bundle\WorkflowBundle\Datagrid\ActionPermissionProvider")</sup>
* The `WorkflowConfigurationProvider::__construct(array $kernelBundles, WorkflowListConfiguration $configuration)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/WorkflowBundle/Configuration/WorkflowConfigurationProvider.php#L36 "Oro\Bundle\WorkflowBundle\Configuration\WorkflowConfigurationProvider")</sup> method was changed to `WorkflowConfigurationProvider::__construct(WorkflowListConfiguration $configuration, WorkflowConfigFinderBuilder $finderBuilder, ConfigFileReaderInterface $reader, WorkflowConfigurationImportsProcessor $configurationImportsProcessor)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/WorkflowBundle/Configuration/WorkflowConfigurationProvider.php#L29 "Oro\Bundle\WorkflowBundle\Configuration\WorkflowConfigurationProvider")</sup>
* The `AbstractWorkflowAclExtension::__construct(ObjectIdAccessor $objectIdAccessor, MetadataProviderInterface $metadataProvider, EntityOwnerAccessor $entityOwnerAccessor, AccessLevelOwnershipDecisionMakerInterface $decisionMaker, WorkflowManager $workflowManager)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/WorkflowBundle/Acl/Extension/AbstractWorkflowAclExtension.php#L28 "Oro\Bundle\WorkflowBundle\Acl\Extension\AbstractWorkflowAclExtension")</sup> method was changed to `AbstractWorkflowAclExtension::__construct(ObjectIdAccessor $objectIdAccessor, OwnershipMetadataProviderInterface $metadataProvider, EntityOwnerAccessor $entityOwnerAccessor, AccessLevelOwnershipDecisionMakerInterface $decisionMaker, WorkflowManager $workflowManager)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/WorkflowBundle/Acl/Extension/AbstractWorkflowAclExtension.php#L28 "Oro\Bundle\WorkflowBundle\Acl\Extension\AbstractWorkflowAclExtension")</sup>
* The `WorkflowAclExtension::__construct(ObjectIdAccessor $objectIdAccessor, MetadataProviderInterface $metadataProvider, EntityOwnerAccessor $entityOwnerAccessor, AccessLevelOwnershipDecisionMakerInterface $decisionMaker, WorkflowManager $workflowManager, WorkflowAclMetadataProvider $workflowMetadataProvider, WorkflowTransitionAclExtension $transitionAclExtension)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/WorkflowBundle/Acl/Extension/WorkflowAclExtension.php#L39 "Oro\Bundle\WorkflowBundle\Acl\Extension\WorkflowAclExtension")</sup> method was changed to `WorkflowAclExtension::__construct(ObjectIdAccessor $objectIdAccessor, OwnershipMetadataProviderInterface $metadataProvider, EntityOwnerAccessor $entityOwnerAccessor, AccessLevelOwnershipDecisionMakerInterface $decisionMaker, WorkflowManager $workflowManager, WorkflowAclMetadataProvider $workflowMetadataProvider, WorkflowTransitionAclExtension $transitionAclExtension)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/WorkflowBundle/Acl/Extension/WorkflowAclExtension.php#L39 "Oro\Bundle\WorkflowBundle\Acl\Extension\WorkflowAclExtension")</sup>
* The `WorkflowTransitionAclExtension::__construct(ObjectIdAccessor $objectIdAccessor, MetadataProviderInterface $metadataProvider, EntityOwnerAccessor $entityOwnerAccessor, AccessLevelOwnershipDecisionMakerInterface $decisionMaker, WorkflowManager $workflowManager)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/WorkflowBundle/Acl/Extension/WorkflowTransitionAclExtension.php#L27 "Oro\Bundle\WorkflowBundle\Acl\Extension\WorkflowTransitionAclExtension")</sup> method was changed to `WorkflowTransitionAclExtension::__construct(ObjectIdAccessor $objectIdAccessor, OwnershipMetadataProviderInterface $metadataProvider, EntityOwnerAccessor $entityOwnerAccessor, AccessLevelOwnershipDecisionMakerInterface $decisionMaker, WorkflowManager $workflowManager)`<sup>[[?]](https://github.com/oroinc/platform/tree/2.3.0/src/Oro/Bundle/WorkflowBundle/Acl/Extension/WorkflowTransitionAclExtension.php#L27 "Oro\Bundle\WorkflowBundle\Acl\Extension\WorkflowTransitionAclExtension")</sup>
* The `WorkflowRegistry::$managerRegistry`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/WorkflowBundle/Model/WorkflowRegistry.php#L19 "Oro\Bundle\WorkflowBundle\Model\WorkflowRegistry::$managerRegistry")</sup> property was removed.
* The `IsGrantedWorkflowTransition::$securityFacade`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/WorkflowBundle/Model/Condition/IsGrantedWorkflowTransition.php#L29 "Oro\Bundle\WorkflowBundle\Model\Condition\IsGrantedWorkflowTransition::$securityFacade")</sup> property was removed.
* The `WorkflowDataHelper::$securityFacade`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/WorkflowBundle/Helper/WorkflowDataHelper.php#L27 "Oro\Bundle\WorkflowBundle\Helper\WorkflowDataHelper::$securityFacade")</sup> property was removed.
* The `ProcessTriggerExtension::$queuedJobs`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/WorkflowBundle/EventListener/Extension/ProcessTriggerExtension.php#L44 "Oro\Bundle\WorkflowBundle\EventListener\Extension\ProcessTriggerExtension::$queuedJobs")</sup> property was removed.
* The following properties in class `WorkflowConfigurationProvider`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/WorkflowBundle/Configuration/WorkflowConfigurationProvider.php#L15 "Oro\Bundle\WorkflowBundle\Configuration\WorkflowConfigurationProvider")</sup> were removed:
   - `$configFilePattern::$configFilePattern`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/WorkflowBundle/Configuration/WorkflowConfigurationProvider.php#L15 "Oro\Bundle\WorkflowBundle\Configuration\WorkflowConfigurationProvider::$configFilePattern")</sup>
   - `$loadedRawConfigs::$loadedRawConfigs`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/WorkflowBundle/Configuration/WorkflowConfigurationProvider.php#L25 "Oro\Bundle\WorkflowBundle\Configuration\WorkflowConfigurationProvider::$loadedRawConfigs")</sup>
   - `$importWorkflowsInProgress::$importWorkflowsInProgress`<sup>[[?]](https://github.com/oroinc/platform/tree/2.2.0/src/Oro/Bundle/WorkflowBundle/Configuration/WorkflowConfigurationProvider.php#L30 "Oro\Bundle\WorkflowBundle\Configuration\WorkflowConfigurationProvider::$importWorkflowsInProgress")</sup>

